# StochasticDiffEq.jl

[![Join the chat at https://julialang.zulipchat.com #sciml-bridged](https://img.shields.io/static/v1?label=Zulip&message=chat&color=9558b2&labelColor=389826)](https://julialang.zulipchat.com/#narrow/stream/279055-sciml-bridged)
[![Global Docs](https://img.shields.io/badge/docs-SciML-blue.svg)](https://docs.sciml.ai/DiffEqDocs/stable/solvers/sde_solve/)

[![ColPrac: Contributor's Guide on Collaborative Practices for Community Packages](https://img.shields.io/badge/ColPrac-Contributor%27s%20Guide-blueviolet)](https://github.com/SciML/ColPrac)
[![SciML Code Style](https://img.shields.io/static/v1?label=code%20style&message=SciML&color=9558b2&labelColor=389826)](https://github.com/SciML/SciMLStyle)

StochasticDiffEq.jl is a component package in the DifferentialEquations ecosystem. It holds the stochastic differential equation solvers and utilities. While completely independent and usable on its own, users interested in using this functionality should check out [DifferentialEquations.jl](https://github.com/SciML/DifferentialEquations.jl).

This is an umbrella package that re-exports all SDE solver subpackages from the [OrdinaryDiffEq.jl](https://github.com/SciML/OrdinaryDiffEq.jl) monorepo.

## Installation

```julia
import Pkg;
Pkg.add("StochasticDiffEq");
```

## API

StochasticDiffEq.jl is part of the SciML common interface, but can be used independently of DifferentialEquations.jl. The only requirement is that the user passes a StochasticDiffEq.jl algorithm to `solve`. For example:

```julia
using StochasticDiffEq
f(u, p, t) = 1.01 * u
g(u, p, t) = 0.87 * u
u0 = 0.5
tspan = (0.0, 1.0)
prob = SDEProblem(f, g, u0, tspan)
sol = solve(prob, SOSRI())
```

The in-place syntax (more efficient for systems of equations):

```julia
using StochasticDiffEq
function f!(du, u, p, t)
    du[1] = 10.0 * (u[2] - u[1])
    du[2] = u[1] * (28.0 - u[3]) - u[2]
    du[3] = u[1] * u[2] - (8 / 3) * u[3]
end
function g!(du, u, p, t)
    du[1] = 0.3 * u[1]
    du[2] = 0.3 * u[2]
    du[3] = 0.3 * u[3]
end
u0 = [1.0; 0.0; 0.0]
tspan = (0.0, 100.0)
prob = SDEProblem(f!, g!, u0, tspan)
sol = solve(prob, SOSRI())
```

## Subpackages

For more targeted dependencies, you can use individual solver subpackages:

| Package | Solvers |
|---------|---------|
| StochasticDiffEqLowOrder | EM, EulerHeun, LambaEM, LambaEulerHeun, SimplifiedEM, SplitEM, RKMil, RKMilCommute, PCEuler |
| StochasticDiffEqHighOrder | SRI, SRIW1, SRIW2, SOSRI, SOSRI2, SRA, SRA1, SRA2, SRA3, SOSRA, SOSRA2 |
| StochasticDiffEqMilstein | RKMilGeneral, WangLi3SMil_A-F |
| StochasticDiffEqROCK | SROCK1, SROCK2, KomBurSROCK2, SROCKC2, SROCKEM, SKSROCK, TangXiaoSROCK2 |
| StochasticDiffEqImplicit | ImplicitEM, ImplicitEulerHeun, ImplicitRKMil, STrapezoid, SImplicitMidpoint, ISSEM, ISSEulerHeun, SKenCarp |
| StochasticDiffEqWeak | DRI1, RI1, RI3, RI5, RI6, RDI1WM-RDI4WM, W2Ito1, RS1, RS2, PL1WM, NON, COM, IRI1, and more |
| StochasticDiffEqIIF | IIF1M, IIF2M, IIF1Mil |
| StochasticDiffEqLeaping | TauLeaping, CaoTauLeaping, ImplicitTauLeaping, ThetaTrapezoidalTauLeaping |
| StochasticDiffEqRODE | RandomEM, RandomHeun, RandomTamedEM, BAOAB |

## Available Solvers

For the full list of available solvers, refer to the [DifferentialEquations.jl SDE Solvers](https://docs.sciml.ai/DiffEqDocs/stable/solvers/sde_solve/), [RODE Solvers](https://docs.sciml.ai/DiffEqDocs/stable/solvers/rode_solve/), and [Jump Solvers](https://docs.sciml.ai/DiffEqDocs/stable/solvers/jump_solve/) pages.

using StochasticDiffEq, DiffEqDevTools, Test, LinearAlgebra, Random

u0 = ones(2)
A = [
    -3 / 2 1 / 20
    1 / 20 -3 / 2
]
B = [
    1 / 5 1 / 100
    1 / 100 1 / 5
]

function f(du, u, p, t)
    return mul!(du, A, u)
end
function σ(du, u, p, t)
    mul!(@view(du[:, 1]), B, u)
    return mul!(@view(du[:, 2]), B, u)
end

function f_analytic(u0, p, t, W)
    tmp = (A - (B^2)) * t + B * W[1] + B * W[2]
    return exp(tmp) * u0
end

prob2 = SDEProblem(SDEFunction(f, σ, analytic = f_analytic), u0, (0.0, 1.0), noise_rate_prototype = rand(2, 2))

sol2 = solve(prob2, EM(), dt = 1 / 100)

dts = 1 ./ 2 .^ (14:-1:7)

println("First Test")
Random.seed!(100)
sim = test_convergence(dts, prob2, EM(), trajectories = 150)
@test abs(sim.𝒪est[:l2] - 0.5) < 0.1

# using Plots; plot(sim)

u0 = rand(2)
A = [2.0 -1.0; -1.0 2.0]
B = [
    1 / 5 1 / 100
    1 / 100 1 / 5
]

function f_iip(du, u, p, t)
    mul!(du, A, u)
    return du .+= 1.01u
end
function σ_iip(du, u, p, t)
    mul!(@view(du[:, 1]), B, u)
    return mul!(@view(du[:, 2]), B, u)
end

function f_analytic_iip(u0, p, t, W)
    tmp = (A + 1.01I - (B^2)) * t + B * sum(W)
    return exp(tmp) * u0
end

prob2 = SDEProblem(
    SDEFunction(f_iip, σ_iip, analytic = f_analytic_iip),
    u0, (0.0, 1.0), noise_rate_prototype = rand(2, 2)
)

sol2 = solve(prob2, EM(), dt = 1 / 100)

dts = 1 ./ 2 .^ (14:-1:7)

println("Second Test")
Random.seed!(100)
sim = test_convergence(dts, prob2, EM(), trajectories = 50)
# Superconvergence
@test abs(sim.𝒪est[:l2] - 1.0) < 0.1

# using Plots; plot(sim)

using StochasticDiffEq, Test, Random
using SDEProblemLibrary: prob_sde_linear, prob_sde_2Dlinear
Random.seed!(100)
prob = prob_sde_linear
f(u, p, t) = 2u
prob = SDEProblem{false}(f, prob.f, prob.u0, prob.tspan)
sol = solve(prob, EM(), dt = 1 // 2^(4), saveat = 0.33)

sol.t == [0.0, 0.33, 0.33 + 0.33, 1]

sol = solve(prob, EM(), dt = 1 // 2^(4), saveat = 0.33, save_start = false)

sol.t == [0.33, 0.33 + 0.33, 1]
sol(0.4)

sol = solve(
    prob, EM(), dt = 1 // 2^(4), saveat = 0.33, save_start = false, save_everystep = true
)

@test 0.33 ∈ sol.t
@test 0.66 ∈ sol.t
sol.t != [0.33, 0.33 + 0.33, 1]

prob = prob_sde_2Dlinear
f(du, u, p, t) = prob.f(du, u, p, t)
prob2 = SDEProblem(f, prob.g, vec(prob.u0), prob.tspan)
Random.seed!(200)
sol = solve(
    prob2, EM(), dt = 1 // 2^(4), saveat = 0.33, save_start = false, save_everystep = true
)
Random.seed!(200)
sol2 = solve(
    prob2, EM(), dt = 1 // 2^(4), saveat = 0.33,
    save_start = false, save_everystep = true, save_idxs = 1:2:5
)

@test sol(0.43)[1:2:5] == sol2(0.43)

# Test save_on switch
sol = solve(
    prob2, EM(), dt = 1 // 2^(4), save_on = false, save_start = false, save_end = false
)
@test isempty(sol.t) && isempty(sol.u)
sol = solve(
    prob2, EM(), dt = 1 // 2^(4), saveat = 0.33,
    save_on = false, save_start = false, save_end = false
)
@test isempty(sol.t) && isempty(sol.u)

_saveat = [0.0, 0.25, 0.5, 1.0]
integ = init(SDEProblem((u, p, t) -> u, (u, p, t) -> u, 0.0, (0.0, 1.0)), SOSRI(), saveat = _saveat)
add_tstop!(integ, 2.0)
solve!(integ)
@test integ.sol.t == _saveat

integ = init(
    SDEProblem((u, p, t) -> u, (u, p, t) -> u, 0.0, (0.0, 1.0)), SOSRI(), saveat = _saveat, save_end = true
)
add_tstop!(integ, 2.0)
solve!(integ)
@test integ.sol.t == [0.0, 0.25, 0.5, 1.0, 2.0]

integ = init(
    SDEProblem((u, p, t) -> u, (u, p, t) -> u, 0.0, (0.0, 1.0)), SOSRI(), saveat = _saveat, save_end = false
)
add_tstop!(integ, 2.0)
solve!(integ)
@test integ.sol.t == _saveat

# Catch save for maxiters
ode = SDEProblem((u, p, t) -> u, (u, p, t) -> u, 1.0, (0.0, 1.0))
sol = solve(ode, SOSRI(), save_everystep = false) # okay, as expected
@test length(sol) == 2
@info "Warning Expected"
sol = solve(ode, SOSRI(), save_everystep = false, maxiters = 3) # doesn't save the final solution anymore!
@test length(sol) == 2

# Default algorithm selection for SDEs
# Moved from DifferentialEquations.jl as part of modularization effort

using LinearAlgebra: I

# Helper function to extract alg_hints from keyword arguments
function get_alg_hints(o)
    return :alg_hints ∈ keys(o) ? alg_hints = o[:alg_hints] : alg_hints = Symbol[:auto]
end

function default_algorithm(
        prob::DiffEqBase.AbstractSDEProblem{uType, tType, isinplace, ND};
        kwargs...
    ) where {uType, tType, isinplace, ND}
    o = Dict{Symbol, Any}(kwargs)
    alg = SOSRI() # Standard default

    alg_hints = get_alg_hints(o)

    if :commutative ∈ alg_hints
        alg = RKMilCommute()
    end

    is_stiff = :stiff ∈ alg_hints
    is_stratonovich = :stratonovich ∈ alg_hints
    if is_stiff || prob.f.mass_matrix !== I
        alg = ImplicitRKMil(autodiff = false)
    end

    if is_stratonovich
        if is_stiff || prob.f.mass_matrix !== I
            alg = ImplicitRKMil(
                autodiff = false,
                interpretation = SciMLBase.AlgorithmInterpretation.Stratonovich
            )
        else
            alg = RKMil(interpretation = SciMLBase.AlgorithmInterpretation.Stratonovich)
        end
    end

    if prob.noise_rate_prototype != nothing || prob.noise != nothing
        if is_stratonovich
            if is_stiff || prob.f.mass_matrix !== I
                alg = ImplicitEulerHeun(autodiff = false)
            else
                alg = LambaEulerHeun()
            end
        else
            if is_stiff || prob.f.mass_matrix !== I
                alg = ISSEM(autodiff = false)
            else
                alg = LambaEM()
            end
        end
    end

    if :additive ∈ alg_hints
        if is_stiff || prob.f.mass_matrix !== I
            alg = SKenCarp(autodiff = false)
        else
            alg = SOSRA()
        end
    end

    return alg
end

SciMLBase.supports_solve_rng(::SciMLBase.AbstractSDEProblem, ::Nothing) = true

# Dispatch for __init with Nothing algorithm - use default
function DiffEqBase.__init(
        prob::DiffEqBase.AbstractSDEProblem, ::Nothing, args...; kwargs...
    )
    alg = default_algorithm(prob; kwargs...)
    return DiffEqBase.__init(prob, alg, args...; kwargs...)
end

# Dispatch for __solve with Nothing algorithm - use default
function DiffEqBase.__solve(
        prob::DiffEqBase.AbstractSDEProblem, ::Nothing, args...; kwargs...
    )
    alg = default_algorithm(prob; kwargs...)
    return DiffEqBase.__solve(prob, alg, args...; kwargs...)
end

using StochasticDiffEq, DiffEqDevTools, LinearAlgebra, Random, Test
Random.seed!(100)
dts = (1 / 2) .^ (10:-1:2) #14->7 good plot

const σ_const = 0.87
const μ = 1.01

u0 = rand(2)
A = [-2.0 1.0; 1.0 -2.0]
B = Diagonal([σ_const for i in 1:2])

function f_commute(du, u, p, t)
    mul!(du, A, u)
    return du .+= 1.01u
end

function f_commute_oop(u, p, t)
    du = A * u
    return du += 1.01u
end

function f_commute_analytic(u0, p, t, W)
    tmp = (A + 1.01I - 2 * (B^2)) * t + B * sum(W)
    return exp(tmp) * u0
end

function σ(du, u, p, t)
    du[1, 1] = σ_const * u[1]
    du[2, 1] = σ_const * u[2]
    du[1, 2] = σ_const * u[1]
    du[2, 2] = σ_const * u[2]
    du[1, 3] = σ_const * u[1]
    du[2, 3] = σ_const * u[2]
    du[1, 4] = σ_const * u[1]
    return du[2, 4] = σ_const * u[2]
end

function σ_oop(u, p, t)
    return σ_const * [
        u[1] u[1] u[1] u[1]
        u[2] u[2] u[2] u[2]
    ]
end

ff_commute = SDEFunction(f_commute, σ, analytic = f_commute_analytic)

prob = SDEProblem(ff_commute, u0, (0.0, 1.0), noise_rate_prototype = rand(2, 4))

sol = solve(prob, RKMilCommute(), dt = 1 / 2^(8))
sol = solve(prob, RKMilGeneral(ii_approx = IICommutative()), dt = 1 / 2^(8))
sol = solve(prob, RKMilGeneral(p = 2), dt = 1 / 2^(10))
sol = solve(prob, EM(), dt = 1 / 2^(10))

dts = (1 / 2) .^ (10:-1:3) #14->7 good plot
sim2 = test_convergence(dts, prob, EM(), trajectories = Int(1.0e2))
@test abs(sim2.𝒪est[:final] - 0.5) < 0.2

sim2 = test_convergence(dts, prob, RKMilCommute(), trajectories = Int(2.0e2))
@test abs(sim2.𝒪est[:final] - 1.0) < 0.2

sim2 = test_convergence(dts, prob, RKMilGeneral(ii_approx = IICommutative()), trajectories = Int(2.0e2))
@test abs(sim2.𝒪est[:final] - 1.0) < 0.2

sim2 = test_convergence(dts, prob, RKMilGeneral(p = 2), trajectories = Int(2.0e2))
@test abs(sim2.𝒪est[:final] - 1.0) < 0.2

ff_commute_oop = SDEFunction(f_commute_oop, σ_oop, analytic = f_commute_analytic)

proboop = SDEProblem(ff_commute_oop, u0, (0.0, 1.0), noise_rate_prototype = rand(2, 4))

sol = solve(proboop, RKMilCommute(), dt = 1 / 2^(8))
sol = solve(proboop, RKMilGeneral(ii_approx = IICommutative()), dt = 1 / 2^(8))
sol = solve(proboop, RKMilGeneral(p = 2), dt = 1 / 2^(10))
sol = solve(proboop, EM(), dt = 1 / 2^(10))

dts = (1 / 2) .^ (10:-1:3) #14->7 good plot
sim2 = test_convergence(dts, proboop, EM(), trajectories = Int(1.0e3))
@test abs(sim2.𝒪est[:final] - 0.5) < 0.2

sim2 = test_convergence(dts, proboop, RKMilCommute(), trajectories = Int(2.0e2))
@test abs(sim2.𝒪est[:final] - 1.0) < 0.2

sim2 = test_convergence(dts, proboop, RKMilGeneral(ii_approx = IICommutative()), trajectories = Int(2.0e2))
@test abs(sim2.𝒪est[:final] - 1.0) < 0.2

sim2 = test_convergence(dts, proboop, RKMilGeneral(p = 2), trajectories = Int(2.0e2))
@test abs(sim2.𝒪est[:final] - 1.0) < 0.2

using StochasticDiffEq, DiffEqDevTools, Test

linear = (u, p, t) -> (p * u)
g = (u, p, t) -> zero(u)
linear_analytic = (u0, p, t, W) -> u0 * exp(p * t)
prob = SDEProblem(
    SDEFunction(linear, g, analytic = linear_analytic),
    1 / 2, (0.0, 1.0), 1.01
)

dts = (1 / 2) .^ (7:-1:4) #14->7 good plot
sol = solve(prob, SKenCarp())
sim2 = test_convergence(dts, prob, SKenCarp(), trajectories = 20)
@test abs(sim2.𝒪est[:l∞] - 3) < 0.1 #High tolerance since low dts for testing!

linear = (du, u, p, t) -> (du .= p .* u)
g = (du, u, p, t) -> (du .= 0)
linear_analytic = (u0, p, t, W) -> u0 * exp.(p .* t)
prob = SDEProblem(
    SDEFunction(linear, g, analytic = linear_analytic),
    rand(4, 2), (0.0, 1.0), 1.01
)

dts = (1 / 2) .^ (7:-1:4) #14->7 good plot
sol = solve(prob, SKenCarp())
sim2 = test_convergence(dts, prob, SKenCarp(), trajectories = 20)
@test abs(sim2.𝒪est[:l∞] - 3) < 0.1 #High tolerance since low dts for testing!

# Stochastic Runge Kutta for the weak approximation (deterministic order tests)
linear = (u, p, t) -> (p * u)
g = (u, p, t) -> zero(u)
linear_analytic = (u0, p, t, W) -> u0 * exp(p * t)
prob = SDEProblem(SDEFunction(linear, g, analytic = linear_analytic), 1 / 2, (0.0, 1.0), 1.01)
dts = 1 .// 2 .^ (10:-1:2)

sim2 = test_convergence(dts, prob, DRI1(), trajectories = 20)
@test abs(sim2.𝒪est[:l∞] - 3) < 0.1
sim2 = test_convergence(dts, prob, RI1(), trajectories = 20)
@test abs(sim2.𝒪est[:l∞] - 3) < 0.1
sim2 = test_convergence(dts, prob, RI3(), trajectories = 20)
@test abs(sim2.𝒪est[:l∞] - 3) < 0.1
sim2 = test_convergence(dts, prob, RI5(), trajectories = 20)
@test abs(sim2.𝒪est[:l∞] - 3) < 0.1
sim2 = test_convergence(dts, prob, RI6(), trajectories = 20)
@test abs(sim2.𝒪est[:l∞] - 2) < 0.1

sim2 = test_convergence(dts, prob, RDI1WM(), trajectories = 20)
@test abs(sim2.𝒪est[:l∞] - 2) < 0.1
sim2 = test_convergence(dts, prob, RDI2WM(), trajectories = 20)
@test abs(sim2.𝒪est[:l∞] - 2) < 0.1
sim2 = test_convergence(dts, prob, RDI3WM(), trajectories = 20)
@test abs(sim2.𝒪est[:l∞] - 3) < 0.1
sim2 = test_convergence(dts, prob, RDI4WM(), trajectories = 20)
@test abs(sim2.𝒪est[:l∞] - 3) < 0.1

sim2 = test_convergence(dts, prob, W2Ito1(), trajectories = 20)
@test abs(sim2.𝒪est[:l∞] - 3) < 0.1

sim2 = test_convergence(dts, prob, RS1(), trajectories = 20)
@test abs(sim2.𝒪est[:l∞] - 2) < 0.1
sim2 = test_convergence(dts, prob, RS2(), trajectories = 20)
@test abs(sim2.𝒪est[:l∞] - 3) < 0.1

sim2 = test_convergence(dts, prob, NON(), trajectories = 20)
@test abs(sim2.𝒪est[:l∞] - 4) < 0.1

using StochasticDiffEq, Test, Random, DiffEqDevTools
using SDEProblemLibrary: prob_sde_linear_stratonovich, prob_sde_2Dlinear_stratonovich
import SciMLBase

Random.seed!(100)
dts = 1 ./ 2 .^ (10:-1:2) #14->7 good plot

prob = prob_sde_linear_stratonovich
sim = test_convergence(dts, prob, EulerHeun(), trajectories = Int(5.0e2))
@test abs(sim.𝒪est[:l2] - 1) < 0.1

sim = test_convergence(dts, prob, LambaEulerHeun(), trajectories = Int(5.0e2))
@test abs(sim.𝒪est[:l2] - 1) < 0.1

sim = test_convergence(dts, prob, ISSEulerHeun(), trajectories = Int(5.0e2))
@test abs(sim.𝒪est[:l2] - 1) < 0.1

sim = test_convergence(dts, prob, ImplicitEulerHeun(), trajectories = Int(5.0e2))
@test abs(sim.𝒪est[:l2] - 1) < 0.1

sim = test_convergence(dts, prob, ImplicitEulerHeun(theta = 1), trajectories = Int(5.0e2))
@test abs(sim.𝒪est[:l2] - 1) < 0.1

sim = test_convergence(dts, prob, ImplicitEulerHeun(symplectic = true), trajectories = Int(5.0e2))
@test abs(sim.𝒪est[:l2] - 1) < 0.1

sim = test_convergence(
    dts, prob, RKMil(interpretation = SciMLBase.AlgorithmInterpretation.Stratonovich),
    trajectories = Int(5.0e2)
)
@test abs(sim.𝒪est[:l2] - 1) < 0.2

sim = test_convergence(
    dts, prob,
    RKMilGeneral(interpretation = SciMLBase.AlgorithmInterpretation.Stratonovich),
    trajectories = Int(5.0e2)
)
@test abs(sim.𝒪est[:l2] - 1) < 0.2

sim = test_convergence(
    dts, prob,
    ImplicitRKMil(interpretation = SciMLBase.AlgorithmInterpretation.Stratonovich),
    trajectories = Int(5.0e2)
)
@test abs(sim.𝒪est[:l2] - 1) < 0.1

sim = test_convergence(
    dts, prob, SROCK1(interpretation = SciMLBase.AlgorithmInterpretation.Stratonovich),
    trajectories = Int(2.0e2)
)
@test abs(sim.𝒪est[:l2] - 1) < 0.15

sim = test_convergence(dts, prob, KomBurSROCK2(), trajectories = Int(2.0e2))
@test abs(sim.𝒪est[:final] - 2) < 0.2

println("Now 2D")

prob = prob_sde_2Dlinear_stratonovich

sim = test_convergence(dts, prob, EulerHeun(), trajectories = Int(5.0e1))
@test abs(sim.𝒪est[:l2] - 1) < 0.1

sim = test_convergence(dts, prob, LambaEulerHeun(), trajectories = Int(5.0e1))
@test abs(sim.𝒪est[:l2] - 1) < 0.1

sim = test_convergence(dts, prob, ISSEulerHeun(), trajectories = Int(5.0e1))
@test abs(sim.𝒪est[:l2] - 1) < 0.1

sim = test_convergence(dts, prob, ImplicitEulerHeun(), trajectories = Int(5.0e1))
@test abs(sim.𝒪est[:l2] - 1) < 0.1

sim = test_convergence(dts, prob, ImplicitEulerHeun(theta = 1), trajectories = Int(5.0e1))
@test abs(sim.𝒪est[:l2] - 1) < 0.1

sim = test_convergence(dts, prob, ImplicitEulerHeun(symplectic = true), trajectories = Int(5.0e1))
@test abs(sim.𝒪est[:l2] - 1) < 0.1

println("RKMils")

sim = test_convergence(
    dts, prob, RKMil(interpretation = SciMLBase.AlgorithmInterpretation.Stratonovich),
    trajectories = Int(1.0e2)
)
@test abs(sim.𝒪est[:l2] - 1) < 0.2

sim = test_convergence(
    dts, prob,
    RKMilGeneral(interpretation = SciMLBase.AlgorithmInterpretation.Stratonovich),
    trajectories = Int(1.0e2)
)
@test abs(sim.𝒪est[:l2] - 1) < 0.2

sim = test_convergence(
    dts, prob,
    ImplicitRKMil(interpretation = SciMLBase.AlgorithmInterpretation.Stratonovich),
    trajectories = Int(1.0e2)
)
@test abs(sim.𝒪est[:l2] - 1) < 0.1

sim = test_convergence(
    dts,
    prob,
    ImplicitRKMil(theta = 1, interpretation = SciMLBase.AlgorithmInterpretation.Stratonovich),
    trajectories = Int(1.0e2)
)
@test abs(sim.𝒪est[:l2] - 1) < 0.1

sim = test_convergence(
    dts,
    prob,
    ImplicitRKMil(symplectic = true, interpretation = SciMLBase.AlgorithmInterpretation.Stratonovich),
    trajectories = Int(1.0e2)
)
@test abs(sim.𝒪est[:l2] - 1) < 0.1

sim = test_convergence(
    dts, prob, SROCK1(interpretation = SciMLBase.AlgorithmInterpretation.Stratonovich),
    trajectories = Int(1.0e2)
)
@test abs(sim.𝒪est[:l2] - 1) < 0.1

sim = test_convergence(dts, prob, KomBurSROCK2(), trajectories = Int(2.0e2))
@test abs(sim.𝒪est[:final] - 2) < 0.2

Random.seed!(200)
sol = solve(prob, EulerHeun(), dt = 1 / 4)

using StochasticDiffEq, DiffEqDevTools, Test, Random
using SDEProblemLibrary: prob_sde_linear
Random.seed!(100)
prob = prob_sde_linear

## Solve and plot
println("Solve and Plot")
sol = solve(prob, EM(), dt = 1 // 2^(4))
sol = solve(prob, RKMil(), dt = 1 // 2^(4))
sol = solve(prob, RKMilCommute(), dt = 1 // 2^(4))
sol = solve(prob, RKMilGeneral(), dt = 1 // 2^(4))
sol = solve(prob, SRI(), dt = 1 // 2^(4))
sol = solve(prob, SRIW1(), dt = 1 // 2^(4))
trajectories = 100
## Convergence Testing
println("Convergence Test on Linear")
dts = (1 // 2) .^ (9:-1:4) #14->7 good plot with higher num Monte

sim = test_convergence(dts, prob, EM(), trajectories = trajectories)

sim2 = test_convergence(dts, prob, RKMil(), trajectories = trajectories)

sim21 = test_convergence(dts, prob, RKMilGeneral(), trajectories = trajectories)

sim22 = test_convergence(dts, prob, RKMilCommute(), trajectories = trajectories)

sim3 = test_convergence(dts, prob, SRI(), trajectories = trajectories)

#TEST_PLOT && plot(plot(sim),plot(sim2),plot(sim3),layout=@layout([a b c]),size=(1200,600))

@test abs(sim.𝒪est[:l2] - 0.5) + abs(sim2.𝒪est[:l∞] - 1) + abs(sim3.𝒪est[:final] - 1.5) < 0.441  #High tolerance since low dts for testing!

@test abs(sim.𝒪est[:l2] - 0.5) + abs(sim21.𝒪est[:l∞] - 1) + abs(sim3.𝒪est[:final] - 1.5) < 0.441  #High tolerance since low dts for testing!

@test abs(sim22.𝒪est[:l∞] - 1) < 0.3

# test reinit
integrator = init(prob, EM(), dt = 1 // 2^(4))
solve!(integrator)
reinit!(integrator)
solve!(integrator)

# test reinit
prob2 = SDEProblem((u, p, t) -> prob.f(u, p, t), prob.g, prob.u0, prob.tspan)
integrator = init(prob2, EM(), dt = 1 // 2^(4), tstops = [1 // 2], saveat = [1 // 3])
solve!(integrator)
reinit!(integrator)
solve!(integrator)

using StochasticDiffEq, Test

SRIW1_tab = constructSRIW1()
@test minimum(checkSRIOrder(SRIW1_tab))

SRA1_tab = constructSRA1()
@test minimum(checkSRAOrder(SRA1_tab))

DRI1_tab = constructDRI1()
@test minimum(checkRIOrder(DRI1_tab))

RI1_tab = constructRI1()
@test minimum(checkRIOrder(RI1_tab))

RI3_tab = constructRI3()
@test minimum(checkRIOrder(RI3_tab))

RI5_tab = constructRI5()
@test minimum(checkRIOrder(RI5_tab))

RI6_tab = constructRI6()
@test minimum(checkRIOrder(RI6_tab))

RDI1WM_tab = constructRDI1WM()
@test minimum(checkRIOrder(RDI1WM_tab, ps = 1))

RDI2WM_tab = constructRDI2WM()
@test minimum(checkRIOrder(RDI2WM_tab))

RDI3WM_tab = constructRDI3WM()
@test minimum(checkRIOrder(RDI3WM_tab))

RDI4WM_tab = constructRDI4WM()
@test minimum(checkRIOrder(RDI4WM_tab))

RS1_tab = constructRS1()
@test minimum(checkRSOrder(RS1_tab))

RS2_tab = constructRS2()
@test minimum(checkRSOrder(RS2_tab))

# Komori's NON
NON_tab = constructNON()
@test minimum(checkNONOrder(NON_tab))

NON2_tab = constructNON2()
@test minimum(checkNONOrder(NON2_tab))

using StochasticDiffEq, DiffEqNoiseProcess, Test, Random, LinearAlgebra
using StochasticDiffEqLevyArea, Statistics

seed = 113213898
Random.seed!(seed)

m = 10
W = WienerProcess(0.0, zeros(m), nothing)

dt = 0.1
calculate_step!(W, dt, nothing, nothing)

for i in 1:10
    accept_step!(W, dt, nothing, nothing)
end

# LevyArea.jl algs: ITER_INT_ALGS

@testset "diagonal noise tests" begin
    true_diag = 1 // 2 .* W.dW .* W.dW

    Jdiag = StochasticDiffEq.JDiagonal_iip(W.dW)
    StochasticDiffEq.get_iterated_I!(dt, W.dW, W.dZ, Jdiag, nothing, 1)
    Jdiagoop = StochasticDiffEq.JDiagonal_oop()

    @test StochasticDiffEq.get_iterated_I(dt, W.dW, W.dZ, Jdiagoop, nothing, 1) == Jdiag.J
    @test Jdiag.J == true_diag

    for alg in StochasticDiffEqLevyArea.ITER_INT_ALGS
        @test diag(StochasticDiffEq.get_iterated_I(dt, W.dW, W.dZ, alg, nothing, 1)) ==
            true_diag
    end
end

# Commutative noise tests
@testset "Commutative noise tests" begin
    true_commute = 1 // 2 .* W.dW .* W.dW'

    Jcommute = StochasticDiffEq.JCommute_iip(W.dW)
    StochasticDiffEq.get_iterated_I!(dt, W.dW, W.dZ, Jcommute, nothing, 1)
    Jcommuteoop = StochasticDiffEq.JCommute_oop()

    @test StochasticDiffEq.get_iterated_I(dt, W.dW, W.dZ, Jcommuteoop, nothing, 1) ==
        Jcommute.J
    @test Jcommute.J == true_commute

    for alg in StochasticDiffEqLevyArea.ITER_INT_ALGS
        @test diag(StochasticDiffEq.get_iterated_I(dt, W.dW, W.dZ, alg, nothing, 1)) ==
            diag(true_commute)
    end
end

# moment conditions
# E1(I_{j1} I_{j2}) = Δ δ_{j1,j2}
# E2(I_{j1, j2} I_{j1, j2}) = 1/2 Δ^2
# E3(I_{j1} I_{j2} I_{j3, j4}) = {Δ^2 if j1=j2=j3=j4, 1/2 Δ^2 if j3!=j4 and j1=j3, j2=j4 or j1=j4, j2=j3, 0 otherwise}
function test_moments(m, alg, Δ, samples, p = nothing)
    # generate new random dW
    W = WienerProcess!(0.0, zeros(m), nothing)
    E1 = false .* vec(W.dW) .* vec(W.dW)'
    E2 = zero(E1)
    E3 = zero(E1)
    tmp = zero(E1)
    for _ in 1:samples
        calculate_step!(W, Δ, nothing, nothing)
        accept_step!(W, Δ, nothing, nothing)
        mul!(tmp, vec(W.dW), vec(W.dW)')

        I = StochasticDiffEq.get_iterated_I(Δ, W.dW, W.dZ, alg, p, 1)
        @. E1 = E1 + tmp
        @. E2 = E2 + I * I
        @. E3 = E3 + tmp * I
    end
    @. E1 = E1 / samples
    @. E2 = E2 / samples
    @. E3 = E3 / samples

    @test maximum(abs.(E1 - Δ * I)) < 2.0e-1
    @test maximum(abs.(E2 - Δ^2 * (zero(E2) .+ 1) / 2)) < 1.0e-2
    return @test maximum(abs.(E3 - Δ^2 * (one(E2) .+ 1) / 2)) < 1.0e-2
end

"""
Exercise 2.3.1 from
Kloeden, P. E., Platen, E., & Schurz, H. Numerical solution of SDE through computer
experiments. Springer Science & Business Media. (2012)
"""

function test_compare_sample_mean_and_var(alg, Δ, m, samples = Int(1.0e6), p = Int(1.0e2))
    W = WienerProcess(0.0, zeros(m), nothing)
    calculate_step!(W, dt, nothing, nothing)
    for i in 1:10
        accept_step!(W, dt, nothing, nothing)
    end

    xs = [StochasticDiffEq.get_iterated_I(Δ, W.dW, W.dZ, alg, p, 1)[1, 2]]
    coms = [1 // 2 * W.dW[1] * W.dW[2]]

    for i in 1:samples
        calculate_step!(W, Δ, nothing, nothing)
        accept_step!(W, Δ, nothing, nothing)
        com = 1 // 2 * W.dW[1] * W.dW[2]
        x = StochasticDiffEq.get_iterated_I(Δ, W.dW, W.dZ, alg, p, 1)[1, 2]

        push!(xs, x)
        push!(coms, com)
    end

    @test mean(xs) ≈ 0 atol = 1.0e-2
    @test mean(coms) ≈ 0 atol = 1.0e-2
    @test var(xs) ≈ 1 // 2 * Δ^2 rtol = 1.0e-2
    return @test var(coms) ≈ 1 // 4 * Δ^2 rtol = 1.0e-2
end

@testset "General noise tests" begin
    true_commute = 1 // 2 .* W.dW .* W.dW'
    samples = Int(1.0e4)
    for alg in StochasticDiffEqLevyArea.ITER_INT_ALGS
        # Test the relations given in Wiktorsson paper Eq.(2.1)
        Random.seed!(seed)
        I = StochasticDiffEq.get_iterated_I(dt, W.dW, W.dZ, alg, 1, 1)
        Random.seed!(seed)
        A = StochasticDiffEqLevyArea.levyarea(W.dW / √dt, 1, alg)
        @test dt * A + true_commute == I # because of correction with \mu term
        @test diag(A) == diag(zero(A))
        @test diag(true_commute) == diag(I)
        @test I + I' ≈ 2 * true_commute atol = 1.0e-12
        @test A ≈ -A' atol = 1.0e-12

        # test moment conditions
        test_moments(m, alg, dt, samples)

        # test other StatsJ
        @time test_compare_sample_mean_and_var(alg, 1.0, 2)
    end
end

@testset "Simulate non-com. SDEs tests" begin
    u₀ = [0.0, 0.0, 0.0]
    f(u, p, t) = [0.0, 0.0, 0.0]
    g(u, p, t) = [1.0 0.0; 0.0 1.0; 0.0 u[1]]
    f!(du, u, p, t) = du .*= false
    function g!(du, u, p, t)
        du[1, 1] = 1.0
        du[2, 2] = 1.0
        du[3, 2] = u[1]
        return nothing
    end
    dt = 1 // 2^8
    tspan = (0.0, 1.0)
    prob = SDEProblem(f, g, u₀, (0.0, 1.0); noise_rate_prototype = zeros(3, 2))
    prob! = SDEProblem(f!, g!, u₀, (0.0, 1.0); noise_rate_prototype = zeros(3, 2))

    sol = solve(prob, RKMilGeneral(; ii_approx = IICommutative()), dt = dt, adaptive = false)
    @test sol.retcode == ReturnCode.Success
    sol = solve(prob, RKMilGeneral(; ii_approx = IILevyArea()), dt = dt, adaptive = false)
    @test sol.retcode == ReturnCode.Success
    sol = solve(prob, RKMilGeneral(ii_approx = Fourier()), dt = dt, adaptive = false)
    @test sol.retcode == ReturnCode.Success

    sol = solve(prob!, RKMilGeneral(; ii_approx = IICommutative()), dt = dt, adaptive = false)
    @test sol.retcode == ReturnCode.Success
    sol = solve(prob!, RKMilGeneral(; ii_approx = IILevyArea()), dt = dt, adaptive = false)
    @test sol.retcode == ReturnCode.Success
    sol = solve(prob!, RKMilGeneral(ii_approx = Fourier()), dt = dt, adaptive = false)
    @test sol.retcode == ReturnCode.Success
end

using StochasticDiffEq, OrdinaryDiffEqDifferentiation, Test

tspan = (0.0, 1.0)
explicit = [SRIW1(), SRIW2(), SOSRI(), SOSRI2(), SRA2(), SRA3(), SOSRA(), SOSRA2()]
implicit_autodiff = [SKenCarp(), ImplicitEulerHeun()]
implicit_noautodiff = [SKenCarp(autodiff = false), ImplicitEulerHeun(autodiff = false)]

@testset "Out-of-place methods" begin
    u0 = 1.0 + 1.0im
    function f(u, p, t)
        t isa Complex && error("time is complex")
        1.01u
    end
    prob = SDEProblem(f, f, u0, tspan)

    for alg in Iterators.flatten((explicit, implicit_noautodiff))
        sol = solve(prob, alg)
        @test eltype(sol.u[end]) == ComplexF64
    end

    # currently broken
    for alg in implicit_autodiff
        @test_throws OrdinaryDiffEqDifferentiation.FirstAutodiffJacError solve(prob, alg)
    end
end

@testset "In-place methods" begin
    u0 = ones(2, 4) + im * ones(2, 4)
    function f(du, u, p, t)
        t isa Complex && error("time is complex")
        du .= 1.01u
    end
    prob = SDEProblem(f, f, u0, tspan)

    for alg in Iterators.flatten((explicit, implicit_noautodiff))
        sol = solve(prob, alg)
        @test eltype(sol.u[end]) == ComplexF64
    end

    # currently broken
    for alg in implicit_autodiff
        @test_throws OrdinaryDiffEqDifferentiation.FirstAutodiffJacError solve(prob, alg)
    end
end

using StochasticDiffEq, DiffEqCallbacks, DiffEqNoiseProcess, Test, Random
import SciMLBase

Random.seed!(100)
# Definitions according to vector/matrix representations of operators from QuantumOptics
u0 = ComplexF64[0.0, 1.0]
A = zeros(ComplexF64, 2, 2)
A[2, 1] = 1.0
A[1, 2] = 1.0
As = zeros(ComplexF64, 2, 2)
As[1, 1] = 0.5
As[2, 2] = -0.5

# SDE functions
function f_qm(du, u, p, t)
    return du .= -1.0im * A * u
end
function g_qm(du, u, p, t)
    return du .= -1.0im * As * u
end

# Set up two identical instances of saving
T = [0:0.1:2;]
fout(u, t, integrator) = abs2(u[1]) - abs2(u[2])

# Define the problems -- note the difference in noise
prob1 = SDEProblem{true}(
    f_qm, g_qm, u0, (T[1], T[end]),
    noise = StochasticDiffEq.RealWienerProcess(
        0.0, 0.0, 0.0,
        rswm = DiffEqNoiseProcess.RSWM(adaptivealg = :RSwM1)
    )
)

prob2 = SDEProblem{true}(
    f_qm, g_qm, u0, (T[1], T[end]),
    noise = StochasticDiffEq.RealWienerProcess(
        0.0, 0.0, 0.0,
        rswm = DiffEqNoiseProcess.RSWM(adaptivealg = :RSwM3)
    )
)

# Simple averaging
Ntraj = 1000
avg1 = zeros(size(T)...)
avg2 = zeros(size(T)...)
avg3 = zeros(size(T)...)

let
    global avg1, avg2, avg3
    for i in 1:Ntraj
        out1 = SavedValues(Float64, ComplexF64)
        scb1 = SavingCallback(
            fout, out1, saveat = T, save_everystep = false, save_start = false
        )

        solve(
            prob1, RKMil{SciMLBase.AlgorithmInterpretation.Stratonovich}(),
            dt = 1.0e-4, callback = scb1, seed = i, adaptive = false
        )
        avg1 .+= out1.saveval ./ Ntraj

        out1 = SavedValues(Float64, ComplexF64)
        scb1 = SavingCallback(
            fout, out1, saveat = T, save_everystep = false, save_start = false
        )

        solve(
            prob1, RKMil{SciMLBase.AlgorithmInterpretation.Stratonovich}(),
            tstops = T, callback = scb1,
            save_everystep = false, save_start = false
        )
        avg2 .+= out1.saveval ./ Ntraj

        out1 = SavedValues(Float64, ComplexF64)
        scb1 = SavingCallback(
            fout, out1, saveat = T, save_everystep = false, save_start = false
        )

        solve(
            prob2, RKMil{SciMLBase.AlgorithmInterpretation.Stratonovich}(),
            tstops = T, callback = scb1,
            save_everystep = false, save_start = false
        )
        avg3 .+= out1.saveval ./ Ntraj
    end
end

#=
using Plots; gr()
plot(T, avg1)
plot!(T, avg2)
plot!(T, avg3)
=#

@test maximum(avg1 - avg2) < 0.02
@test maximum(avg1 - avg3) < 0.03

#Adding Similar Tests for RKMilGeneral
# Simple averaging
Ntraj = 1000
avg1 = zeros(size(T)...)
avg2 = zeros(size(T)...)
avg3 = zeros(size(T)...)

let
    global avg1, avg2, avg3
    for i in 1:Ntraj
        out1 = SavedValues(Float64, ComplexF64)
        scb1 = SavingCallback(
            fout, out1, saveat = T, save_everystep = false, save_start = false
        )

        solve(
            prob1,
            RKMilGeneral(interpretation = SciMLBase.AlgorithmInterpretation.Stratonovich),
            dt = 1.0e-4,
            callback = scb1, seed = i, adaptive = false
        )
        avg1 .+= out1.saveval ./ Ntraj

        out1 = SavedValues(Float64, ComplexF64)
        scb1 = SavingCallback(
            fout, out1, saveat = T, save_everystep = false, save_start = false
        )

        solve(
            prob1,
            RKMilGeneral(interpretation = SciMLBase.AlgorithmInterpretation.Stratonovich),
            tstops = T, callback = scb1,
            save_everystep = false, save_start = false
        )
        avg2 .+= out1.saveval ./ Ntraj

        out1 = SavedValues(Float64, ComplexF64)
        scb1 = SavingCallback(
            fout, out1, saveat = T, save_everystep = false, save_start = false
        )

        solve(
            prob2,
            RKMilGeneral(interpretation = SciMLBase.AlgorithmInterpretation.Stratonovich),
            tstops = T, callback = scb1,
            save_everystep = false, save_start = false
        )
        avg3 .+= out1.saveval ./ Ntraj
    end
end

#=
using Plots; gr()
plot(T, avg1)
plot!(T, avg2)
plot!(T, avg3)
=#

@test maximum(avg1 - avg2) < 0.03
@test maximum(avg1 - avg3) < 0.04

using StochasticDiffEq, Test
function f(du, u, p, t)
    du[1] = u[2]
    return du[2] = -9.81
end

function g(du, u, p, t)
    return nothing
end

function condition(u, t, integrator) # Event when event_f(u,p,t,k) == 0
    return u[1]
end

affect! = nothing
function affect_neg!(integrator)
    return integrator.u[2] = -integrator.u[2]
end

# Continuous callback
callback = ContinuousCallback(condition, affect!, affect_neg!)

u0 = [50.0, 0.0]
tspan = (0.0, 15.0)
prob = SDEProblem(f, g, u0, tspan)

sol = solve(prob, SRIW1(), callback = callback, adaptive = false, dt = 3 / 4)

@test minimum([u[1] for u in sol.u]) > -1.0e-12 && minimum([u[1] for u in sol.u]) < 1.0e-12

sol = solve(prob, SRIW1(), callback = callback, save_everystep = false)
t = sol.t[end ÷ 2] # this is the callback time point
sol = solve(prob, SRIW1(), callback = callback, saveat = t)
@test count(x -> x == t, sol.t) == 2
sol = solve(prob, SRIW1(), callback = callback, saveat = t - eps(t))
@test count(x -> x == t, sol.t) == 2

function g(du, u, p, t)
    return du[2] = 0.125 * u[2]
end

prob = SDEProblem(f, g, u0, tspan)

sol = solve(prob, SRIW1(), callback = callback)

sol = solve(prob, EM(), callback = callback, dt = 1 / 4)

# Discrete callback
tstop = [5.0; 8.0]
condition_dc = (u, t, integrator) -> t in tstop
affect!_dc = (integrator) -> integrator.u .= 1.0
save_positions = (true, true)
times_finalize_called = 0
callback_dc = DiscreteCallback(
    condition_dc, affect!_dc, save_positions = save_positions,
    finalize = (args...) -> global times_finalize_called += 1
)
sol = solve(prob, SRIW1(), callback = callback_dc, tstops = tstop, saveat = tstop)
@test count(x -> x == tstop[1], sol.t) == 2
@test count(x -> x == tstop[2], sol.t) == 2
@test times_finalize_called == 1
sol = solve(
    prob, SRIW1(), callback = callback_dc, tstops = tstop, saveat = prevfloat.(tstop)
)
@test count(x -> x == tstop[1], sol.t) == 2
@test count(x -> x == tstop[2], sol.t) == 2
@test times_finalize_called == 2

###
# https://github.com/SciML/DifferentialEquations.jl/issues/802
###

function HM_neuron!(du, u, Params, t)
    # Membrane voltage
    du[1] = -u[1]^3 + 3.0 * u[1]^2 + u[2] - u[3] + u[4] * u[1]

    # Fast channel
    du[2] = 1.0 - 5.0 * u[1]^2 - u[2]

    # Slow channel
    val = Params.s * (u[1] + 8.0 / 5.0)
    du[3] = Params.r * (val - u[3])

    # Synapse
    return du[4] = -u[4] / Params.syntau
end

function HM_noise!(du, u, Params, t)
    du[1] = 0.1
    du[2] = 0.0
    du[3] = 0.0
    return du[4] = 0.0
end

tvals = range(0.0, stop = 1999.9, length = 20000);
struct P
    r::Float64
    s::Float64
    I::Float64
    syntau::Float64
    gSyn::Float64
end

params = P(0.001, 1, 0.0, 5, 0.0);
x0 = Float64[-1.6, -11.8, 0.0, 0.0];

condition2(u, t, integrator) = u[1];
affect2!(integrator) = integrator.u[4] = integrator.u[4] - params.gSyn; # Inhibitory exponential decay synapse
cb = ContinuousCallback(condition2, affect2!, nothing);
prob = SDEProblem(HM_neuron!, HM_noise!, x0, (0.0, 1999.9), params);
sol = solve(prob, ImplicitEM(), reltol = 1.0e-4, abstol = 1.0e-6, dense = true, callback = cb);
sol = solve(prob, SKenCarp(), reltol = 1.0e-4, abstol = 1.0e-6, dense = true, callback = cb);

using DiffEqCallbacks

function f(du, u, p, t)
    return du[1] = p[1] - u[1]
end

function g(du, u, p, t)
    return du[1] = p[2]
end

sprob = SDEProblem(f, g, [1.0], (0.0, 10.0), [1.0, 0.1])
sol = solve(sprob, ImplicitEM(), callback = PositiveDomain())

###
# https://github.com/SciML/DifferentialEquations.jl/issues/1121
# saveat + ContinuousCallback interpolation bug fix
###

using Random

@testset "saveat + ContinuousCallback interpolation (issue #1121)" begin
    α = 1.0
    β = 1.0
    σφ = 0.5

    u0_test = [0.5, 0.0]
    tspan_test = (0.0, 10.0)

    function f_test(u, p, t)
        A, φ = u
        return [α * A * cos(φ), 0.0]
    end

    function g_test(u, p, t)
        A, φ = u
        return [β * A, σφ]
    end

    prob_test = SDEProblem(f_test, g_test, u0_test, tspan_test)

    rng = MersenneTwister(123)
    threshold = Ref(rand(rng, 0.2:0.001:1.0))
    cond_test(u, t, integrator) = u[1] - threshold[]
    function affect_test!(integrator)
        integrator.u[1] *= 2.0
        threshold[] = rand(rng, 0.2:0.001:1.0)
    end

    cb_test = ContinuousCallback(cond_test, affect_test!)

    sol_saveat = solve(
        prob_test, SRIW1(), seed = 123, abstol = 1.0e-2, reltol = 1.0e-2,
        maxiters = Int(1.0e10), saveat = 0.01, callback = cb_test
    )

    # Reset RNG for same callback behavior
    rng = MersenneTwister(123)
    threshold = Ref(rand(rng, 0.2:0.001:1.0))

    sol_dense = solve(
        prob_test, SRIW1(), seed = 123, abstol = 1.0e-2, reltol = 1.0e-2,
        maxiters = Int(1.0e10), callback = cb_test
    )

    # Compare saveat values with dense solution sampled at same times
    phase_saveat = [sol_saveat.u[i][2] for i in 1:length(sol_saveat)]
    phase_dense_sampled = [sol_dense(t)[2] for t in sol_saveat.t]

    # The values should match to machine precision
    max_diff = maximum(abs.(phase_saveat .- phase_dense_sampled))
    @test max_diff < 1.0e-10

    # Also verify no large jumps in phase (the original bug symptom)
    dt = 0.01
    expected_std = σφ * sqrt(dt)
    diffs_saveat = diff(phase_saveat)
    @test all(abs.(diffs_saveat) .< 10 * expected_std)
end

###
# Test that save_discretes defaults to true for SDE integrators,
# matching ODE behavior.
###

@testset "save_discretes defaults to true" begin
    f_sd(u, p, t) = 0.5u
    g_sd(u, p, t) = 0.1u
    sprob = SDEProblem(f_sd, g_sd, 1.0, (0.0, 1.0))
    si = init(sprob, ImplicitEM(); dt = 0.01)
    @test si.opts.save_discretes == true
end

using StochasticDiffEq, Test, Random
using SDEProblemLibrary: prob_sde_stiffquadito

Random.seed!(100)
prob = prob_sde_stiffquadito
prob = remake(prob; p = (1.0e5, 2.0))
alg = AutoSOSRA2(SKenCarp(), maxstiffstep = 5, maxnonstiffstep = 2, stiffalgfirst = false)
@test StochasticDiffEq.isadaptive(prob, alg)
@test StochasticDiffEq.isadaptive(alg)
@time sol = solve(prob, alg)
@test alg.algs[sol.alg_choice[end]] isa SKenCarp
@test length(unique(sol.alg_choice)) == 2

Random.seed!(100)
prob = prob_sde_stiffquadito
prob = remake(prob; p = (1.0e5, 2.0))
@time sol = solve(
    prob, AutoSOSRI2(ImplicitRKMil(), maxstiffstep = 1, maxnonstiffstep = 10, stiffalgfirst = false)
)
@test length(unique(sol.alg_choice)) == 2

using StochasticDiffEq, DiffEqNoiseProcess, Random, Test
Random.seed!(100)

f(u, p, t, W) = 1.01u .+ 0.87u .* W
u0 = 1.0
tspan = (0.0, 1.0)
prob = RODEProblem(f, u0, tspan)
sol = solve(prob, RandomEM(), dt = 1 / 100, save_noise = true)
prob = RODEProblem(f, u0, tspan, noise = NoiseWrapper(sol.W))
sol2 = solve(prob, RandomHeun(), dt = 1 / 100)
@test abs(sol.u[end] - sol2.u[end]) < 0.1 * abs(sol.u[end])
sol3 = solve(prob, RandomTamedEM(), dt = 1 / 100)
@test abs(sol.u[end] - sol3.u[end]) < 0.1 * abs(sol.u[end])

f(du, u, p, t, W) = (du .= 1.01u .+ 0.87u .* W)
u0 = ones(4)
prob = RODEProblem(f, u0, tspan)
sol = solve(prob, RandomEM(), dt = 1 / 100, save_noise = true)
prob = RODEProblem(f, u0, tspan, noise = NoiseWrapper(sol.W))
sol2 = solve(prob, RandomHeun(), dt = 1 / 100)
@test sum(abs, sol.u[end] - sol2.u[end]) < 0.1 * sum(abs, sol.u[end])
sol3 = solve(prob, RandomEM(), dt = 1 / 100)
@test sum(abs, sol.u[end] - sol3.u[end]) < 0.1 * sum(abs, sol.u[end])

f(u, p, t, W) = 2u * sin(W)
u0 = 1.0
tspan = (0.0, 1.0)
prob = RODEProblem{false}(f, u0, tspan)
sol = solve(prob, RandomEM(), dt = 1 / 100, save_noise = true)
prob = RODEProblem{false}(f, u0, tspan, noise = NoiseWrapper(sol.W))
sol2 = solve(prob, RandomHeun(), dt = 1 / 100)
@test abs(sol.u[end] - sol2.u[end]) < 0.1 * abs(sol.u[end])
sol3 = solve(prob, RandomTamedEM(), dt = 1 / 100)
@test abs(sol.u[end] - sol3.u[end]) < 0.1 * abs(sol.u[end])

function f(du, u, p, t, W)
    du[1] = 0.2u[1] * sin(W[1] - W[2])
    return du[2] = -0.2u[2] * cos(W[1] + W[2])
end
u0 = [1.0; 1.0]
tspan = (0.0, 1.0)
prob = RODEProblem(f, u0, tspan)
sol = solve(prob, RandomEM(), dt = 1 / 100, save_noise = true)
prob = RODEProblem(f, u0, tspan, noise = NoiseWrapper(sol.W))
sol2 = solve(prob, RandomHeun(), dt = 1 / 100)
@test sum(abs, sol.u[end] - sol2.u[end]) < 0.1 * sum(abs, sol.u[end])
sol3 = solve(prob, RandomTamedEM(), dt = 1 / 100)
@test sum(abs, sol.u[end] - sol3.u[end]) < 0.1 * sum(abs, sol.u[end])

function f(du, u, p, t, W)
    du[1] = -0.2W[3] * u[1] * sin(W[1] - W[2])
    return du[2] = -0.2u[2] * cos(W[1] + W[2])
end
u0 = [1.0; 1.0]
tspan = (0.0, 1.0)
prob = RODEProblem(f, u0, tspan, rand_prototype = zeros(3))
sol = solve(prob, RandomEM(), dt = 1 / 100, save_noise = true)
prob = RODEProblem(f, u0, tspan, noise = NoiseWrapper(sol.W))
sol2 = solve(prob, RandomHeun(), dt = 1 / 100)
@test sum(abs, sol.u[end] - sol2.u[end]) < 0.1 * sum(abs, sol.u[end])
sol3 = solve(prob, RandomTamedEM(), dt = 1 / 100)
@test sum(abs, sol.u[end] - sol3.u[end]) < 0.1 * sum(abs, sol3.u[end])

using StochasticDiffEq, Test, Random, DiffEqDevTools
using SDEProblemLibrary: prob_sde_2Dlinear
Random.seed!(100)
prob = prob_sde_2Dlinear

## Solve and plot
println("Solve and Plot")
sol = solve(prob, EM(), dt = 1 / 2^(3))
sol = solve(prob, LambaEM(), dt = 1 / 2^(3))
sol = solve(prob, LambaEulerHeun(), dt = 1 / 2^(3))
sol = solve(prob, RKMil(), dt = 1 / 2^(3))
sol = solve(prob, RKMilCommute(), dt = 1 / 2^(3))
sol = solve(prob, RKMilGeneral(), dt = 1 / 2^(3))
sol = solve(prob, SRI(), dt = 1 / 2^(3))
sol = solve(prob, SRIW1(), dt = 1 / 2^(3))
sol = solve(prob, SRIW2(), dt = 1 / 2^(3))
sol = solve(prob, SOSRI(), dt = 1 / 2^(3))
sol = solve(prob, SOSRI2(), dt = 1 / 2^(3))
sol = solve(prob, ImplicitEM(), dt = 1 / 2^(3))
sol = solve(prob, ImplicitEM(nlsolve = StochasticDiffEq.NLFunctional()), dt = 1 / 2^(3), adaptive = false)
sol = solve(prob, ImplicitEM(autodiff = false), dt = 1 / 2^(3))
sol = solve(prob, ImplicitRKMil(), dt = 1 / 2^(3))

sol = solve(prob, SRIW1(), dt = 1 / 2^(3), save_everystep = false)
#sol = solve(prob,SRIW1(),dt=1/2^(3),progress=true,progress_steps=1)

sol = solve(prob, SRIW1(), dt = 1 / 2^(3), seed = 1)
sol2 = solve(prob, SRI(error_terms = 2), dt = 1 / 2^(3), seed = 1, delta = 1 / 6)
sol.t ≈ sol2.t

sol = solve(prob, SOSRI(), dt = 1 / 2^(3), seed = 1)
sol2 = solve(prob, SRI(tableau = StochasticDiffEq.constructSRIOpt1()), dt = 1 / 2^(3), seed = 1)
sol.t ≈ sol2.t

## Convergence Testing
println("Convergence Test on 2D Linear")
dts = (1 / 2) .^ (7:-1:4) #14->7 good plot

sim = test_convergence(dts, prob, EM(), trajectories = 1000)
@test abs(sim.𝒪est[:l2] - 0.5) < 0.1

sim = test_convergence(dts, prob, LambaEM(), trajectories = 1000)
@test abs(sim.𝒪est[:l2] - 0.5) < 0.1

sim = test_convergence(dts, prob, ImplicitEM(), trajectories = 300)
@test abs(sim.𝒪est[:l2] - 0.5) < 0.1

sim = test_convergence(dts, prob, ImplicitEM(theta = 1), trajectories = 100)
@test abs(sim.𝒪est[:l2] - 0.5) < 0.1

sim = test_convergence(dts, prob, ImplicitEM(symplectic = true), trajectories = 500)
@test abs(sim.𝒪est[:l2] - 0.5) < 0.1

sim = test_convergence(dts, prob, ImplicitEM(symplectic = true, autodiff = false), trajectories = 100)
@test abs(sim.𝒪est[:l2] - 0.5) < 0.1

sim = test_convergence(dts, prob, ISSEM(), trajectories = 500)
@test abs(sim.𝒪est[:l2] - 0.5) < 0.1

sim = test_convergence(dts, prob, ImplicitRKMil(), trajectories = 100)
@test abs(sim.𝒪est[:l2] - 1) < 0.1

sim = test_convergence(dts, prob, ImplicitRKMil(theta = 1), trajectories = 100)
@test abs(sim.𝒪est[:l2] - 1) < 0.1

sim = test_convergence(dts, prob, ImplicitRKMil(theta = 1, autodiff = false), trajectories = 200)
@test abs(sim.𝒪est[:l2] - 1) < 0.1

sim = test_convergence(dts, prob, ImplicitRKMil(symplectic = true), trajectories = 150)
@test abs(sim.𝒪est[:l2] - 1) < 0.1

sim = test_convergence(dts, prob, ImplicitRKMil(symplectic = true, autodiff = false), trajectories = 100)
@test abs(sim.𝒪est[:l2] - 1) < 0.1

sim = test_convergence(dts, prob, ImplicitRKMil(nlsolve = StochasticDiffEq.NLFunctional()), trajectories = 100)
@test abs(sim.𝒪est[:l2] - 1) < 0.1

sim2 = test_convergence(dts, prob, RKMil(), trajectories = 1000)
@test abs(sim2.𝒪est[:l∞] - 1) < 0.2

sim2 = test_convergence(dts, prob, RKMilCommute(), trajectories = 1000)
@test abs(sim2.𝒪est[:l∞] - 1) < 0.2

sim2 = test_convergence(dts, prob, RKMilGeneral(), trajectories = 1000)
@test abs(sim2.𝒪est[:l∞] - 1) < 0.2

print(".")

sim2 = test_convergence(dts, prob, WangLi3SMil_A(), trajectories = 100)
@test abs(sim2.𝒪est[:l∞] - 1) < 0.2

sim2 = test_convergence(dts, prob, WangLi3SMil_B(), trajectories = 100)
@test abs(sim2.𝒪est[:l∞] - 1) < 0.2

sim2 = test_convergence(dts, prob, WangLi3SMil_C(), trajectories = 100)
@test abs(sim2.𝒪est[:l∞] - 1) < 0.2

sim2 = test_convergence(dts, prob, WangLi3SMil_D(), trajectories = 100)
@test abs(sim2.𝒪est[:l∞] - 1) < 0.2

sim2 = test_convergence(dts, prob, WangLi3SMil_E(), trajectories = 100)
@test abs(sim2.𝒪est[:l∞] - 1) < 0.2

sim2 = test_convergence(dts, prob, WangLi3SMil_F(), trajectories = 100)
@test abs(sim2.𝒪est[:l∞] - 1) < 0.2

print(".")

Random.seed!(100)
eigen_est = (integrator) -> integrator.eigen_est = 10.0
for Alg in [SROCK1, SROCK2], alg in [Alg(), Alg(eigen_est = eigen_est)]

    local sim2
    sim2 = test_convergence(dts, prob, alg, trajectories = 150)
    @test abs(sim2.𝒪est[:l∞] - 1) < 0.2
    @show sim2.𝒪est[:l∞]
end

sim2 = test_convergence(dts, prob, SROCKEM(strong_order_1 = false), trajectories = 100)
@test abs(sim2.𝒪est[:l∞] - 0.5) < 0.2

sim2 = test_convergence(dts, prob, SROCKEM(), trajectories = 100)
@test abs(sim2.𝒪est[:l∞] - 1) < 0.2

sim2 = test_convergence(dts, prob, SROCKEM(eigen_est = eigen_est), trajectories = 100)
@test abs(sim2.𝒪est[:l∞] - 1) < 0.2

sim2 = test_convergence(dts, prob, SKSROCK(), trajectories = 500)
@test abs(sim2.𝒪est[:l∞] - 0.5) < 0.2
sim2 = test_convergence(dts, prob, SKSROCK(eigen_est = eigen_est), trajectories = 500)
@test abs(sim2.𝒪est[:l∞] - 0.5) < 0.2

sim2 = test_convergence(dts, prob, SROCKC2(), trajectories = 100)
@test abs(sim2.𝒪est[:l∞] - 1) < 0.2
sim2 = test_convergence(dts, prob, SROCKC2(eigen_est = eigen_est), trajectories = 100)
@test abs(sim2.𝒪est[:l∞] - 1) < 0.2

# #omitting tests for incomplete methods
# sim = test_convergence(dts,prob,TangXiaoSROCK2(version_num=1),trajectories=100)
# @test abs(sim.𝒪est[:l∞]- 1) < 0.2
#
# sim = test_convergence(dts,prob,TangXiaoSROCK2(version_num=2),trajectories=100)
# @test abs(sim.𝒪est[:l∞]- 1) < 0.2
#
# sim = test_convergence(dts,prob,TangXiaoSROCK2(version_num=3),trajectories=100)
# @test abs(sim.𝒪est[:l∞]- 1) < 0.2
#
# sim = test_convergence(dts,prob,TangXiaoSROCK2(version_num=4),trajectories=100)
# @test abs(sim.𝒪est[:l∞]- 1) < 0.2
#
# sim = test_convergence(dts,prob,TangXiaoSROCK2(version_num=5),trajectories=100)
# @test abs(sim.𝒪est[:l∞]- 1) < 0.2

print(".")

sim3 = test_convergence(dts, prob, SRI(), trajectories = 100)
@test abs(sim3.𝒪est[:final] - 1.5) < 0.3

sim4 = test_convergence(dts, prob, SRIW1(), trajectories = 100)
@test abs(sim4.𝒪est[:final] - 1.5) < 0.3

sim4 = test_convergence(dts, prob, SRIW2(), trajectories = 100)
@test abs(sim4.𝒪est[:final] - 1.5) < 0.3

sim4 = test_convergence(dts, prob, SOSRI(), trajectories = 100)
@test abs(sim4.𝒪est[:final] - 1.5) < 0.3

sim4 = test_convergence(dts, prob, SOSRI2(), trajectories = 100)
@test abs(sim4.𝒪est[:final] - 1.5) < 0.3

# 2D oop
f_oop(u, p, t) = 0.1 * u
g_oop(u, p, t) = 0.1 * u
prob = SDEProblem(f_oop, g_oop, 0.001 * ones(2, 2), (0.0, 1.0))
@test_nowarn solve(prob, ImplicitEM())

using StochasticDiffEq, Test, Random, DiffEqNoiseProcess
using SDEProblemLibrary: prob_sde_linear, prob_sde_2Dlinear

Random.seed!(100)

for prob in (prob_sde_linear, prob_sde_2Dlinear)
    prob2 = remake(prob; tspan = (1.0, 0.0))

    solEM = solve(prob2, EM(), dt = -1 // 2^(4), tstops = [0.33])
    @test solEM.t[15] > solEM.t[16]

    solSRIW1 = solve(prob2, SRIW1(), tstops = [0.33])
    @test solSRIW1.t[15] > solSRIW1.t[16]
end

# Test reversing the noise

α = 1
β = 1
u₀ = 1 / 2
f(u, p, t) = α * u
g(u, p, t) = β * u
dt = 1 // 2^(4)
tspan = (0.0, 1.0)
prob = SDEProblem(f, g, u₀, (0.0, 1.0))
sol = solve(prob, EulerHeun(), dt = 0.01, save_noise = true)
_sol = deepcopy(sol) # to make sure the plot is correct
W3 = NoiseGrid(reverse!(_sol.t), reverse!(_sol.W))
prob3 = SDEProblem(f, g, sol.u[end], (1.0, 0.0), noise = W3)
sol2 = solve(prob3, EulerHeun(), dt = 0.01)
@test sol.u ≈ reverse!(sol2.u) atol = 1.0e-1

using StochasticDiffEq, Test, Random
using SDEProblemLibrary: prob_sde_linear, prob_sde_2Dlinear
prob = prob_sde_2Dlinear
choice_function(integrator) = (Int(integrator.t < 0.5) + 1)
alg_double = StochasticCompositeAlgorithm((SRIW1(), SRIW1()), choice_function)
alg_double2 = StochasticCompositeAlgorithm((SRI(), SRI()), choice_function)
alg_switch = StochasticCompositeAlgorithm((EM(), RKMil()), choice_function)

Random.seed!(100)
@time sol1 = solve(prob_sde_linear, alg_double, delta = 1 / 6)
Random.seed!(100)
@time sol2 = solve(prob_sde_linear, SRIW1())
@test sol1.t == sol2.t
@test sol1(0.8) == sol2(0.8)

Random.seed!(100)
integrator1 = init(prob, alg_double2, delta = 1 / 6)
Random.seed!(100)
integrator2 = init(prob, SRI(), delta = 1 / 6)
Random.seed!(100)
solve!(integrator1)
Random.seed!(100)
solve!(integrator2)

@test integrator1.sol.t == integrator2.sol.t

sol = solve(prob, alg_switch, dt = 1 / 8)

using StochasticDiffEq, DiffEqDevTools, LinearAlgebra, Random, Test
Random.seed!(100)
dts = (1 / 2) .^ (10:-1:2) #14->7 good plot

# From RUNGE–KUTTA METHODS FOR THE STRONG APPROXIMATION OF SOLUTIONS OF STOCHASTIC DIFFERENTIAL EQUATIONS
# (7.4)

d = 4;
m = 10
u0 = rand(4)
A = zeros(d, d)
for i in 1:d, j in 1:d

    global A
    i == j && (A[i, j] = -3 / 2)
    i != j && (A[i, j] = 1 / 20)
end

B = [zeros(d, d) for i in 1:m]
for k in 1:m, i in 1:d, j in 1:d
    global B
    i == j && (B[k][i, j] = 1 / 5)
    i != j && (B[k][i, j] = 1 / 100)
end

function f_noncommute(du, u, p, t)
    return mul!(du, A, u)
end

function g_noncommute(du, u, p, t)
    for i in 1:m
        mul!(@view(du[:, i]), B[i], u)
    end
    return
end

function f_noncommute_analytic(u0, p, t, W)
    tmp = (A - 0.5 * sum(B[i]^2 for i in 1:m)) * t + sum(B[i] * W[i] for i in 1:m)
    return exp(tmp) * u0
end

function f_noncommute_analytic_stratonovich(u0, p, t, W)
    tmp = A * t + sum(B[i] * W[i] for i in 1:m)
    return exp(tmp) * u0
end

ff_noncommute = SDEFunction(f_noncommute, g_noncommute, analytic = f_noncommute_analytic)

prob = SDEProblem(ff_noncommute, u0, (0.0, 1.0), noise_rate_prototype = rand(4, m))

sol = solve(prob, EM(), dt = 1 / 2^(8))
sol = solve(prob, RKMilGeneral(p = 10), dt = 1 / 2^(8))

dts = (1 / 2) .^ (10:-1:3) #14->7 good plot
sim1 = test_convergence(dts, prob, EM(), trajectories = Int(1.0e2))
@test abs(sim1.𝒪est[:final] - 0.5) < 0.2
sim2 = test_convergence(dts, prob, RKMilCommute(), trajectories = Int(1.0e2))
@test abs(sim2.𝒪est[:final] - 1) < 0.2
sim3 = test_convergence(dts, prob, RKMilGeneral(p = 2), trajectories = Int(1.0e2))
@test abs(sim3.𝒪est[:final] - 1) < 0.2

ff_noncommute_stratonovich = SDEFunction(
    f_noncommute, g_noncommute, analytic = f_noncommute_analytic_stratonovich
)
prob_stratonovich = SDEProblem(ff_noncommute_stratonovich, u0, (0.0, 1.0), noise_rate_prototype = rand(4, m))

sim4 = test_convergence(dts, prob_stratonovich, EulerHeun(), trajectories = Int(1.0e2))
@test abs(sim4.𝒪est[:final] - 1.0) < 0.2

d = 2;
m = 4
u0 = [2.0, 2.0]
α = 1 / 2

function f_noncommute_2(du, u, p, t)
    du .= 0
    return nothing
end

function g_noncommute_2(du, u, p, t)
    du[1, 1] = cos(p[1]) * sin(u[1])
    du[2, 1] = sin(p[1]) * sin(u[1])
    du[1, 2] = cos(p[1]) * cos(u[1])
    du[2, 2] = sin(p[1]) * cos(u[1])
    du[1, 3] = -sin(p[1]) * sin(u[2])
    du[2, 3] = cos(p[1]) * sin(u[2])
    du[1, 4] = -sin(p[1]) * cos(u[2])
    du[2, 4] = cos(p[1]) * cos(u[2])
    return nothing
end

p = [α]
prob2 = SDEProblem(
    f_noncommute_2, g_noncommute_2, u0, (0.0, 0.5), p, noise_rate_prototype = rand(2, m)
)

sol1 = solve(prob2, EM(), dt = 1 / 2^(8))
sol2 = solve(prob2, RKMilGeneral(p = true, dt = 1 / 2^(7)), dt = 1 / 2^(7), adaptive = false)
sol3 = solve(prob2, RKMilGeneral(), dt = 1 / 2^(7))

dts = (1 / 2) .^ (6:-1:2) #14->7 good plot
test_dt = 1 / 2^(10)
sim5 = analyticless_test_convergence(
    dts, prob2, EM(), test_dt, trajectories = 300, use_noise_grid = false
)
@test abs(sim5.𝒪est[:final] - 0.5) < 0.2
test_dt_mil = 1 / 2^(12)
sim6 = analyticless_test_convergence(
    dts, prob2, RKMilGeneral(p = true, dt = test_dt_mil),
    test_dt_mil, trajectories = 500, use_noise_grid = false
)
@test abs(sim6.𝒪est[:final] - 1.0) < 0.2
sim7 = analyticless_test_convergence(
    dts, prob2, EulerHeun(), test_dt, trajectories = 300, use_noise_grid = false
)
@test abs(sim7.𝒪est[:final] - 0.5) < 0.2

using StochasticDiffEq, Test, Random
using SDEProblemLibrary: prob_sde_linear, prob_sde_2Dlinear, prob_sde_additive,
    prob_sde_additivesystem

probs = Vector{SDEProblem}(undef, 2)
add_probs = Vector{SDEProblem}(undef, 2)
probs[1] = prob_sde_2Dlinear
probs[2] = prob_sde_linear
add_probs[1] = prob_sde_additive
add_probs[2] = prob_sde_additivesystem

for i in 1:2
    global sol, sol2, err1
    bigprob = SDEProblem(
        probs[i].f, big.(probs[i].u0),
        (big.(probs[i].tspan[1]), big.(probs[i].tspan[2])), noise = probs[i].noise
    )
    add_bigprob = SDEProblem(
        add_probs[i].f, big.(add_probs[i].u0),
        (big.(add_probs[i].tspan[1]), big.(add_probs[i].tspan[2])),
        noise = add_probs[i].noise
    )
    ## SRIW1

    Random.seed!(100)
    sol = solve(
        probs[i], SRI(error_terms = 2), dt = 1 / 2^(4), abstol = 1, reltol = 0, delta = 1 / 6
    )
    err1 = sol.errors[:final]

    sol2 = solve(
        probs[i], SRI(error_terms = 2), dt = 1 / 2^(4),
        abstol = 1.0e-1, reltol = 0, delta = 1 / 6
    )
    err2 = sol2.errors[:final]

    #  No bigfloat RNG
    #  sol3 =solve(bigprob,SRI(),dt=BigInt(1)/BigInt(2)^(4),abstol=1e-2,reltol=0)
    #  err3 = sol3.errors[:final]
    #  @test err1 > err3

    sol4 = solve(
        probs[i], SRI(error_terms = 2), dt = 1 / 2^(4),
        abstol = 1.0e-3, reltol = 0, delta = 1 / 6
    )
    err4 = sol4.errors[:final]
    @test err2 > err4

    Random.seed!(100)
    sol = solve(probs[i], SRIW1(), dt = 1 / 2^(4), abstol = 1, reltol = 0)
    err21 = sol.errors[:final]
    @test err1 ≈ err21
    # p1 = plot(sol,plot_analytic=true)

    sol2 = solve(probs[i], SRIW1(), dt = 1 / 2^(4), abstol = 1.0e-1, reltol = 0)
    err22 = sol2.errors[:final]
    @test err2 ≈ err22
    #TEST_PLOT && p2 = plot(sol2,plot_analytic=true)

    #  No bigfloat rng
    #  sol3 =solve(bigprob,SRIW1(),dt=BigInt(1)/BigInt(2)^(4),abstol=1e-2,reltol=0)
    #  err23 = sol3.errors[:final]
    #  @test ≈(err3,err23,rtol=1e-7)
    #TEST_PLOT && p3 = plot(sol3,plot_analytic=true)

    sol4 = solve(probs[i], SRIW1(), dt = 1 / 2^(4), abstol = 1.0e-3, reltol = 0)
    err24 = sol4.errors[:final]
    @test err4 ≈ err24

    ## SRA1

    Random.seed!(100)
    sol = solve(add_probs[i], SRA(), dt = 1 / 2^(4), abstol = 1, reltol = 0)
    err1 = sol.errors[:final]

    sol2 = solve(add_probs[i], SRA(), dt = 1 / 2^(4), abstol = 1.0e-1, reltol = 0)
    err2 = sol2.errors[:final]

    # No BigFloat RNG
    #  sol3 =solve(add_bigprob,SRA(),dt=BigInt(1)/BigInt(2)^(4),abstol=1e-2,reltol=0)
    #  err3 = sol3.errors[:final]#
    #  @test err1 > err3

    sol4 = solve(add_probs[i], SRA(), dt = 1 / 2^(4), abstol = 1.0e-4, reltol = 0)
    err4 = sol4.errors[:final]
    @test err2 > err4

    Random.seed!(100)
    sol = solve(add_probs[i], SRA1(), dt = 1 / 2^(4), abstol = 1, reltol = 0)
    err21 = sol.errors[:final]
    @test err1 ≈ err21
    # p1 = plot(sol,plot_analytic=true)

    sol2 = solve(add_probs[i], SRA1(), dt = 1 / 2^(4), abstol = 1.0e-1, reltol = 0)
    err22 = sol2.errors[:final]
    @test err2 ≈ err22
    #TEST_PLOT && p2 = plot(sol2,plot_analytic=true)

    #  No BigFloat RNG
    #  sol3 =solve(add_bigprob,SRA1(),dt=BigInt(1)/BigInt(2)^(4),abstol=1e-2,reltol=0)
    #  err23 = sol3.errors[:final]
    #  @test ≈(err3,err23,rtol=1e-7)
    #TEST_PLOT && p3 = plot(sol3,plot_analytic=true)

    sol4 = solve(add_probs[i], SRA1(), dt = 1 / 2^(4), abstol = 1.0e-4, reltol = 0)
    err24 = sol4.errors[:final]
    @test isapprox(err4, err24; atol = 1.0e-4)
end

# https://github.com/SciML/StochasticDiffEq.jl/issues/463

σ = 0.05
function f(du, u, p, t)
    return @. du = -u
end

function g(du, u, p, t)
    return @. du = σ
end

u0 = [1.0, 1.0]
prob = SDEProblem(f, g, u0, (0.0, 10.0))

sol = solve(prob, SKenCarp())

using StochasticDiffEq, DiffEqDevTools, Test
using Random
using SDEProblemLibrary: prob_sde_linear
Random.seed!(100)
dts = 1 .// 2 .^ (7:-1:3) #14->7 good plot

prob = prob_sde_linear
println("EM")
@time sim = test_convergence(
    dts, prob, EM(), save_everystep = false, trajectories = Int(1.0e4)
)
@test abs(sim.𝒪est[:weak_final] - 1) < 0.45
#@test abs(sim.𝒪est[:weak_l2]-1) < 0.3
#@test abs(sim.𝒪est[:weak_l∞]-1) < 0.3
println("SimplifiedEM")
@time sim = test_convergence(
    dts, prob, SimplifiedEM(), save_everystep = false, trajectories = Int(1.0e6)
)
@test abs(sim.𝒪est[:weak_final] - 1) < 0.45
#@test abs(sim.𝒪est[:weak_l2]-1) < 0.3
#@test abs(sim.𝒪est[:weak_l∞]-1) < 0.35
println("RKMil")
sim = test_convergence(dts, prob, RKMil(), save_everystep = false, trajectories = Int(1.0e4))
@test abs(sim.𝒪est[:weak_final] - 1) < 0.45
#@test abs(sim.𝒪est[:weak_l2]-1) < 0.3
#@test abs(sim.𝒪est[:weak_l∞]-1) < 0.3
println("RKMilCommute")
sim = test_convergence(
    dts, prob, RKMilCommute(), save_everystep = false, trajectories = Int(1.0e4)
)
@test abs(sim.𝒪est[:weak_final] - 1) < 0.45
#@test abs(sim.𝒪est[:weak_l2]-1) < 0.3
#@test abs(sim.𝒪est[:weak_l∞]-1) < 0.3
println("RKMilGeneral")
sim = test_convergence(
    dts, prob, RKMilGeneral(), save_everystep = false, trajectories = Int(1.0e4)
)
@test abs(sim.𝒪est[:weak_final] - 1) < 0.45
#@test abs(sim.𝒪est[:weak_l2]-1) < 0.3
#@test abs(sim.𝒪est[:weak_l∞]-1) < 0.3
println("SROCK1")
sim = test_convergence(dts, prob, SROCK1(), save_everystep = false, trajectories = Int(1.0e4))
@test abs(sim.𝒪est[:weak_final] - 1) < 0.45
#@test abs(sim.𝒪est[:weak_l2]-1) < 0.3
#@test abs(sim.𝒪est[:weak_l∞]-1) < 0.3
println("SROCK2")
dts = 1 .// 2 .^ (8:-1:1) #14->7 good plot
sim = test_convergence(dts, prob, SROCK2(), save_everystep = false, trajectories = Int(7.0e5))
@test abs(sim.𝒪est[:weak_final] - 2) < 0.5
#@test abs(sim.𝒪est[:weak_l2]-2) < 0.3
#@test abs(sim.𝒪est[:weak_l∞]-2) < 0.3
dts = 1 .// 2 .^ (7:-1:2) #14->7 good plot
println("SROCKEM")
sim = test_convergence(
    dts, prob, SROCKEM(strong_order_1 = false),
    save_everystep = false, trajectories = Int(1.0e4)
)
@test abs(sim.𝒪est[:weak_final] - 1) < 0.45
#@test abs(sim.𝒪est[:weak_l2]-1) < 0.3
#@test abs(sim.𝒪est[:weak_l∞]-1) < 0.3
println("SROCKEM")
sim = test_convergence(
    dts, prob, SROCKEM(), save_everystep = false, trajectories = Int(1.0e4)
)
@test abs(sim.𝒪est[:weak_final] - 1) < 0.45
#@test abs(sim.𝒪est[:weak_l2]-1) < 0.3
#@test abs(sim.𝒪est[:weak_l∞]-1) < 0.3
println("SKSROCK")
sim = test_convergence(
    dts, prob, SKSROCK(), save_everystep = false, trajectories = Int(1.0e4)
)
@test abs(sim.𝒪est[:weak_final] - 1) < 0.45
#@test abs(sim.𝒪est[:weak_l2]-1) < 0.3
#@test abs(sim.𝒪est[:weak_l∞]-1) < 0.3

#omitting tests for incomplete methods
# sim = test_convergence(dts,prob,TangXiaoSROCK2(version_num=1),save_everystep=false,trajectories=Int(4e4),
#                           weak_timeseries_errors=true)
# @test abs(sim.𝒪est[:weak_final]-2) < 0.3
# #@test abs(sim.𝒪est[:weak_l2]-2) < 0.3
# #@test abs(sim.𝒪est[:weak_l∞]-2) < 0.3
# sim = test_convergence(dts,prob,TangXiaoSROCK2(version_num=2),save_everystep=false,trajectories=Int(4e4),
#                           weak_timeseries_errors=true)
# @test abs(sim.𝒪est[:weak_final]-2) < 0.3
# #@test abs(sim.𝒪est[:weak_l2]-2) < 0.3
# #@test abs(sim.𝒪est[:weak_l∞]-2) < 0.3
# sim = test_convergence(dts,prob,TangXiaoSROCK2(version_num=3),save_everystep=false,trajectories=Int(4e4),
#                           weak_timeseries_errors=true)
# @test abs(sim.𝒪est[:weak_final]-2) < 0.3
# #@test abs(sim.𝒪est[:weak_l2]-2) < 0.3
# #@test abs(sim.𝒪est[:weak_l∞]-2) < 0.3
# sim = test_convergence(dts,prob,TangXiaoSROCK2(version_num=4),save_everystep=false,trajectories=Int(4e4),
#                           weak_timeseries_errors=true)
# @test abs(sim.𝒪est[:weak_final]-2) < 0.3
# #@test abs(sim.𝒪est[:weak_l2]-2) < 0.3
# #@test abs(sim.𝒪est[:weak_l∞]-2) < 0.3
# sim = test_convergence(dts,prob,TangXiaoSROCK2(version_num=5),save_everystep=false,trajectories=Int(4e4),
#                           weak_timeseries_errors=true)
# @test abs(sim.𝒪est[:weak_final]-2) < 0.3
# #@test abs(sim.𝒪est[:weak_l2]-2) < 0.3
# #@test abs(sim.𝒪est[:weak_l∞]-2) < 0.3

println("WangLi3SMil_A")
dts = 1 .// 2 .^ (7:-1:3)
sim = test_convergence(
    dts, prob, WangLi3SMil_A(), save_everystep = false, trajectories = Int(1.0e4)
)
@test abs(sim.𝒪est[:weak_final] - 1) < 0.45
#@test abs(sim.𝒪est[:weak_l2]-1) < 0.3
#@test abs(sim.𝒪est[:weak_l∞]-1) < 0.3
println("WangLi3SMil_B")
sim = test_convergence(
    dts, prob, WangLi3SMil_B(), save_everystep = false, trajectories = Int(1.0e4)
)
@test abs(sim.𝒪est[:weak_final] - 1) < 0.45
#@test abs(sim.𝒪est[:weak_l2]-1) < 0.3
#@test abs(sim.𝒪est[:weak_l∞]-1) < 0.3
println("WangLi3SMil_C")
sim = test_convergence(
    dts, prob, WangLi3SMil_C(), save_everystep = false, trajectories = Int(1.0e4)
)
@test abs(sim.𝒪est[:weak_final] - 1) < 0.45
#@test abs(sim.𝒪est[:weak_l2]-1) < 0.3
#@test abs(sim.𝒪est[:weak_l∞]-1) < 0.3
println("WangLi3SMil_D")
sim = test_convergence(
    dts, prob, WangLi3SMil_D(), save_everystep = false, trajectories = Int(1.0e4)
)
@test abs(sim.𝒪est[:weak_final] - 1) < 0.45
#@test abs(sim.𝒪est[:weak_l2]-1) < 0.3
#@test abs(sim.𝒪est[:weak_l∞]-1) < 0.3
println("WangLi3SMil_E")
sim = test_convergence(
    dts, prob, WangLi3SMil_E(), save_everystep = false, trajectories = Int(1.0e4)
)
@test abs(sim.𝒪est[:weak_final] - 1) < 0.45
#@test abs(sim.𝒪est[:weak_l2]-1) < 0.3
#@test abs(sim.𝒪est[:weak_l∞]-1) < 0.3
println("WangLi3SMil_F")
sim = test_convergence(
    dts, prob, WangLi3SMil_F(), save_everystep = false, trajectories = Int(1.0e4)
)
@test abs(sim.𝒪est[:weak_final] - 1) < 0.45
#@test abs(sim.𝒪est[:weak_l2]-1) < 0.3
#@test abs(sim.𝒪est[:weak_l∞]-1) < 0.3
println("SRI")
sim = test_convergence(dts, prob, SRI(), save_everystep = false, trajectories = Int(2.0e5))
@test abs(sim.𝒪est[:weak_final] - 2) < 0.45
#@test abs(sim.𝒪est[:weak_l2]-2) < 0.3
#@test abs(sim.𝒪est[:weak_l∞]-2) < 0.3
println("SRIW1")
sim = test_convergence(dts, prob, SRIW1(), save_everystep = false, trajectories = Int(1.0e5))
@test abs(sim.𝒪est[:weak_final] - 2) < 0.45
#@test abs(sim.𝒪est[:weak_l2]-2) < 0.3
#@test abs(sim.𝒪est[:weak_l∞]-2) < 0.3

#sim = test_convergence(dts,prob,DRI1(),save_everystep=false,trajectories=Int(4e4),
#                        weak_timeseries_errors=true)
#@test abs(sim.𝒪est[:weak_final]-2) < 0.3
##@test abs(sim.𝒪est[:weak_l2]-2) < 0.3
##@test abs(sim.𝒪est[:weak_l∞]-2) < 0.3
#sim = test_convergence(dts,prob,RI1(),save_everystep=false,trajectories=Int(4e4),
#                        weak_timeseries_errors=true)
#@test abs(sim.𝒪est[:weak_final]-2) < 0.3
##@test abs(sim.𝒪est[:weak_l2]-2) < 0.3
##@test abs(sim.𝒪est[:weak_l∞]-2) < 0.3

using StochasticDiffEq, Test, Random
using SDEProblemLibrary: prob_sde_2Dlinear

#=
function f(u,p,t)
  du = similar(u)
  prob_sde_2Dlinear.f(du,u,p,t)
  return du
end
function σ(u,p,t)
  du = similar(u)
  prob_sde_2Dlinear.g(du,u,p,t)
  return du
end

probs = [prob_sde_2Dlinear,
         SDEProblem(f,σ,prob_sde_2Dlinear.u0,prob_sde_2Dlinear.tspan)]
=#

function tolerance_testing(probs, algs)
    for alg in algs, prob in probs

        dt = typeof(alg) <: StochasticDiffEqAdaptiveAlgorithm ? 0.0 : 0.1
        Random.seed!(100)
        sol = solve(prob, alg; dt = dt)

        # Vector of element-wise absolute tolerances
        Random.seed!(100)
        sol2 = solve(prob, alg; dt = dt, abstol = fill(1.0e-2, 4, 2))

        @test sol.t ≈ sol2.t && sol.u ≈ sol2.u

        # Vector of element-wise relative tolerances
        Random.seed!(100)
        sol2 = solve(prob, alg; dt = dt, reltol = fill(1.0e-2, 4, 2))

        @test sol.t ≈ sol2.t && sol.u ≈ sol2.u
    end
    return
end

probs = [prob_sde_2Dlinear]
algs = [SRI(), SRIW1(), SRA1(), SRA(), RKMil(), RKMilGeneral()]
tolerance_testing(probs, algs)

using StochasticDiffEq, Random

function f(du, u, p, t)
    for i in 1:length(u)
        du[i] = (0.2 / length(u)) * u[i]
    end
    return
end

function g(du, u, p, t)
    for i in 1:length(u)
        du[i] = (0.2 / length(u)) * u[i]
    end
    return
end

function condition(u, t, integrator)
    return 1 - maximum(u)
end

function callback_affect!(integrator)
    u = integrator.u
    resize!(integrator, length(u) + 1)
    maxidx = findmax(u)[2]
    Θ = rand()
    u[maxidx] = Θ
    u[end] = 1 - Θ
    return nothing
end

callback = ContinuousCallback(condition, callback_affect!)

u0 = [0.2]
tspan = (0.0, 100.0)
prob = SDEProblem(f, g, u0, tspan)

Random.seed!(3)
sol = solve(prob, SRIW1(), callback = callback)

#=
using Plots; pyplot()
p1 = plot(sol,vars=(0,1),plotdensity=10000,title="Amount of X in Cell 1")
scatter!(sol,denseplot=false)
p2 = plot(sol.t,map((x)->length(x),sol.u),lw=3,
     ylabel="Number of Cells",xlabel="Time")
plot(p1,p2,layout=(2,1),size=(600,1000))
=#

Random.seed!(3)
sol = solve(prob, EM(), callback = callback, dt = 1 / 4)
sol = solve(prob, RKMil(), callback = callback, dt = 1 / 4)

function g(du, u, p, t)
    for i in 1:length(u)
        du[i] = (0.3 / length(u))
    end
    return
end
prob = SDEProblem(f, g, u0, tspan)

sol = solve(prob, SRA1(), callback = callback)

using StochasticDiffEq, Test

f1(u, p, t) = zero(u)
g1(u, p, t) = u isa Number ? one(u) : ones(size(u))
dt = 1 // 2^(4)
prob1 = SDEProblem{false}(f1, g1, 0.0, (0.0, 1.0))
integrator = init(prob1, EM(), dt = dt, save_noise = true)

k = integrator.W.dW
@test integrator.W.dW != 0
solve!(integrator)
@test integrator.sol.W[2] == k

prob1 = SDEProblem{false}(f1, g1, zeros(4), (0.0, 1.0))
sol = solve(prob1, EM(), dt = dt, save_noise = true)
@test sol.W[2] != zeros(4)

f1(du, u, p, t) = du .= 0.0
g1(du, u, p, t) = du .= 1.0
dt = 1 // 2^(4)
prob1 = SDEProblem(f1, g1, zeros(4), (0.0, 1.0))
sol = solve(prob1, EM(), dt = dt, save_noise = true)
@test sol.W[2] != zeros(4)

using StochasticDiffEq, DiffEqNoiseProcess, Test

println("Scalar g")
A = [-1.0 0.0; 0.0 -0.5]
u0 = [1.0, 1.0];
tspan = (0.0, 1.0)
_f = (u, p, t) -> t * (A * u)
_g = (u, p, t) -> 1.0
prob = SDEProblem(SDEFunction(_f, _g), u0, tspan)
integrator = init(prob, SKenCarp(); adaptive = false, dt = 0.01)
step!(integrator)
@test_broken solve(prob, SOSRI(); adaptive = false, dt = 0.01) isa RODESolution
solve(prob, SOSRA(); adaptive = false, dt = 0.01)
solve(prob, EM(); adaptive = false, dt = 0.01)
@test_broken solve(prob, RKMil(); adaptive = false, dt = 0.01) isa RODESolution
solve(prob, SRIW1(); adaptive = false, dt = 0.01)
@test_broken solve(prob, SOSRI2(); adaptive = false, dt = 0.01) isa RODESolution
solve(prob, SOSRA2(); adaptive = false, dt = 0.01)

println("Vector g")
_g = (u, p, t) -> [1.0, 1.0]
prob = SDEProblem(SDEFunction(_f, _g), u0, tspan)
println("Implicit EM")
integrator = init(prob, ImplicitEM(); adaptive = false, dt = 0.01)
step!(integrator)
println("SKenCarp")
integrator = init(prob, SKenCarp(); adaptive = false, dt = 0.01)
step!(integrator)
solve(prob, SOSRI(); adaptive = false, dt = 0.01)
solve(prob, SOSRA(); adaptive = false, dt = 0.01)
solve(prob, EM(); adaptive = false, dt = 0.01)
solve(prob, RKMil(); adaptive = false, dt = 0.01)
solve(prob, SOSRI2(); adaptive = false, dt = 0.01)
solve(prob, SOSRA2(); adaptive = false, dt = 0.01)

using StochasticDiffEq, JumpProcesses, DiffEqBase, Statistics, OrdinaryDiffEq
using Test, LinearAlgebra

function regular_rate(out, u, p, t)
    out[1] = (0.1 / 1000.0) * u[1] * u[2]
    return out[2] = 0.01u[2]
end

const dc = zeros(3, 2)
dc[1, 1] = -1
dc[2, 1] = 1
dc[2, 2] = -1
dc[3, 2] = 1

function regular_c(du, u, p, t, counts, mark)
    return mul!(du, dc, counts)
end

rj = RegularJump(regular_rate, regular_c, 2)
jumps = JumpSet(rj)
iip_prob = DiscreteProblem([999.0, 1, 0], (0.0, 250.0))
jump_iipprob = JumpProblem(iip_prob, Direct(), rj)
jump_iipprob_pure = JumpProblem(iip_prob, PureLeaping(), rj)
@time sol = solve(jump_iipprob, TauLeaping())
@time sol = solve(jump_iipprob_pure, SimpleTauLeaping(); dt = 1.0)
@time sol = solve(jump_iipprob, TauLeaping(); dt = 1.0, adaptive = false)
@time sol = solve(jump_iipprob, CaoTauLeaping(); dt = 1.0)
@time sol = solve(jump_iipprob, CaoTauLeaping())

N = 40_000
sol1 = solve(EnsembleProblem(jump_iipprob_pure), SimpleTauLeaping(); dt = 1.0, trajectories = N)
sol2 = solve(
    EnsembleProblem(jump_iipprob), TauLeaping(); dt = 1.0,
    adaptive = false, save_everystep = false, trajectories = N
)

mean1 = mean([sol1.u[i][end, end] for i in 1:N])
mean2 = mean([sol2.u[i][end, end] for i in 1:N])
@test mean1 ≈ mean2 rtol = 1.0e-2

f(du, u, p, t) = (du .= 0)
g(du, u, p, t) = (du .= 0)
iip_sdeprob = SDEProblem(f, g, [999.0, 1, 0], (0.0, 250.0))
jumpdiff_iipprob = JumpProblem(iip_sdeprob, Direct(), rj)
@time sol = solve(jumpdiff_iipprob, EM(); dt = 1.0)
@time sol = solve(jumpdiff_iipprob, ImplicitEM(); dt = 1.0, adaptive = false)

sol = solve(EnsembleProblem(jumpdiff_iipprob), EM(); dt = 1.0, trajectories = N)
meanX = mean([sol.u[i][end, end] for i in 1:N])
@test mean1 ≈ meanX rtol = 1.0e-2

sol = solve(EnsembleProblem(jumpdiff_iipprob), ImplicitEM(); dt = 1.0, trajectories = N)
meanX = mean([sol.u[i][end, end] for i in 1:N])
@test mean1 ≈ meanX rtol = 1.0e-2

iip_prob = DiscreteProblem([999, 1, 0], (0.0, 250.0))
jump_iipprob = JumpProblem(iip_prob, Direct(), rj)
sol = solve(jump_iipprob, TauLeaping())

function rate_oop(u, p, t)
    return [(0.1 / 1000.0) * u[1] * u[2], 0.01u[2]]
end

function regular_c(u, p, t, counts, mark)
    return dc * counts
end

rj = RegularJump(rate_oop, regular_c, 2)
jumps = JumpSet(rj)
prob = DiscreteProblem([999.0, 1, 0], (0.0, 250.0))
jump_prob = JumpProblem(prob, Direct(), rj)
sol = solve(jump_prob, TauLeaping(), reltol = 5.0e-2)

sol2 = solve(
    EnsembleProblem(jump_prob), TauLeaping(); dt = 1.0,
    adaptive = false, save_everystep = false, trajectories = N
)
mean2 = mean([sol2.u[i][end, end] for i in 1:N])
@test mean1 ≈ mean2 rtol = 1.0e-2

foop(u, p, t) = [0.0, 0.0, 0.0]
goop(u, p, t) = [0.0, 0.0, 0.0]
oop_sdeprob = SDEProblem(foop, goop, [999.0, 1, 0], (0.0, 250.0))
jumpdiff_prob = JumpProblem(oop_sdeprob, Direct(), rj)
@time sol = solve(jumpdiff_prob, EM(); dt = 1.0)
@time sol = solve(jumpdiff_prob, ImplicitEM(); dt = 1.0)

sol = solve(EnsembleProblem(jumpdiff_prob), EM(); dt = 1.0, trajectories = 10_000)
meanX = mean([sol.u[i][end, end] for i in 1:10_000])
@test mean1 ≈ meanX rtol = 1.0e-2

sol = solve(EnsembleProblem(jumpdiff_prob), ImplicitEM(); dt = 1.0, trajectories = 1_000)
meanX = mean([sol.u[i][end, end] for i in 1:1_000])
@test mean1 ≈ meanX rtol = 1.0e-1

# ThetaTrapezoidalTauLeaping: Implicit weak second order tau-leaping method
# Test in-place version with fixed dt
function regular_rate_iip(out, u, p, t)
    out[1] = (0.1 / 1000.0) * u[1] * u[2]
    return out[2] = 0.01u[2]
end

const dc_iip = zeros(3, 2)
dc_iip[1, 1] = -1
dc_iip[2, 1] = 1
dc_iip[2, 2] = -1
dc_iip[3, 2] = 1

function regular_c_iip(du, u, p, t, counts, mark)
    return mul!(du, dc_iip, counts)
end

rj_iip = RegularJump(regular_rate_iip, regular_c_iip, 2)
iip_prob_theta = DiscreteProblem([999.0, 1, 0], (0.0, 250.0))
jump_iipprob_theta = JumpProblem(iip_prob_theta, Direct(), rj_iip)

# Test basic solve
@time sol_theta = solve(
    jump_iipprob_theta, ThetaTrapezoidalTauLeaping(); dt = 1.0, adaptive = false
)

# Test with different theta values
for theta in [0.25, 0.5, 0.75]
    @time sol = solve(
        jump_iipprob_theta, ThetaTrapezoidalTauLeaping(; theta = theta);
        dt = 1.0, adaptive = false
    )
    @test length(sol.t) > 0
end

# Compare mean with TauLeaping - should give similar results
N_theta = 10_000
sol_tauleaping_theta = solve(
    EnsembleProblem(jump_iipprob_theta), TauLeaping(); dt = 1.0,
    adaptive = false, save_everystep = false, trajectories = N_theta
)
sol_theta_ens = solve(
    EnsembleProblem(jump_iipprob_theta), ThetaTrapezoidalTauLeaping();
    dt = 1.0, adaptive = false, save_everystep = false, trajectories = N_theta
)

mean_tauleaping_theta = mean([sol_tauleaping_theta.u[i][end, end] for i in 1:N_theta])
mean_theta_ens = mean([sol_theta_ens.u[i][end, end] for i in 1:N_theta])
@test mean_tauleaping_theta ≈ mean_theta_ens rtol = 5.0e-2

# Test out-of-place version
function rate_oop_theta(u, p, t)
    return [(0.1 / 1000.0) * u[1] * u[2], 0.01u[2]]
end

const dc_oop_theta = zeros(3, 2)
dc_oop_theta[1, 1] = -1
dc_oop_theta[2, 1] = 1
dc_oop_theta[2, 2] = -1
dc_oop_theta[3, 2] = 1

function regular_c_oop_theta(u, p, t, counts, mark)
    return dc_oop_theta * counts
end

rj_oop = RegularJump(rate_oop_theta, regular_c_oop_theta, 2)
prob_oop_theta = DiscreteProblem([999.0, 1, 0], (0.0, 250.0))
jump_prob_oop_theta = JumpProblem(prob_oop_theta, Direct(), rj_oop)

@time sol_oop = solve(
    jump_prob_oop_theta, ThetaTrapezoidalTauLeaping(); dt = 1.0, adaptive = false
)
@test length(sol_oop.t) > 0

# Ensemble test for out-of-place
sol_theta_oop_ens = solve(
    EnsembleProblem(jump_prob_oop_theta),
    ThetaTrapezoidalTauLeaping();
    dt = 1.0, adaptive = false, save_everystep = false,
    trajectories = N_theta
)
mean_theta_oop = mean([sol_theta_oop_ens.u[i][end, end] for i in 1:N_theta])
@test mean_theta_oop ≈ mean_theta_ens rtol = 5.0e-2

# ImplicitTauLeaping: First-order implicit (backward Euler) tau-leaping method
# Reuse the same problem setup from ThetaTrapezoidalTauLeaping tests

# Test basic solve with in-place functions
@time sol_implicit = solve(
    jump_iipprob_theta, ImplicitTauLeaping(); dt = 1.0, adaptive = false
)
@test length(sol_implicit.t) > 0

# Test with out-of-place functions
@time sol_implicit_oop = solve(
    jump_prob_oop_theta, ImplicitTauLeaping(); dt = 1.0, adaptive = false
)
@test length(sol_implicit_oop.t) > 0

# Compare mean with TauLeaping - should give similar results
N_implicit = 10_000
sol_implicit_ens = solve(
    EnsembleProblem(jump_iipprob_theta), ImplicitTauLeaping();
    dt = 1.0, adaptive = false, save_everystep = false, trajectories = N_implicit
)
mean_implicit_ens = mean([sol_implicit_ens.u[i][end, end] for i in 1:N_implicit])
@test mean_tauleaping_theta ≈ mean_implicit_ens rtol = 5.0e-2

# Test for DifferentialEquations.jl#1129:
# ContinuousCallback with SDEProblem using StaticArrays (SVector)
# This should not attempt to mutate the SVector state
#
# The bug was that sde_interpolant! was being called for out-of-place problems,
# which tried to mutate immutable SVectors. The fix ensures that out-of-place
# problems use non-mutating interpolation (linear_interpolant) via the
# is_constant_cache check in change_t_via_interpolation!.

using StochasticDiffEq, StaticArrays, Test, SciMLBase

@testset "ContinuousCallback with SDEProblem{SVector} (issue #1129)" begin
    # Define out-of-place drift and diffusion functions
    function f(u::V, p, t) where {V <: StaticVector}
        V(u[2], -p)
    end
    function g(::V, p, t) where {V <: StaticVector}
        V(0.0, 0.0)
    end

    # Condition: trigger when u[1] crosses zero
    function condition(u, t, integrator)
        u[1]
    end

    u0 = SVector(1.0, -2.0)
    tspan = (0.0, 2.0)
    p = 0.0

    # Create out-of-place SDEProblem
    fn = SDEFunction{false}(f, g)
    sdeprob = SDEProblem(fn, u0, tspan, p)

    # First verify it works without callback
    sol_no_cb = solve(sdeprob, SOSRI())
    @test sol_no_cb.retcode == ReturnCode.Success

    # Now test with ContinuousCallback - this is what triggers the bug
    cb = ContinuousCallback(condition, terminate!)

    # This should not error - should use non-mutating interpolation
    # Before the fix, this would throw:
    # "setindex!(::StaticArraysCore.SVector{2, Float64}, value, ::Int) is not defined"
    sol = solve(sdeprob, SOSRI(); callback = cb)
    @test sol.retcode == ReturnCode.Terminated

    # Verify the callback actually triggered (u[1] should be near zero at the end)
    @test abs(sol.u[end][1]) < 0.1

    # Test with different SDE solvers that support callbacks
    # Use zero noise so the callback deterministically triggers
    for alg in [EM(), LambaEM(), SOSRI(), SOSRA()]
        sol_alg = solve(sdeprob, alg; callback = cb, dt = 0.001)
        @test sol_alg.retcode == ReturnCode.Terminated
    end
end

@testset "DiscreteCallback with SDEProblem{SVector}" begin
    # Also test DiscreteCallback with StaticArrays for completeness
    function f(u::V, p, t) where {V <: StaticVector}
        V(-u[1], -u[2])
    end
    function g(u::V, p, t) where {V <: StaticVector}
        V(0.1, 0.1)
    end

    u0 = SVector(1.0, 1.0)
    tspan = (0.0, 1.0)

    fn = SDEFunction{false}(f, g)
    sdeprob = SDEProblem(fn, u0, tspan)

    # Simple DiscreteCallback that terminates at t=0.5
    condition_dc(u, t, integrator) = t >= 0.5
    affect_dc!(integrator) = terminate!(integrator)
    cb_dc = DiscreteCallback(condition_dc, affect_dc!)

    sol = solve(sdeprob, SOSRI(); callback = cb_dc)
    @test sol.retcode == ReturnCode.Terminated
    @test sol.t[end] ≈ 0.5 atol = 0.01
end

using StochasticDiffEq, SparseArrays, Test, DiffEqNoiseProcess
using SciMLBase: RODEAliasSpecifier

f(du, u, p, t) = (du .= 1.01u)
function g(du, u, p, t)
    du[1, 1] = 0.3u[1]
    du[1, 2] = 0.6u[1]
    du[1, 3] = 0.9u[1]
    du[1, 4] = 0.12u[2]
    du[2, 1] = 1.2u[1]
    du[2, 2] = 0.2u[2]
    du[2, 3] = 0.3u[2]
    return du[2, 4] = 1.8u[2]
end
prob = SDEProblem(f, g, ones(2), (0.0, 1.0), noise_rate_prototype = zeros(2, 4))

sol = solve(prob, EM(), dt = 1 / 1000)

f(du, u, p, t) = (du .= 1.01u)
function g(du, u, p, t)
    du[1, 1] = 0.3
    du[1, 2] = 0.6
    du[1, 3] = 0.9
    du[1, 4] = 0.12
    du[2, 1] = 1.2
    du[2, 2] = 0.2
    du[2, 3] = 0.3
    return du[2, 4] = 1.8
end
prob = SDEProblem(f, g, ones(2), (0.0, 1.0), noise_rate_prototype = zeros(2, 4))

sol = solve(prob, SRA1())
sol = solve(prob, SRA2())
sol = solve(prob, SRA3())
sol = solve(prob, SOSRA())
sol = solve(prob, SOSRA2())
sol = solve(prob, SRA())

@test length(sol.W.u[1]) == 4

f(du, u, p, t) = (du .= 1.01u)
g(du, u, p, t) = (du .= 0.1)
Z = WienerProcess(0.0, [0.0])
prob = SDEProblem(f, g, [1.0], (0.0, 1.0), noise = Z)

sol = solve(prob, EM(), dt = 1 / 100)

@test sol.W == prob.noise
@test objectid(prob.noise) != objectid(sol.W)
@test objectid(prob.noise.u) == objectid(prob.noise.W) != objectid(sol.W.W) ==
    objectid(sol.W.u)

sol = solve(prob, EM(), dt = 1 / 1000, alias = RODEAliasSpecifier(alias_noise = false))

@test sol.W == prob.noise
@test objectid(prob.noise) == objectid(sol.W)
@test objectid(prob.noise.u) == objectid(prob.noise.W) == objectid(sol.W.W) ==
    objectid(sol.W.u)

sol = solve(prob, EM(), dt = 1 / 1000, alias = RODEAliasSpecifier(alias_noise = true))

@test sol.W == prob.noise
@test objectid(prob.noise) != objectid(sol.W)
@test objectid(prob.noise.u) == objectid(prob.noise.W) != objectid(sol.W.W) ==
    objectid(sol.W.u)

function g(du, u, p, t)
    @test du isa SparseMatrixCSC
    du[1, 1] = 0.3u[1]
    du[1, 2] = 0.6u[1]
    du[1, 3] = 0.9u[1]
    du[1, 4] = 0.12u[2]
    du[2, 1] = 1.2u[1]
    du[2, 2] = 0.2u[2]
    du[2, 3] = 0.3u[2]
    return du[2, 4] = 1.8u[2]
end
prob = SDEProblem(f, g, ones(2), (0.0, 1.0), noise_rate_prototype = sprand(2, 4, 1.0))

sol = solve(prob, EM(), dt = 1 / 1000)
@test length(sol.W.u[1]) == 4

sol2 = solve(prob, EM(), dt = 1 / 1000)
@test sol.W.curt ≈ sol2.W.curt ≈ 1.0

ff = (u, p, t) -> exp(t)
W = NoiseFunction(0.0, ff)
drift(u, p, t) = u
vol(u, p, t) = u
dt = 0.01
tspan = (0.0, 1.0)
u0 = 0.0
prob = SDEProblem(drift, vol, u0, tspan, noise = W)
sol = solve(prob, EM(), dt = 0.1)
@test sol.W.curt ≈ last(tspan)
sol2 = solve(prob, EM(), dt = 0.1)
@test sol2.W.curt ≈ last(tspan)
tspan = (0.0, 2.0)
prob = SDEProblem(drift, vol, u0, tspan, noise = W)
sol = solve(prob, EM(), dt = 0.01)
@test sol.W.curt ≈ last(tspan)

@test typeof(sol.W) == typeof(prob.noise) && prob.noise isa NoiseFunction
@test objectid(prob.noise) != objectid(sol.W)

sol = solve(prob, EM(), dt = 1 / 1000, alias = RODEAliasSpecifier(alias_noise = false))
@test objectid(prob.noise) == objectid(sol.W)

sol = solve(prob, EM(), dt = 0.01, alias = RODEAliasSpecifier(alias_noise = true))
@test sol.W.curt ≈ last(tspan)

@test typeof(sol.W) == typeof(prob.noise) && prob.noise isa NoiseFunction
@test objectid(prob.noise) != objectid(sol.W)

sol = solve(prob, EM(), dt = 0.01, alias = RODEAliasSpecifier(alias_noise = false))
@test sol.W.curt ≈ last(tspan)

@test typeof(sol.W) == typeof(prob.noise) && prob.noise isa NoiseFunction
@test objectid(prob.noise) == objectid(sol.W)

using StochasticDiffEq, Random
using SDEProblemLibrary: prob_sde_2Dlinear
Random.seed!(100)

#Let the solver determine the initial stepsize for you!
sol = solve(prob_sde_2Dlinear, SRI())

# using Plots
# plot(sol,plot_analytic=true)
# gui()

#Make sure it does a good job
sol.t[2] > 1.0e-7

sol = solve(prob_sde_2Dlinear, DRI1())
#Make sure it does a good job
sol.t[2] > 1.0e-7

using StochasticDiffEq, DiffEqNoiseProcess, Test

f(du, u, p, t) = (du .= u)
g(du, u, p, t) = (du .= u)
u0 = rand(4, 2)

W = WienerProcess(0.0, 0.0, 0.0)
prob = SDEProblem(f, g, u0, (0.0, 1.0), noise = W)
sol = solve(prob, SRIW1())
sol = solve(prob, SRIW1())

W = WienerProcess(0.0, 0.0, 0.0)
prob = SDEProblem(f, g, u0, (0.0, 1.0), noise = W)
sol = solve(prob, SRI())
sol = solve(prob, SRI())

W = WienerProcess(0.0, 0.0, 0.0, reset = false)
prob = SDEProblem(f, g, u0, (0.0, 1.0), noise = W)
sol = solve(prob, SRI())
@test_throws ErrorException sol = solve(prob, SRI())

g(du, u, p, t) = (du .= 1)

W = WienerProcess(0.0, 0.0, 0.0)
prob = SDEProblem(f, g, u0, (0.0, 1.0), noise = W)
sol = solve(prob, SRA1())

W = WienerProcess(0.0, 0.0, 0.0)
prob = SDEProblem(f, g, u0, (0.0, 1.0), noise = W)
sol = solve(prob, SRA2())

W = WienerProcess(0.0, 0.0, 0.0)
prob = SDEProblem(f, g, u0, (0.0, 1.0), noise = W)
sol = solve(prob, SRA3())

W = WienerProcess(0.0, 0.0, 0.0)
prob = SDEProblem(f, g, u0, (0.0, 1.0), noise = W)
sol = solve(prob, SOSRA())

W = WienerProcess(0.0, 0.0, 0.0)
prob = SDEProblem(f, g, u0, (0.0, 1.0), noise = W)
sol = solve(prob, SOSRA2())

W = WienerProcess(0.0, 0.0, 0.0)
prob = SDEProblem(f, g, u0, (0.0, 1.0), noise = W)
sol = solve(prob, SRA())

using StochasticDiffEq, DiffEqNoiseProcess, ForwardDiff
using Test

u0 = 1 / 2
f(u, p, t) = u
g(u, p, t) = u
dt = 1 // 2^(4)
tspan = (0.0, 1.0)
prob = SDEProblem{false}(f, g, u0, (0.0, 1.0))
sol = @inferred solve(prob, EM(), dt = dt)

# issue #351 — interpolation with ForwardDiff.Dual
# Now uses ODE's interpolation infrastructure (linear fallback via isempty(k))
@inferred sol(ForwardDiff.Dual(0.5))

# https://github.com/SciML/DiffEqNoiseProcess.jl/issues/213
f(u, p, t) = -u
g(u, p, t) = 1.0

w = WienerProcess(0.0, 0.0)
prob = SDEProblem(f, g, 0.0, (0.0, 1.0), noise = w)
@test_throws "Higher order solver requires extra Brownian process Z. Thus `WienerProcess(t, W0)` is insufficient, you must use `WienerProcess(t, W0, Z0)` where `Z` is another Brownian process" solve(
    prob, SRIW1()
)

w = WienerProcess(0.0, 0.0, 0.0)
prob = SDEProblem(f, g, 0.0, (0.0, 1.0), noise = w)
@test SciMLBase.successful_retcode(solve(prob, SRIW1()))

using StochasticDiffEq, JumpProcesses, DiffEqBase, Test

# Test that JumpProblem kwargs (tstops, callbacks) are properly forwarded
# to the SDE/RODE solver via merge_problem_kwargs.

# --- Shared setup ---
# Zero-drift, zero-noise SDE so u stays constant (deterministic for testing).
function f!(du, u, p, t)
    return du[1] = 0.0
end

function g!(du, u, p, t)
    return du[1] = 0.0
end

# A jump that never fires (rate = 0).
never_rate(u, p, t) = 0.0
noop_affect!(integrator) = nothing
noop_jump = ConstantRateJump(never_rate, noop_affect!)

@testset "JumpProblem kwarg forwarding" begin

    @testset "tstops passed to solve are forwarded through JumpProblem" begin
        prob = SDEProblem(f!, g!, [10.0], (0.0, 10.0))
        jprob = JumpProblem(prob, Direct(), noop_jump)
        sol = solve(jprob, EM(); dt = 0.1, tstops = [3.0, 7.0])
        @test 3.0 ∈ sol.t
        @test 7.0 ∈ sol.t
    end

    @testset "callable tstops passed to solve with JumpProblem" begin
        prob = SDEProblem(f!, g!, [10.0], (0.0, 10.0))
        jprob = JumpProblem(prob, Direct(), noop_jump)
        my_tstops = (p, tspan) -> [2.5, 5.5]
        sol = solve(jprob, EM(); dt = 0.1, tstops = my_tstops)
        @test 2.5 ∈ sol.t
        @test 5.5 ∈ sol.t
    end

    # The JumpProblem constructor natively stores `callback` in jprob.kwargs.
    # These tests verify that merge_problem_kwargs properly forwards it.

    @testset "callback from JumpProblem.kwargs forwarded and fires" begin
        prob = SDEProblem(f!, g!, [1.0], (0.0, 5.0))

        condition(u, t, integrator) = t == 2.0
        affect!(integrator) = (integrator.u[1] = 42.0)
        cb = DiscreteCallback(condition, affect!)

        jprob = JumpProblem(prob, Direct(), noop_jump; callback = cb)
        sol = solve(jprob, EM(); dt = 0.01, tstops = [2.0])
        @test 2.0 ∈ sol.t
        # Verify callback fired: u was 1.0 before, should be 42.0 after
        idx = findfirst(==(2.0), sol.t)
        @test sol.u[idx + 1][1] == 42.0
    end

    @testset "callback from JumpProblem.kwargs fires exactly once" begin
        prob = SDEProblem(f!, g!, [1.0], (0.0, 5.0))

        fire_count = Ref(0)
        cb_cond(u, t, integrator) = t == 2.0
        cb_affect!(integrator) = (fire_count[] += 1; integrator.u[1] = 42.0)
        cb = DiscreteCallback(cb_cond, cb_affect!)

        jprob = JumpProblem(prob, Direct(), noop_jump; callback = cb)
        fire_count[] = 0
        sol = solve(jprob, EM(); dt = 0.01, tstops = [2.0])
        @test fire_count[] == 1
    end

    @testset "callback merging between JumpProblem.kwargs and solve kwargs" begin
        prob = SDEProblem(f!, g!, [1.0], (0.0, 5.0))

        # Callback in jprob.kwargs (stored natively by JumpProblem constructor)
        cb1_cond(u, t, integrator) = t == 2.0
        cb1_affect!(integrator) = (integrator.u[1] = 42.0)
        cb1 = DiscreteCallback(cb1_cond, cb1_affect!)

        jprob = JumpProblem(prob, Direct(), noop_jump; callback = cb1)

        # Callback in solve kwargs
        cb2_cond(u, t, integrator) = t == 4.0
        cb2_affect!(integrator) = (integrator.u[1] = 99.0)
        cb2 = DiscreteCallback(cb2_cond, cb2_affect!)

        sol = solve(jprob, EM(); dt = 0.01, tstops = [2.0, 4.0], callback = cb2)

        # Both callbacks should have fired
        idx2 = findfirst(==(2.0), sol.t)
        @test sol.u[idx2 + 1][1] == 42.0
        idx4 = findfirst(==(4.0), sol.t)
        @test sol.u[idx4 + 1][1] == 99.0
    end

    @testset "merged callbacks each fire exactly once" begin
        prob = SDEProblem(f!, g!, [1.0], (0.0, 5.0))

        fire_a = Ref(0)
        fire_b = Ref(0)

        cb_a = DiscreteCallback(
            (u, t, integrator) -> t == 2.0,
            integrator -> (fire_a[] += 1)
        )

        jprob = JumpProblem(prob, Direct(), noop_jump; callback = cb_a)

        cb_b = DiscreteCallback(
            (u, t, integrator) -> t == 4.0,
            integrator -> (fire_b[] += 1)
        )

        fire_a[] = 0
        fire_b[] = 0
        sol = solve(jprob, EM(); dt = 0.01, tstops = [2.0, 4.0], callback = cb_b)
        @test fire_a[] == 1
        @test fire_b[] == 1
    end

    @testset "tstops are not duplicated" begin
        prob = SDEProblem(f!, g!, [10.0], (0.0, 10.0))
        jprob = JumpProblem(prob, Direct(), noop_jump)
        sol = solve(jprob, EM(); dt = 0.1, tstops = [3.0, 7.0])
        @test count(==(3.0), sol.t) == 1
        @test count(==(7.0), sol.t) == 1
    end

    @testset "callback from JumpProblem.kwargs forwarded via init" begin
        prob = SDEProblem(f!, g!, [1.0], (0.0, 5.0))

        condition(u, t, integrator) = t == 2.0
        affect!(integrator) = (integrator.u[1] = 42.0)
        cb = DiscreteCallback(condition, affect!)

        jprob = JumpProblem(prob, Direct(), noop_jump; callback = cb)
        integrator = init(jprob, EM(); dt = 0.01, tstops = [2.0])
        solve!(integrator)
        idx = findfirst(==(2.0), integrator.sol.t)
        @test integrator.sol.u[idx + 1][1] == 42.0
    end

    # JumpProcesses 9.22+ stores tstops passed to JumpProblem() in jprob.kwargs.
    # These tests verify that tstops from jprob.kwargs are forwarded to the solver.

    @testset "tstops from JumpProblem.kwargs are forwarded via solve" begin
        prob = SDEProblem(f!, g!, [10.0], (0.0, 10.0))
        jprob = JumpProblem(prob, Direct(), noop_jump; tstops = [3.0, 7.0])
        sol = solve(jprob, EM(); dt = 0.1)
        @test 3.0 ∈ sol.t
        @test 7.0 ∈ sol.t
    end

    @testset "tstops from JumpProblem.kwargs are forwarded via init" begin
        prob = SDEProblem(f!, g!, [10.0], (0.0, 10.0))
        jprob = JumpProblem(prob, Direct(), noop_jump; tstops = [3.0, 7.0])
        integrator = init(jprob, EM(); dt = 0.1)
        solve!(integrator)
        @test 3.0 ∈ integrator.sol.t
        @test 7.0 ∈ integrator.sol.t
    end

    @testset "tstops from JumpProblem.kwargs are not duplicated" begin
        prob = SDEProblem(f!, g!, [10.0], (0.0, 10.0))
        jprob = JumpProblem(prob, Direct(), noop_jump; tstops = [3.0, 7.0])
        sol = solve(jprob, EM(); dt = 0.1)
        @test count(==(3.0), sol.t) == 1
        @test count(==(7.0), sol.t) == 1
    end

    @testset "tstops from JumpProblem.kwargs with event that depends on them" begin
        prob = SDEProblem(f!, g!, [1.0], (0.0, 5.0))

        # Event at t == 2.0 that sets u to 42.0 — only fires if tstops ensures
        # the solver steps exactly at t = 2.0
        condition(u, t, integrator) = t == 2.0
        affect!(integrator) = (integrator.u[1] = 42.0)
        cb = DiscreteCallback(condition, affect!)

        # Both tstops and callback stored in jprob.kwargs — nothing extra to solve
        jprob = JumpProblem(
            prob, Direct(), noop_jump;
            tstops = [2.0], callback = cb
        )
        sol = solve(jprob, EM(); dt = 0.01)
        @test 2.0 ∈ sol.t
        idx = findfirst(==(2.0), sol.t)
        @test sol.u[idx + 1][1] == 42.0
    end

    @testset "callable tstops from JumpProblem.kwargs are forwarded" begin
        prob = SDEProblem(f!, g!, [1.0], (0.0, 5.0), [0.5])

        my_tstops = (p, tspan) -> [p[1] * 4.0]  # tstop at 2.0
        condition(u, t, integrator) = t == 2.0
        affect!(integrator) = (integrator.u[1] = 42.0)
        cb = DiscreteCallback(condition, affect!)

        jprob = JumpProblem(prob, Direct(), noop_jump; tstops = my_tstops, callback = cb)
        sol = solve(jprob, EM(); dt = 0.01)
        @test 2.0 ∈ sol.t
        idx = findfirst(==(2.0), sol.t)
        @test sol.u[idx + 1][1] == 42.0
    end

    # merge_problem_kwargs gives priority to solve kwargs over prob.kwargs for
    # non-callback kwargs (only callbacks get special merging). Verify solve-level
    # tstops take precedence when both sources provide tstops.
    @testset "solve tstops take precedence over JumpProblem.kwargs tstops" begin
        prob = SDEProblem(f!, g!, [10.0], (0.0, 10.0))
        jprob = JumpProblem(prob, Direct(), noop_jump; tstops = [3.0])
        sol = solve(jprob, EM(); dt = 0.1, tstops = [7.0])
        @test 7.0 ∈ sol.t
        @test count(==(7.0), sol.t) == 1
    end

    @testset "tstops forwarding with adaptive SDE solver (SOSRI)" begin
        f_drift!(du, u, p, t) = (du[1] = -0.5 * u[1])
        g_noise!(du, u, p, t) = (du[1] = 0.1 * u[1])
        prob = SDEProblem(f_drift!, g_noise!, [1.0], (0.0, 5.0))
        jprob = JumpProblem(prob, Direct(), noop_jump)
        sol = solve(jprob, SOSRI(); tstops = [1.5, 3.5])
        @test 1.5 ∈ sol.t
        @test 3.5 ∈ sol.t
    end

    @testset "tstops forwarding with RODE solver" begin
        f_rode(u, p, t, W) = 1.01u + 0.87u * W
        prob = RODEProblem(f_rode, 1.0, (0.0, 5.0))
        jprob = JumpProblem(prob, Direct(), noop_jump)
        sol = solve(jprob, RandomEM(); dt = 0.01, tstops = [2.0, 4.0])
        @test 2.0 ∈ sol.t
        @test 4.0 ∈ sol.t
    end
end

using StochasticDiffEq, DiffEqDevTools, Test, Random
using SDEProblemLibrary: prob_sde_wave, prob_sde_cubic, prob_sde_additive
Random.seed!(100)
dts = (1 / 2) .^ (10:-1:2) #14->7 good plot

print("prob_sde_wave")
prob = prob_sde_wave
solve(prob, ImplicitEM(), dt = 0.1)
sim = test_convergence(dts, prob, ImplicitEM(), trajectories = Int(1.0e1))
@test abs(sim.𝒪est[:l2] - 0.5) < 0.2
sim = test_convergence(
    dts, prob, ImplicitEM(nlsolve = StochasticDiffEq.NLFunctional()), trajectories = Int(1.0e1)
)
@test abs(sim.𝒪est[:l2] - 0.5) < 0.2
sim = test_convergence(dts, prob, ImplicitRKMil(), trajectories = Int(1.0e2))
@test abs(sim.𝒪est[:l2] - 1) < 0.2
sim = test_convergence(dts, prob, EM(), trajectories = Int(1.0e2))
@test abs(sim.𝒪est[:l2] - 0.5) < 0.2
sim = test_convergence(dts, prob, ISSEM(), trajectories = Int(1.0e2))
@test abs(sim.𝒪est[:l2] - 0.5) < 0.2
sim = test_convergence(dts, prob, ISSEM(nlsolve = StochasticDiffEq.NLFunctional()), trajectories = Int(1.0e2))
@test abs(sim.𝒪est[:l2] - 0.5) < 0.2
sim = test_convergence(dts, prob, LambaEM(), trajectories = Int(1.0e2))
@test abs(sim.𝒪est[:l2] - 0.5) < 0.2
sim2 = test_convergence(dts, prob, RKMil(), trajectories = Int(2.0e2))
@test abs(sim2.𝒪est[:l∞] - 1) < 0.2
sim2 = test_convergence(dts, prob, RKMilCommute(), trajectories = Int(2.0e2))
@test abs(sim2.𝒪est[:l∞] - 1) < 0.2
sim2 = test_convergence(dts, prob, RKMilGeneral(), trajectories = Int(2.0e2))
@test abs(sim2.𝒪est[:l∞] - 1) < 0.2
print(".")
sim2 = test_convergence(dts, prob, WangLi3SMil_A(), trajectories = Int(2.0e2))
@test abs(sim2.𝒪est[:l∞] - 1) < 0.2
sim2 = test_convergence(dts, prob, WangLi3SMil_B(), trajectories = Int(2.0e2))
@test abs(sim2.𝒪est[:l∞] - 1) < 0.2
sim2 = test_convergence(dts, prob, WangLi3SMil_C(), trajectories = Int(2.0e2))
@test abs(sim2.𝒪est[:l∞] - 1) < 0.2
sim2 = test_convergence(dts, prob, WangLi3SMil_D(), trajectories = Int(2.0e2))
@test abs(sim2.𝒪est[:l∞] - 1) < 0.2
sim2 = test_convergence(dts, prob, WangLi3SMil_E(), trajectories = Int(2.0e2))
@test abs(sim2.𝒪est[:l∞] - 1) < 0.2
sim2 = test_convergence(dts, prob, WangLi3SMil_F(), trajectories = Int(2.0e2))
@test abs(sim2.𝒪est[:l∞] - 1) < 0.2
print(".")
eigen_est = (integrator) -> integrator.eigen_est = 10.0
sim2 = test_convergence(dts, prob, SROCK1(), trajectories = Int(2.0e2))
@test abs(sim2.𝒪est[:l∞] - 1) < 0.2
sim2 = test_convergence(dts, prob, SROCK1(eigen_est = eigen_est), trajectories = Int(2.0e2))
@test abs(sim2.𝒪est[:l∞] - 1) < 0.2
sim2 = test_convergence(dts, prob, SROCK2(), trajectories = Int(2.0e2))
@test abs(sim2.𝒪est[:l∞] - 1) < 0.2
sim2 = test_convergence(dts, prob, SROCK2(eigen_est = eigen_est), trajectories = Int(2.0e2))
@test abs(sim2.𝒪est[:l∞] - 1) < 0.2
sim2 = test_convergence(dts, prob, SROCKEM(strong_order_1 = false), trajectories = Int(2.0e2))
@test abs(sim2.𝒪est[:l∞] - 0.5) < 0.2
sim2 = test_convergence(dts, prob, SROCKEM(eigen_est = eigen_est), trajectories = Int(2.0e2))
@test abs(sim2.𝒪est[:l∞] - 1) < 0.2
sim2 = test_convergence(dts, prob, SROCKEM(), trajectories = Int(2.0e2))
@test abs(sim2.𝒪est[:l∞] - 1) < 0.2
sim2 = test_convergence(dts, prob, SKSROCK(eigen_est = eigen_est), trajectories = Int(2.0e2))
@test abs(sim2.𝒪est[:l∞] - 0.5) < 0.2
sim2 = test_convergence(dts, prob, SKSROCK(), trajectories = Int(2.0e2))
@test abs(sim2.𝒪est[:l∞] - 0.5) < 0.2
sim2 = test_convergence(dts, prob, SROCKC2(eigen_est = eigen_est), trajectories = Int(2.0e2))
@test abs(sim2.𝒪est[:l∞] - 1) < 0.2
sim2 = test_convergence(dts, prob, SROCKC2(), trajectories = Int(2.0e2))
@test abs(sim2.𝒪est[:l∞] - 1) < 0.2

#omitting tests for incomplete methods
# sim = test_convergence(dts,prob,TangXiaoSROCK2(version_num=1),trajectories=Int(2e2))
# @test abs(sim.𝒪est[:l∞]- 1) < 0.2
# sim = test_convergence(dts,prob,TangXiaoSROCK2(version_num=2),trajectories=Int(2e2))
# @test abs(sim.𝒪est[:l∞]- 1) < 0.2
# sim = test_convergence(dts,prob,TangXiaoSROCK2(version_num=3),trajectories=Int(2e2))
# @test abs(sim.𝒪est[:l∞]- 1) < 0.2
# sim = test_convergence(dts,prob,TangXiaoSROCK2(version_num=4),trajectories=Int(2e2))
# @test abs(sim.𝒪est[:l∞]- 1) < 0.2
# sim = test_convergence(dts,prob,TangXiaoSROCK2(version_num=5),trajectories=Int(2e2))
# @test abs(sim.𝒪est[:l∞]- 1) < 0.2

sim3 = test_convergence(dts, prob, SRI(), trajectories = Int(1.0e1))
@test abs(sim3.𝒪est[:final] - 1.5) < 0.3
sim4 = test_convergence(dts, prob, SRIW1(), trajectories = Int(1.0e1))
@test abs(sim4.𝒪est[:final] - 1.5) < 0.3
sim5 = test_convergence(dts, prob, SRIW2(), trajectories = Int(1.0e1))
@test abs(sim5.𝒪est[:final] - 1.5) < 0.3
sim6 = test_convergence(dts, prob, SOSRI(), trajectories = Int(1.0e1))
@test abs(sim6.𝒪est[:final] - 1.5) < 0.3
sim7 = test_convergence(dts, prob, SOSRI2(), trajectories = Int(1.0e1))
@test abs(sim7.𝒪est[:final] - 1.5) < 0.3
println()

print("prob_sde_cubic")
prob = prob_sde_cubic
sim = test_convergence(dts, prob, EM(), trajectories = Int(1.0e1))
@test abs(sim.𝒪est[:l2] - 0.5) < 0.2
sim = test_convergence(dts, prob, LambaEM(), trajectories = Int(1.0e1))
@test abs(sim.𝒪est[:l2] - 0.5) < 0.2
sim = test_convergence(dts, prob, ISSEM(), trajectories = Int(1.0e2))
@test abs(sim.𝒪est[:l2] - 0.5) < 0.2
sim = test_convergence(dts, prob, ImplicitEM(), trajectories = Int(1.0e2))
@test abs(sim.𝒪est[:l2] - 0.5) < 0.2
sim = test_convergence(dts, prob, ImplicitRKMil(), trajectories = Int(1.0e2))
@test abs(sim.𝒪est[:l2] - 1) < 0.2
sim2 = test_convergence(dts, prob, RKMil(), trajectories = Int(1.0e2))
@test abs(sim2.𝒪est[:l∞] - 1) < 0.22
sim2 = test_convergence(dts, prob, RKMilCommute(), trajectories = Int(1.0e2))
@test abs(sim2.𝒪est[:l∞] - 1) < 0.22
sim2 = test_convergence(dts, prob, RKMilGeneral(), trajectories = Int(1.0e2))
@test abs(sim2.𝒪est[:l∞] - 1) < 0.22
print(".")
sim2 = test_convergence(dts, prob, WangLi3SMil_A(), trajectories = Int(2.0e2))
@test abs(sim2.𝒪est[:l∞] - 1) < 0.2
sim2 = test_convergence(dts, prob, WangLi3SMil_B(), trajectories = Int(2.0e2))
@test abs(sim2.𝒪est[:l∞] - 1) < 0.2
sim2 = test_convergence(dts, prob, WangLi3SMil_C(), trajectories = Int(2.0e2))
@test abs(sim2.𝒪est[:l∞] - 1) < 0.2
sim2 = test_convergence(dts, prob, WangLi3SMil_D(), trajectories = Int(2.0e2))
@test abs(sim2.𝒪est[:l∞] - 1) < 0.2
sim2 = test_convergence(dts, prob, WangLi3SMil_E(), trajectories = Int(2.0e2))
@test abs(sim2.𝒪est[:l∞] - 1) < 0.2
sim2 = test_convergence(dts, prob, WangLi3SMil_F(), trajectories = Int(2.0e2))
@test abs(sim2.𝒪est[:l∞] - 1) < 0.2
print(".")
sim2 = test_convergence(dts, prob, SROCK1(), trajectories = Int(2.0e2))
@test abs(sim2.𝒪est[:l∞] - 1) < 0.2
sim2 = test_convergence(dts, prob, SROCK2(), trajectories = Int(2.0e2))
@test abs(sim2.𝒪est[:l∞] - 1) < 0.2
sim2 = test_convergence(dts, prob, SROCKEM(strong_order_1 = false), trajectories = Int(2.0e2))
@test abs(sim2.𝒪est[:l∞] - 0.5) < 0.2
sim2 = test_convergence(dts, prob, SROCKEM(), trajectories = Int(2.0e2))
@test abs(sim2.𝒪est[:l∞] - 1) < 0.2
sim2 = test_convergence(dts, prob, SKSROCK(), trajectories = Int(2.0e2))
@test abs(sim2.𝒪est[:l∞] - 0.5) < 0.2
sim2 = test_convergence(dts, prob, SROCKC2(), trajectories = Int(2.0e2))
@test abs(sim2.𝒪est[:l∞] - 1) < 0.2

#omitting tests for incomplete methods
# sim = test_convergence(dts,prob,TangXiaoSROCK2(version_num=1),trajectories=Int(2e2))
# @test abs(sim.𝒪est[:l∞]- 1) < 0.2
# sim = test_convergence(dts,prob,TangXiaoSROCK2(version_num=2),trajectories=Int(2e2))
# @test abs(sim.𝒪est[:l∞]- 1) < 0.2
# sim = test_convergence(dts,prob,TangXiaoSROCK2(version_num=3),trajectories=Int(2e2))
# @test abs(sim.𝒪est[:l∞]- 1) < 0.2
# sim = test_convergence(dts,prob,TangXiaoSROCK2(version_num=4),trajectories=Int(2e2))
# @test abs(sim.𝒪est[:l∞]- 1) < 0.2
# sim = test_convergence(dts,prob,TangXiaoSROCK2(version_num=5),trajectories=Int(2e2))
# @test abs(sim.𝒪est[:l∞]- 1) < 0.2

sim3 = test_convergence(dts, prob, SRI(), trajectories = Int(1.0e1))
@test abs(sim3.𝒪est[:final] - 1.5) < 0.3
sim4 = test_convergence(dts, prob, SRIW1(), trajectories = Int(1.0e1))
@test abs(sim4.𝒪est[:final] - 1.5) < 0.3
sim5 = test_convergence(dts, prob, SRIW2(), trajectories = Int(1.0e1))
@test abs(sim5.𝒪est[:final] - 1.5) < 0.3
sim6 = test_convergence(dts, prob, SOSRI(), trajectories = Int(1.0e1))
@test abs(sim6.𝒪est[:final] - 1.5) < 0.3
sim7 = test_convergence(dts, prob, SOSRI2(), trajectories = Int(1.0e1))
@test abs(sim7.𝒪est[:final] - 1.5) < 0.3
println()

print("prob_sde_additive")
prob = prob_sde_additive
sim = test_convergence(dts, prob, EM(), trajectories = Int(1.0e1))
@test abs(sim.𝒪est[:l2] - 1) < 0.2
sim = test_convergence(dts, prob, LambaEM(), trajectories = Int(1.0e1))
@test abs(sim.𝒪est[:l2] - 1) < 0.2
dts = (1 / 2) .^ (10:-1:1)
sim = test_convergence(dts, prob, ISSEM(), trajectories = Int(1.0e3))
@test abs(sim.𝒪est[:l2] - 1) < 0.2
sim = test_convergence(dts, prob, ImplicitEM(), trajectories = Int(1.0e2))
@test abs(sim.𝒪est[:l2] - 1) < 0.2
sim = test_convergence(dts, prob, ImplicitRKMil(), trajectories = Int(1.0e2))
@test abs(sim.𝒪est[:l2] - 1) < 0.2
sim2 = test_convergence(dts, prob, RKMil(), trajectories = Int(1.0e1))
@test abs(sim2.𝒪est[:l∞] - 1) < 0.2
sim2 = test_convergence(dts, prob, RKMilCommute(), trajectories = Int(1.0e1))
@test abs(sim2.𝒪est[:l∞] - 1) < 0.2
sim2 = test_convergence(dts, prob, RKMilGeneral(), trajectories = Int(1.0e1))
@test abs(sim2.𝒪est[:l∞] - 1) < 0.2
print(".")
sim2 = test_convergence(dts, prob, WangLi3SMil_A(), trajectories = Int(2.0e2))
@test abs(sim2.𝒪est[:l∞] - 1) < 0.2
sim2 = test_convergence(dts, prob, WangLi3SMil_B(), trajectories = Int(2.0e2))
@test abs(sim2.𝒪est[:l∞] - 1) < 0.2
sim2 = test_convergence(dts, prob, WangLi3SMil_C(), trajectories = Int(2.0e2))
@test abs(sim2.𝒪est[:l∞] - 1) < 0.2
sim2 = test_convergence(dts, prob, WangLi3SMil_D(), trajectories = Int(2.0e2))
@test abs(sim2.𝒪est[:l∞] - 1) < 0.2
sim2 = test_convergence(dts, prob, WangLi3SMil_E(), trajectories = Int(2.0e2))
@test abs(sim2.𝒪est[:l∞] - 1) < 0.2
sim2 = test_convergence(dts, prob, WangLi3SMil_F(), trajectories = Int(2.0e2))
@test abs(sim2.𝒪est[:l∞] - 1) < 0.2
print(".")
sim2 = test_convergence(dts, prob, SROCK1(), trajectories = Int(1.0e2))
@test abs(sim2.𝒪est[:l∞] - 1) < 0.2
sim2 = test_convergence(dts, prob, SROCK2(), trajectories = Int(1.0e2))
@test abs(sim2.𝒪est[:l∞] - 2) < 0.2
@time sim2 = test_convergence(dts, prob, SROCKEM(strong_order_1 = false), trajectories = Int(1.0e2))
@test abs(sim2.𝒪est[:l∞] - 1) < 0.2
@time sim2 = test_convergence(dts, prob, SROCKEM(), trajectories = Int(1.0e2))
@test abs(sim2.𝒪est[:l∞] - 1) < 0.2
sim2 = test_convergence(dts, prob, SKSROCK(), trajectories = Int(1.0e2))
@test abs(sim2.𝒪est[:l∞] - 1) < 0.2

dts = (1 / 2) .^ (10:-1:4)
sim2 = test_convergence(dts, prob, SROCKC2(), trajectories = Int(2.0e2))
@test abs(sim2.𝒪est[:l∞] - 1) < 0.2
dts = (1 / 2) .^ (10:-1:2)

#omitting tests for incomplete methods
# sim = test_convergence(dts,prob,TangXiaoSROCK2(version_num=1),trajectories=Int(2e2))
# @test abs(sim.𝒪est[:l∞]- 1) < 0.2
# sim = test_convergence(dts,prob,TangXiaoSROCK2(version_num=2),trajectories=Int(2e2))
# @test abs(sim.𝒪est[:l∞]- 1) < 0.2
# sim = test_convergence(dts,prob,TangXiaoSROCK2(version_num=3),trajectories=Int(2e2))
# @test abs(sim.𝒪est[:l∞]- 1) < 0.2
# sim = test_convergence(dts,prob,TangXiaoSROCK2(version_num=4),trajectories=Int(2e2))
# @test abs(sim.𝒪est[:l∞]- 1) < 0.2
# sim = test_convergence(dts,prob,TangXiaoSROCK2(version_num=5),trajectories=Int(2e2))
# @test abs(sim.𝒪est[:l∞]- 1) < 0.2

sim3 = test_convergence(dts, prob, SRI(), trajectories = Int(1.0e1))
@test abs(sim3.𝒪est[:final] - 2) < 0.3
sim3 = test_convergence(dts, prob, SRIW2(), trajectories = Int(1.0e1))
@test abs(sim3.𝒪est[:final] - 2) < 0.3

sim3 = test_convergence(dts, prob, SOSRI(), trajectories = Int(1.0e1))
@test abs(sim3.𝒪est[:final] - 2) < 0.3
sim3 = test_convergence(dts, prob, SOSRI2(), trajectories = Int(1.0e1))
@test abs(sim3.𝒪est[:final] - 2) < 0.3
print(".")
sim4 = test_convergence(dts, prob, SRA(), trajectories = Int(1.0e1))
@test abs(sim4.𝒪est[:final] - 2) < 0.3
sim5 = test_convergence(dts, prob, SRA1(), trajectories = Int(1.0e1))
@test abs(sim5.𝒪est[:final] - 2) < 0.3
sim6 = test_convergence(dts, prob, SRA2(), trajectories = Int(1.0e1))
@test abs(sim6.𝒪est[:final] - 2) < 0.3
sim7 = test_convergence(dts, prob, SRA3(), trajectories = Int(1.0e1))
@test abs(sim7.𝒪est[:final] - 2.5) < 0.3
sim8 = test_convergence(dts, prob, SOSRA(), trajectories = Int(1.0e1))
@test abs(sim8.𝒪est[:final] - 2) < 0.3
sim9 = test_convergence(dts, prob, SOSRA2(), trajectories = Int(1.0e1))
@test abs(sim9.𝒪est[:final] - 2) < 0.3
print(".")
dts = (1 / 2) .^ (10:-1:5) #14->7 good plot
sim10 = test_convergence(dts, prob, SKenCarp(), trajectories = Int(1.0e1))
@test abs(sim10.𝒪est[:final] - 2) < 0.3
sim10 = test_convergence(
    dts, prob, SKenCarp(nlsolve = StochasticDiffEq.NLFunctional()), trajectories = Int(1.0e1)
)
@test abs(sim10.𝒪est[:final] - 2) < 0.3

sim2 = test_convergence(dts, prob, SRA(tableau = StochasticDiffEq.constructSRA2()), trajectories = Int(1.0e1))
@test abs(sim2.𝒪est[:final] - 2) < 0.3
sim3 = test_convergence(dts, prob, SRA(tableau = StochasticDiffEq.constructSRA3()), trajectories = Int(1.0e2))
@test abs(sim3.𝒪est[:final] - 2.0) < 0.3
sim6 = test_convergence(dts, prob, SRIW1(), trajectories = Int(1.0e1))
@test abs(sim6.𝒪est[:final] - 2) < 0.3
sim2 = test_convergence(
    dts, prob, SRA(tableau = StochasticDiffEq.constructExplicitSKenCarp()),
    trajectories = Int(1.0e1)
)
@test abs(sim2.𝒪est[:final] - 2) < 0.3
println(".")

using StochasticDiffEq, DiffEqDevTools, Test, Random
using SDEProblemLibrary: prob_sde_additive, prob_sde_additivesystem
Random.seed!(100)

println("Bunch of additive solves")

f_bm(u, p, t) = 0.0
f_analytic_bm(u0, p, t, W) = W
g_bm(u, p, t) = 1.0
prob = SDEProblem(SDEFunction(f_bm, g_bm, analytic = f_analytic_bm), 0.0, (0.0, 1.0))
sol1 = solve(prob, SRA1(), dt = 1 / 2^(3), adaptive = false)
sol2 = solve(prob, SOSRA(), dt = 1 / 2^(3), adaptive = false)
sol3 = solve(prob, SKenCarp(), dt = 1 / 2^(3), adaptive = false)
@test sol1.errors[:l2] ≈ 0.0 atol = 1.0e-14
@test sol2.errors[:l2] ≈ 0.0 atol = 1.0e-14
@test sol3.errors[:l2] ≈ 0.0 atol = 1.0e-14

prob = prob_sde_additive

# Test error in stepping and seeding simultaneously
sol = solve(prob, SRA(StochasticDiffEq.constructSOSRA()), dt = 1 / 2^(3), seed = 1)
sol2 = solve(prob, SOSRA(), dt = 1 / 2^(3), seed = 1)
@test sol.t ≈ sol2.t

sol = solve(prob, SRA1(), dt = 1 / 2^(3))
sol = solve(prob, SRA2(), dt = 1 / 2^(3))
sol = solve(prob, SRA3(), dt = 1 / 2^(3))
sol = solve(prob, SOSRA(), dt = 1 / 2^(3))
sol = solve(prob, SOSRA2(), dt = 1 / 2^(3))
sol = solve(prob, SKenCarp(), dt = 1 / 2^(3))
sol = solve(prob, SKenCarp(nlsolve = StochasticDiffEq.NLNewton()), dt = 1 / 2^(3))

prob = prob_sde_additivesystem

sol1 = solve(prob, SKenCarp())
sol2 = solve(prob, SKenCarp(ode_error_est = false))
@test length(sol1) < 50
@test length(sol2) < 100

sol = solve(prob, SRA(), dt = 1 / 2^(3))
sol = solve(prob, SRA1(), dt = 1 / 2^(3))
sol = solve(prob, SRA2(), dt = 1 / 2^(3))
sol = solve(prob, SRA3(), dt = 1 / 2^(3))
sol = solve(prob, SOSRA(), dt = 1 / 2^(3))
sol = solve(prob, SOSRA2(), dt = 1 / 2^(3))
sol = solve(prob, SKenCarp(), dt = 1 / 2^(3))

## Convergence Testing
println("Convergence Test on MultiDimAdditive")
dts = (1 / 2) .^ (7:-1:4) #14->7 good plot

sim = test_convergence(dts, prob, SRA(), trajectories = 100)
@test abs(sim.𝒪est[:l2] - 2) < 0.1
sim2 = test_convergence(dts, prob, SRA1(), trajectories = 100)
@test abs(sim2.𝒪est[:l∞] - 2) < 0.1 #High tolerance since low dts for testing!
sim2 = test_convergence(dts, prob, SRA2(), trajectories = 100)
@test abs(sim2.𝒪est[:l∞] - 2) < 0.1 #High tolerance since low dts for testing!
sim2 = test_convergence(dts, prob, SRA3(), trajectories = 100)
@test abs(sim2.𝒪est[:l∞] - 2) < 0.1 #High tolerance since low dts for testing!
sim2 = test_convergence(dts, prob, SOSRA(), trajectories = 100)
@test abs(sim2.𝒪est[:l∞] - 2) < 0.1 #High tolerance since low dts for testing!
sim2 = test_convergence(dts, prob, SOSRA2(), trajectories = 100)
@test abs(sim2.𝒪est[:l∞] - 2) < 0.1 #High tolerance since low dts for testing!
dts = (1 / 2) .^ (14:-1:11) #14->7 good plot
Random.seed!(100)
sim2 = test_convergence(dts, prob, SKenCarp(), trajectories = 100)
@test abs(sim2.𝒪est[:l∞] - 2) < 0.1 #High tolerance since low dts for testing!
sim2 = test_convergence(dts, prob, SKenCarp(nlsolve = StochasticDiffEq.NLFunctional()), trajectories = 100)
@test abs(sim2.𝒪est[:l∞] - 2) < 0.1 #High tolerance since low dts for testing!

using StochasticDiffEq, OrdinaryDiffEq, Test
import SciMLBase

function f(du, u, p, t)
    return du[1] = u[1]
end
function g(du, u, p, t)
    return 0.0
end

u0 = [1.0]
prob = SDEProblem{true}(f, g, u0, (0.0, 0.1))

sol_ito = solve(prob, RKMil{SciMLBase.AlgorithmInterpretation.Ito}())
@test length(sol_ito) < 100

sol_strato = solve(prob, RKMil{SciMLBase.AlgorithmInterpretation.Stratonovich}(); dt = 1.0e-2)
@test length(sol_strato) < 100

sol_ito = solve(prob, RKMil())
@test length(sol_ito) < 100

sol_strato = solve(prob, RKMil(interpretation = SciMLBase.AlgorithmInterpretation.Stratonovich); dt = 1.0e-2)
@test length(sol_strato) < 100

sol_leh = solve(prob, LambaEulerHeun())
@test length(sol_leh) < 100

# Test that SDE solvers with zero noise converge to the same solution as ODE solvers
# Regression test for issue #636: ImplicitRKMil error estimation bug
# https://github.com/SciML/StochasticDiffEq.jl/issues/636

# Linear decay system: du/dt = -λu with λ = 1 (mildly stiff)
# Analytic solution: u(t) = u0 * exp(-λt)
function linear_decay!(du, u, p, t)
    λ = p
    du[1] = -λ * u[1]
    return du[2] = -λ * u[2]
end

function zero_noise_linear!(du, u, p, t)
    return du .= 0
end

# Parameters - use λ=1 for mild stiffness (faster tests)
λ = 1.0
p_decay = λ
u0_decay = [1.0, 2.0]
tspan_decay = (0.0, 1.0)

# Create SDE and ODE problems
sde_prob_decay = SDEProblem(
    linear_decay!, zero_noise_linear!, u0_decay, tspan_decay, p_decay
)
ode_prob_decay = ODEProblem(linear_decay!, u0_decay, tspan_decay, p_decay)

# Analytic solution for reference
analytic_endpoint = u0_decay .* exp(-λ * tspan_decay[2])

# Solve with ODE solver to verify setup
abstol_decay = 1.0e-4
reltol_decay = 1.0e-4
sol_ode_decay = solve(ode_prob_decay, Rodas5(), abstol = abstol_decay, reltol = reltol_decay)
@test isapprox(sol_ode_decay.u[end], analytic_endpoint, rtol = 1.0e-3)

# Test implicit SDE solvers that were fixed in this PR
# These should now converge to the same solution as the ODE solver

# ImplicitRKMil (the main solver from issue #636)
sol_implicitRKMil = solve(sde_prob_decay, ImplicitRKMil(), abstol = abstol_decay, reltol = reltol_decay)
@test isapprox(sol_implicitRKMil.u[end], analytic_endpoint, rtol = 0.05)

# ImplicitEM
sol_implicitEM = solve(sde_prob_decay, ImplicitEM(), abstol = abstol_decay, reltol = reltol_decay)
@test isapprox(sol_implicitEM.u[end], analytic_endpoint, rtol = 0.05)

# ImplicitEulerHeun
sol_implicitEulerHeun = solve(sde_prob_decay, ImplicitEulerHeun(), abstol = abstol_decay, reltol = reltol_decay)
@test isapprox(sol_implicitEulerHeun.u[end], analytic_endpoint, rtol = 0.05)

# Test other SDE solvers for consistency

# SKenCarp (stiff SDE solver)
sol_SKenCarp = solve(sde_prob_decay, SKenCarp(), abstol = abstol_decay, reltol = reltol_decay)
@test isapprox(sol_SKenCarp.u[end], analytic_endpoint, rtol = 0.05)

# ISSEM (semi-implicit)
sol_ISSEM = solve(sde_prob_decay, ISSEM(), abstol = abstol_decay, reltol = reltol_decay)
@test isapprox(sol_ISSEM.u[end], analytic_endpoint, rtol = 0.05)

# SOSRI (default adaptive SDE solver, known to work correctly)
sol_SOSRI = solve(sde_prob_decay, SOSRI(), abstol = abstol_decay, reltol = reltol_decay)
@test isapprox(sol_SOSRI.u[end], analytic_endpoint, rtol = 0.05)

# SOSRA
sol_SOSRA = solve(sde_prob_decay, SOSRA(), abstol = abstol_decay, reltol = reltol_decay)
@test isapprox(sol_SOSRA.u[end], analytic_endpoint, rtol = 0.05)

using StaticArrays, StochasticDiffEq, Test

f(du, u, p, t) = (du .= u)

u0 = zeros(MVector{2, Float64}, 2) .+ (ones(2),)
u0[1] = ones(MVector{2, Float64}) .+ ones(2)
ode = SDEProblem(f, f, u0, (0.0, 1.0))
@test_broken sol = solve(ode, EM(), dt = 1.0e-2)
@test_broken sol = solve(ode, SRIW1())

u0 = zeros(SVector{2, Float64}, 2) .+ (ones(2),)
u0[1] = ones(SVector{2, Float64}) .+ ones(2)
ode = SDEProblem(f, f, u0, (0.0, 1.0))
@test_broken sol = solve(ode, EM(), dt = 1.0e-2)
@test_broken sol = solve(ode, SRIW1(), dt = 1.0e-2)

u0 = ones(MVector{2, Float64})
ode = SDEProblem(f, f, u0, (0.0, 1.0))
sol = solve(ode, EM(), dt = 1.0e-2)
sol = solve(ode, SRIW1())

u0 = ones(SVector{2, Float64})
f(u, p, t) = u
prob = SDEProblem(f, f, u0, (0.0, 1.0))
sol = solve(ode, EM(), dt = 1.0e-2)
sol = solve(ode, SRIW1())

using JumpProcesses, StochasticDiffEq, Test

# Requires threads to be effective
# https://github.com/SciML/DifferentialEquations.jl/issues/854
using Base.Threads
@test Threads.nthreads() > 1

function testdrift!(du, u, p, t)
    return du[1] = u[1]
end

function testdiffusion!(du, u, p, t)
    return du[1] = u[1]
end

function testrate(u, p, t)
    return 0.32
end

function testaffect!(integrator)
    return integrator.u[1] += integrator.u[1] * randn()
end

testjump = ConstantRateJump(testrate, testaffect!)

test_sdeprob = SDEProblem(
    testdrift!,
    testdiffusion!,
    [1.0],
    (0.0, 1.0)
)

test_jumpprob = JumpProblem(
    test_sdeprob,
    Direct(),
    testjump
)

test_ensemprob = EnsembleProblem(test_jumpprob)

test_ensemsim = solve(
    test_ensemprob,
    EM(),
    dt = 0.01,
    EnsembleThreads();
    trajectories = 1_000_000,
    alias_jump = false
)

using StochasticDiffEq, DiffEqNoiseProcess, Test, DiffEqDevTools, Random, LinearAlgebra
const μ = 1.01
const σ_const = 0.87

f(u, p, t) = μ * u + μ * u
f1_μ(u, p, t) = μ
f1_μ_analytic(u0, p, t, W) = u0 .* exp.((2μ - (σ_const^2) / 2)t + σ_const * W)
f2(u, p, t) = μ * u
σ(u, p, t) = σ_const * u
no_noise(u, p, t) = 0.0
f1_no_noise(u, p, t) = μ
f1_no_noise_analytic(u0, p, t, W) = u0 .* exp.(2μ * t)

ff1_μ = SplitSDEFunction(f1_μ, f2, σ, analytic = f1_μ_analytic)
prob = SDEProblem(ff1_μ, 1 / 2, (0.0, 1.0))
ff1_no_noise = SplitSDEFunction(f1_no_noise, f2, no_noise, analytic = f1_no_noise_analytic)
no_noise_prob = SDEProblem(ff1_no_noise, 1 / 2, (0.0, 1.0))

sol = solve(prob, IIF1M(), dt = 1 / 10)

prob2 = SDEProblem{false}(f, σ, 1 / 2, (0.0, 1.0), noise = NoiseWrapper(sol.W))

sol2 = solve(prob2, EM(), dt = 1 / 10)

sol = solve(no_noise_prob, IIF1M(), dt = 1 / 10)

Random.seed!(100)
dts = (1 / 2) .^ (7:-1:4) #14->7 good plot
println("IIF scalar")
sim = test_convergence(dts, prob, IIF1M(), trajectories = Int(1.0e2))
@test abs(sim.𝒪est[:l2] - 0.5) < 0.2 # closer to 1 at this part
sim = test_convergence(dts, no_noise_prob, IIF1M(), trajectories = Int(2.0e1))
@test abs(sim.𝒪est[:l2] - 1.0) < 0.2 # closer to 1 at this part

dts = (1 / 2) .^ (7:-1:4) #14->7 good plot
println("IIF no noise scalar")
Random.seed!(100)
sim = test_convergence(dts, prob, IIF2M(), trajectories = Int(1.0e2))
@test abs(sim.𝒪est[:l2] - 0.5) < 0.2 # closer to 1 at this part
sim = test_convergence(dts, no_noise_prob, IIF2M(), trajectories = Int(1.0e1))
@test abs(sim.𝒪est[:l2] - 2) < 0.2 # closer to 1 at this part

#=
Random.seed!(200)
sim  = test_convergence(dts,prob,IIF1Mil(),trajectories=Int(2e1))
@test abs(sim.𝒪est[:l2]-1) < 0.3
=#

u0 = rand(2)
A = [-2.0 1.0; 1.0 -2.0]
B = [
    σ_const 0
    0 σ_const
]

function f(du, u, p, t)
    mul!(du, A, u)
    return du .+= 1.01u
end
function σ(du, u, p, t)
    mul!(@view(du[:, 1]), B, u)
    return mul!(@view(du[:, 2]), B, u)
end

function f_analytic(u0, p, t, W)
    tmp = (A + 1.01I - (B^2)) * t + B * sum(W)
    return exp(tmp) * u0
end

f1_A(du, u, p, t) = A
function f1_A_analytic(u0, p, t, W)
    tmp = (A + 1.01I - (B^2)) * t + B * sum(W)
    return exp(tmp) * u0
end
f2(du, u, p, t) = du .= μ .* u

ff1_A = SplitSDEFunction(f1_A, f2, σ, analytic = f1_A_analytic)
prob = SDEProblem(ff1_A, u0, (0.0, 1.0), noise_rate_prototype = rand(2, 2))

f1_no_noise(du, u, p, t) = A
f2(du, u, p, t) = (du .= μ .* u)
function σ22(du, u, p, t)
    return du .= 0
end
function f1_no_noise_analytic(u0, p, t, W)
    tmp = (A + 1.01I) * t
    return exp(tmp) * u0
end
ff1_A = SplitSDEFunction(f1_no_noise, f2, σ22, analytic = f1_no_noise_analytic)
prob_no_noise = SDEProblem(ff1_A, u0, (0.0, 1.0), noise_rate_prototype = rand(2, 2))

sol = solve(prob, IIF1M(), dt = 1 / 10)

dts = (1 / 2) .^ (8:-1:4) #14->7 good plot

Random.seed!(250)
println("IIF")
sim = test_convergence(dts, prob, IIF1M(), trajectories = Int(5.0e1))
@test abs(sim.𝒪est[:l2] - 0.5) < 0.2

sim = test_convergence(dts, prob, IIF2M(), trajectories = Int(5.0e1))
@test abs(sim.𝒪est[:l2] - 0.5) < 0.2

println("IIF no noise")
sim = test_convergence(dts, prob_no_noise, IIF1M(), trajectories = Int(1.0e1))
@test abs(sim.𝒪est[:l2] - 1) < 0.2

sim = test_convergence(dts, prob_no_noise, IIF2M(), trajectories = Int(1.0e1))
@test abs(sim.𝒪est[:l2] - 2) < 0.1

using StochasticDiffEq, Test, LinearAlgebra, Random

a = ones(3)
t = 0.4
a .- t

const mm_A = [
    -2.0 1 4
    4 -2 1
    2 1 3
]
const mm_b = mm_A * ones(3)
function mm_f(du, u, p, t)
    mul!(du, mm_A, u)
    tmp = t * mm_b
    return @. du += tmp
end
function mm_analytic(u0, p, t, W)
    return 2.0 .* ones(3) .* exp.(t) .- t .- 1
end
function mm_g(du, u, p, t)
    return @. du = u + t
end
function g!(du, u, p, t)
    return @. du = 0.0
end

prob2 = SDEProblem(SDEFunction(mm_g, g!; analytic = mm_analytic), ones(3), (0.0, 1.0))
prob = SDEProblem(
    SDEFunction(mm_f, g!; analytic = mm_analytic, mass_matrix = mm_A),
    ones(3), (0.0, 1.0)
)

sol = solve(prob, ImplicitRKMil(theta = 1), dt = 0.01, adaptive = false)
sol2 = solve(prob2, ImplicitRKMil(theta = 1), dt = 0.01, adaptive = false)

@test norm(sol .- sol2) ≈ 0 atol = 1.0e-11

sol = solve(prob, ImplicitEM(theta = 1), dt = 0.01, adaptive = false)
sol2 = solve(prob2, ImplicitEM(theta = 1), dt = 0.01, adaptive = false)

@test norm(sol .- sol2) ≈ 0 atol = 1.0e-11

sol = solve(prob, ImplicitRKMil(symplectic = true), dt = 0.01, adaptive = false)
sol2 = solve(prob2, ImplicitRKMil(symplectic = true), dt = 0.01, adaptive = false)

@test norm(sol .- sol2) ≈ 0 atol = 1.0e-11

sol = solve(prob, ImplicitEM(symplectic = true), dt = 0.01, adaptive = false)
sol2 = solve(prob2, ImplicitEM(symplectic = true), dt = 0.01, adaptive = false)

@test norm(sol .- sol2) ≈ 0 atol = 1.0e-11

function mm_f2(du, u, p, t)
    return mul!(du, mm_A, u)
end
function no_mm_f2(du, u, p, t)
    return du .= u
end
function no_mm_g2(du, u, p, t)
    return du .= u
end
function mm_g2(du, u, p, t)
    return mul!(du, mm_A, u)
end
prob2 = SDEProblem(no_mm_f2, no_mm_g2, ones(3), (0.0, 1.0))
prob = SDEProblem(SDEFunction(mm_f2, no_mm_g2; mass_matrix = mm_A), ones(3), (0.0, 1.0))

Random.seed!(1)
sol = solve(prob, ImplicitEM(theta = 1), dt = 0.01, adaptive = false)
Random.seed!(1)
sol2 = solve(prob2, ImplicitEM(theta = 1), dt = 0.01, adaptive = false)

@test norm(sol .- sol2) ≈ 0 atol = 1.0e-11

using SafeTestsets
using Pkg

function activate_gpu_env()
    Pkg.activate("gpu")
    Pkg.develop(PackageSpec(path = dirname(@__DIR__)))
    return Pkg.instantiate()
end

function activate_nopre_env()
    Pkg.activate("nopre")
    Pkg.develop(PackageSpec(path = dirname(@__DIR__)))
    return Pkg.instantiate()
end

const LONGER_TESTS = false

const TEST_GROUP = get(ENV, "ODEDIFFEQ_TEST_GROUP", "ALL")

const is_APPVEYOR = Sys.iswindows() && haskey(ENV, "APPVEYOR")

@time begin
    if TEST_GROUP == "ALL" || TEST_GROUP == "Core" || TEST_GROUP == "Interface1"
        @time @safetestset "Default Solver Tests" begin
            include("default_solver_test.jl")
        end
        @time @safetestset "First Rand Tests" begin
            include("first_rand_test.jl")
        end
        @time @safetestset "Inference Tests" begin
            include("inference_test.jl")
        end
        @time @safetestset "Linear RODE Tests" begin
            include("rode_linear_tests.jl")
        end
        @time @safetestset "Complex Number Tests" begin
            include("complex_tests.jl")
        end
        @time @safetestset "Static Array Tests" begin
            include("static_array_tests.jl")
        end
        @time @safetestset "StaticArrays Callback Tests (issue #1129)" begin
            include("staticarrays_callback_test.jl")
        end
        @time @safetestset "Noise Type Tests" begin
            include("noise_type_test.jl")
        end
        @time @safetestset "Mass matrix tests" begin
            include("mass_matrix_tests.jl")
        end
        @time @safetestset "Outofplace Arrays Tests" begin
            include("outofplace_arrays.jl")
        end
        @time @safetestset "tdir Tests" begin
            include("tdir_tests.jl")
        end
        @time @safetestset "tstops Tests" begin
            include("tstops_tests.jl")
        end
        @time @safetestset "Callable tstops Tests" begin
            include("callable_tstops_tests.jl")
        end
        @time @safetestset "Integrator RNG Tests" begin
            include("rng_integrator_tests.jl")
        end
        @time @safetestset "JumpProblem kwarg forwarding Tests" begin
            include("jump_kwarg_forwarding_tests.jl")
        end
        @time @safetestset "saveat Tests" begin
            include("saveat_tests.jl")
        end
        @time @safetestset "Oval2" begin
            include("oval2_test.jl")
        end
        @time @safetestset "Solver Reversal Tests" begin
            include("reversal_tests.jl")
        end
    end

    if TEST_GROUP == "ALL" || TEST_GROUP == "Interface2"
        @time @safetestset "Basic Tau Leaping Tests" begin
            include("tau_leaping.jl")
        end
        @time @safetestset "Linear SDE Tests" begin
            include("sde/sde_linear_tests.jl")
        end
        @time @safetestset "Two-dimensional Linear SDE Tests" begin
            include("sde/sde_twodimlinear_tests.jl")
        end
        @time @safetestset "Element-wise Tolerances Tests" begin
            include("tolerances_tests.jl")
        end
        @time @safetestset "Zeroed Noise Tests" begin
            include("zeroed_noise_test.jl")
        end
        @time @safetestset "Scalar Tests" begin
            include("scalar_noise.jl")
        end
        @time @safetestset "Stiffness Detection Test" begin
            include("stiffness_detection_test.jl")
        end
        @time @safetestset "Adaptive SDE Linear Tests" begin
            include("adaptive/sde_linearadaptive_tests.jl")
        end
        @time @safetestset "Inplace RODESolution Interpolation Tests" begin
            include("inplace_interpolation.jl")
        end
    end

    if TEST_GROUP == "ALL" || TEST_GROUP == "Interface3"
        @time @safetestset "Composite Tests" begin
            include("composite_algorithm_test.jl")
        end
        @time @safetestset "Events Tests" begin
            include("events_test.jl")
        end
        @time @safetestset "Cache Tests" begin
            include("cache_test.jl")
        end
        @time @safetestset "Adaptive Complex Mean Test" begin
            include("adaptive/sde_complex_adaptive_mean_test.jl")
        end
        @time @safetestset "Utility Tests" begin
            include("utility_tests.jl")
        end
        @time @safetestset "Implicit Time Parameter Tests" begin
            include("implicit_time_parameter_test.jl")
        end
        @time @safetestset "Non-diagonal SDE Tests" begin
            include("nondiagonal_tests.jl")
        end
        @time @safetestset "Non-diagonal EulerHeun sparse alloc" begin
            include("nondiag_noise_eulerheun_test.jl")
        end
        @time @safetestset "No Index Tests" begin
            include("noindex_tests.jl")
        end
        @time @safetestset "Multiple Dimension Linear Adaptive Test" begin
            include("adaptive/sde_twodimlinearadaptive_tests.jl")
        end
        @time @safetestset "Autostepsize Test" begin
            include("adaptive/sde_autostepsize_test.jl")
        end
        @time @safetestset "Additive Lorenz Attractor Test" begin
            include("adaptive/sde_lorenzattractor_tests.jl")
        end
        @time @safetestset "Stochastic iterated integrals" begin
            include("levy_areas.jl")
        end
        @time @safetestset "Sparse Diff Tests" begin
            include("sparsediff_tests.jl")
        end
    end

    if !is_APPVEYOR && (TEST_GROUP == "ALL" || TEST_GROUP == "AlgConvergence")
        @time @safetestset "Convergence Tests" begin
            include("sde/sde_convergence_tests.jl")
        end
        @time @safetestset "Dynamical SDE Tests" begin
            include("sde/sde_dynamical.jl")
        end
    end

    if !is_APPVEYOR && (TEST_GROUP == "ALL" || TEST_GROUP == "NoncommutativeConvergence")
        @time @safetestset "Noncommutative Noise Tests" begin
            include("noncommutative_tests.jl")
        end
    end

    if !is_APPVEYOR && TEST_GROUP == "AlgConvergence2"
        @time @safetestset "IIF Convergence Tests" begin
            include("iif_methods.jl")
        end
        @time @safetestset "Commutative Noise Methods Tests" begin
            include("commutative_tests.jl")
        end
        @time @safetestset "Multivariate Geometric Tests" begin
            include("multivariate_geometric.jl")
        end
    end

    if !is_APPVEYOR && TEST_GROUP == "AlgConvergence3"
        @time @safetestset "Rossler Order Tests" begin
            include("sde/sde_rosslerorder_tests.jl")
        end
        @time @safetestset "ODE Convergence Regression Tests" begin
            include("ode_convergence_regression.jl")
        end
        @time @safetestset "Additive SDE Tests" begin
            include("sde/sde_additive_tests.jl")
        end
        @time @safetestset "Stratonovich Convergence Tests" begin
            include("stratonovich_convergence_tests.jl")
        end
    end

    if !is_APPVEYOR && TEST_GROUP == "WeakConvergence1"
        @time @safetestset "Multidimensional IIP Weak Convergence Tests" begin
            include("weak_convergence/multidim_iip_weak.jl")
        end
    end

    if !is_APPVEYOR && TEST_GROUP == "OOPWeakConvergence"
        @time @safetestset "OOP Weak Convergence Tests" begin
            include("weak_convergence/oop_weak.jl")
        end
        @time @safetestset "Additive Weak Convergence Tests" begin
            include("weak_convergence/additive_weak.jl")
        end
    end

    if !is_APPVEYOR && TEST_GROUP == "IIPWeakConvergence"
        @time @safetestset "IIP Weak Convergence Tests" begin
            include("weak_convergence/iip_weak.jl")
        end
    end

    if !is_APPVEYOR && TEST_GROUP == "WeakAdaptiveGPU"
        activate_gpu_env()
        @time @safetestset "GPU Weak adaptive step size scalar noise SDE" begin
            include("gpu/sde_weak_scalar_adaptive_gpu.jl")
        end
        @time @safetestset "GPU Weak adaptive" begin
            include("gpu/sde_weak_adaptive_gpu.jl")
        end
    end

    if !is_APPVEYOR && TEST_GROUP == "Multithreaded"
        @time @safetestset "Mulithreaded Jump Thread Safety Tests" begin
            include("multithreaded_jump_test.jl")
        end
    end

    if TEST_GROUP == "ALL" || TEST_GROUP == "Allocations"
        @time @safetestset "Allocation Tests" begin
            include("alloc_tests.jl")
        end
    end

    if !is_APPVEYOR && TEST_GROUP == "StaticAnalysis"
        activate_nopre_env()
        @time @safetestset "JET Static Analysis Tests" begin
            include("nopre/jet_tests.jl")
        end
    end
end

using StochasticDiffEq, DiffEqNoiseProcess, JumpProcesses, SciMLBase, Random, Test

# Simple SDE: dX = -X dt + 0.1 dW
f(u, p, t) = -u
g(u, p, t) = 0.1
u0 = 1.0
tspan = (0.0, 1.0)
prob = SDEProblem(f, g, u0, tspan)

@testset "Integrator RNG Support" begin
    @testset "Default behavior" begin
        sol = solve(prob, EM(); dt = 0.01)
        @test sol.retcode == ReturnCode.Success
        @test length(sol.t) > 1
    end

    @testset "Reproducibility with explicit rng" begin
        rng1 = Xoshiro(42)
        rng2 = Xoshiro(42)
        sol1 = solve(prob, EM(); dt = 0.01, rng = rng1)
        sol2 = solve(prob, EM(); dt = 0.01, rng = rng2)
        @test sol1.u == sol2.u
        @test sol1.t == sol2.t
    end

    @testset "has_rng interface" begin
        integ = init(prob, EM(); dt = 0.01)
        @test SciMLBase.has_rng(integ) == true
    end

    @testset "get_rng returns provided RNG" begin
        rng = Xoshiro(123)
        integ = init(prob, EM(); dt = 0.01, rng)
        @test SciMLBase.get_rng(integ) === rng
    end

    @testset "set_rng! type safety" begin
        integ = init(prob, EM(); dt = 0.01, rng = Xoshiro(42))
        new_rng = Xoshiro(99)
        SciMLBase.set_rng!(integ, new_rng)
        @test SciMLBase.get_rng(integ) === new_rng

        # Mismatched type should error
        @test_throws ArgumentError SciMLBase.set_rng!(integ, MersenneTwister(42))
    end

    @testset "set_rng! syncs framework W.rng" begin
        rng = Xoshiro(42)
        integ = init(prob, EM(); dt = 0.01, rng)
        @test integ.W.rng === rng  # same object initially

        new_rng = Xoshiro(99)
        SciMLBase.set_rng!(integ, new_rng)
        @test integ.W.rng === new_rng  # synced after set_rng!
        @test integ.rng === new_rng
    end

    @testset "set_rng! respects user-provided noise" begin
        user_rng = Xoshiro(77)
        W = WienerProcess(0.0, 0.0; rng = user_rng)
        prob_noise = SDEProblem(f, g, u0, tspan; noise = W)
        integ = init(prob_noise, EM(); dt = 0.01, rng = Xoshiro(42))
        @test integ.noise !== nothing  # user-provided noise

        orig_W_rng = integ.W.rng
        new_rng = Xoshiro(99)
        SciMLBase.set_rng!(integ, new_rng)
        @test integ.rng === new_rng
        @test integ.W.rng === orig_W_rng  # NOT synced
    end

    @testset "reinit! with rng kwarg" begin
        rng = Xoshiro(42)
        integ = init(prob, EM(); dt = 0.01, rng)

        new_rng = Xoshiro(99)
        reinit!(integ, u0; rng = new_rng)
        @test integ.rng === new_rng
        @test integ.W.rng === new_rng
    end

    @testset "Backward compat with seed kwarg" begin
        sol1 = solve(prob, EM(); dt = 0.01, seed = UInt64(42))
        sol2 = solve(prob, EM(); dt = 0.01, seed = UInt64(42))
        @test sol1.u == sol2.u
    end

    @testset "Concrete RNG type parameter" begin
        integ = init(prob, EM(); dt = 0.01, rng = Xoshiro(42))
        # The rng field should be a concrete Xoshiro, not Any
        @test typeof(integ.rng) === Xoshiro
    end

    @testset "Solution seed when rng provided" begin
        # Non-TaskLocalRNG: seed should be UInt64(0)
        sol = solve(prob, EM(); dt = 0.01, rng = Xoshiro(42))
        @test sol.seed == UInt64(0)

        # TaskLocalRNG: seed should be the derived seed (nonzero)
        Random.seed!(12345)
        sol_tlrng = solve(prob, EM(); dt = 0.01, rng = Random.default_rng())
        @test sol_tlrng.seed != UInt64(0)
    end

    @testset "TaskLocalRNG conversion" begin
        integ = init(prob, EM(); dt = 0.01, rng = Random.default_rng())
        @test integ.rng isa Xoshiro
        @test !(integ.rng isa Random.TaskLocalRNG)
    end

    @testset "TaskLocalRNG no duplicate stream" begin
        Random.seed!(12345)
        integ = init(prob, EM(); dt = 0.01, rng = Random.default_rng())
        # The integrator's RNG should produce different values than the task-local RNG.
        # Compare vectors to make a probabilistic flake essentially impossible.
        vals_integ = rand(integ.rng, 10)
        vals_task = rand(10)
        @test vals_integ != vals_task
    end

    @testset "user-provided noise detection" begin
        integ = init(prob, EM(); dt = 0.01)
        @test integ.noise === nothing  # no user-provided noise

        W = WienerProcess(0.0, 0.0)
        prob_noise = SDEProblem(f, g, u0, tspan; noise = W)
        integ2 = init(prob_noise, EM(); dt = 0.01)
        @test integ2.noise !== nothing  # user-provided noise
    end

    @testset "rng kwarg type validation" begin
        @test_throws ArgumentError solve(prob, EM(); dt = 0.01, rng = 42)
        @test_throws ArgumentError solve(prob, EM(); dt = 0.01, rng = "not an rng")
    end

    @testset "JumpProblem with rng kwarg" begin
        # Setup: zero-drift SDE with a constant-rate jump
        fj!(du, u, p, t) = (du[1] = 0.0)
        gj!(du, u, p, t) = (du[1] = 0.0)
        jump_rate(u, p, t) = 1.0
        jump_affect!(integrator) = (integrator.u[1] += 1.0)
        jump = ConstantRateJump(jump_rate, jump_affect!)

        sde_prob = SDEProblem(fj!, gj!, [0.0], (0.0, 1.0))
        jprob = JumpProblem(sde_prob, Direct(), jump)

        # Solve with explicit rng works
        sol = solve(jprob, EM(); dt = 0.01, rng = Xoshiro(42))
        @test sol.retcode == ReturnCode.Success

        # Repeated solve works (jump state properly reset)
        sol2 = solve(jprob, EM(); dt = 0.01, rng = Xoshiro(99))
        @test sol2.retcode == ReturnCode.Success

        # Note: full JumpProblem reproducibility requires controlling the
        # aggregation RNG too (Phase 4). Here we only verify the rng kwarg
        # does not error or break jump-diffusion solves.
    end

    @testset "VariableRateJump clock refresh with rng kwarg" begin
        # VariableRateJumps use ExtendedJumpArray, whose jump_u (jump clocks)
        # must be refreshed on each init/solve. This tests that
        # reset_jump_problem! is called even when rng is provided.
        fv!(du, u, p, t) = (du[1] = 0.0)
        gv!(du, u, p, t) = (du[1] = 0.0)
        vr_rate(u, p, t) = 0.5
        vr_affect!(integrator) = (integrator.u[1] += 1.0)
        vrjump = VariableRateJump(vr_rate, vr_affect!)

        sde_prob_vr = SDEProblem(fv!, gv!, [0.0], (0.0, 1.0))
        jprob_vr = JumpProblem(sde_prob_vr, Direct(), vrjump)

        integ1 = init(jprob_vr, EM(); dt = 0.01, rng = Xoshiro(42))
        @test integ1.u isa JumpProcesses.ExtendedJumpArray
        jump_u1 = copy(integ1.u.jump_u)

        # Second init on same aliased problem: jump clocks should be refreshed
        integ2 = init(jprob_vr, EM(); dt = 0.01, rng = Xoshiro(99))
        jump_u2 = copy(integ2.u.jump_u)

        @test jump_u1 != jump_u2
    end
end

using Test
using StochasticDiffEq
using Random
using AllocCheck

"""
    Allocation tests for StochasticDiffEq.jl

These tests ensure that the hot path functions (perform_step!, loopheader!, loopfooter!)
don't allocate memory during stepping, which is critical for performance.
"""

# Wrapper that discards the return value of step!.
# ODE's _step! returns integrator.sol.retcode, and on Julia 1.10 boxing that
# ReturnCode.T return value inside @allocated costs 16 bytes. Discarding it
# avoids measuring return-value boxing as a false positive.
@inline function step_void!(integrator)
    step!(integrator)
    return nothing
end

@testset "Allocation Tests" begin
    Random.seed!(12345)

    # Test problem definitions (in-place, 3D diagonal noise)
    f_iip!(du, u, p, t) = (du[1] = 0.1 * u[1]; du[2] = 0.2 * u[2]; du[3] = 0.3 * u[3])
    g_iip!(du, u, p, t) = (du[1] = 0.2 * u[1]; du[2] = 0.3 * u[2]; du[3] = 0.4 * u[3])
    u0 = [1.0, 1.0, 1.0]
    tspan = (0.0, 10.0)  # Long enough to ensure many steps
    prob_iip = SDEProblem(f_iip!, g_iip!, u0, tspan)

    @testset "EM stepping allocation" begin
        # Initialize integrator with save_on=false to avoid solution saving allocations
        integrator = init(prob_iip, EM(), dt = 0.01, save_on = false)

        # Warm up to ensure JIT compilation
        for _ in 1:10
            step_void!(integrator)
        end

        # Test allocation per step
        allocs_per_step = @allocated step_void!(integrator)
        @test allocs_per_step == 0
    end

    @testset "EulerHeun stepping allocation" begin
        integrator = init(prob_iip, EulerHeun(), dt = 0.01, save_on = false)

        # Warm up
        for _ in 1:10
            step_void!(integrator)
        end

        allocs_per_step = @allocated step_void!(integrator)
        @test allocs_per_step == 0
    end

    @testset "RKMil stepping allocation" begin
        integrator = init(prob_iip, RKMil(), dt = 0.01, save_on = false)

        # Warm up
        for _ in 1:10
            step_void!(integrator)
        end

        allocs_per_step = @allocated step_void!(integrator)
        @test allocs_per_step == 0
    end

    @testset "SOSRI stepping allocation" begin
        integrator = init(prob_iip, SOSRI(), save_on = false)

        # Warm up
        for _ in 1:10
            step_void!(integrator)
        end

        allocs_per_step = @allocated step_void!(integrator)
        @test allocs_per_step == 0
    end

    @testset "SOSRA stepping allocation" begin
        integrator = init(prob_iip, SOSRA(), save_on = false)

        # Warm up
        for _ in 1:10
            step_void!(integrator)
        end

        allocs_per_step = @allocated step_void!(integrator)
        @test allocs_per_step == 0
    end

    # Test with scalar SDE (out-of-place)
    @testset "Scalar SDE allocations" begin
        f_scalar(u, p, t) = 0.1 * u
        g_scalar(u, p, t) = 0.2 * u
        prob_scalar = SDEProblem(f_scalar, g_scalar, 1.0, tspan)

        integrator = init(prob_scalar, EM(), dt = 0.01, save_on = false)

        # Warm up
        for _ in 1:10
            step_void!(integrator)
        end

        allocs_per_step = @allocated step_void!(integrator)
        @test allocs_per_step == 0
    end

    # Test perform_step! directly
    @testset "perform_step! allocation - EM" begin
        integrator = init(prob_iip, EM(), dt = 0.01, save_on = false)
        cache = integrator.cache

        # Warm up
        for _ in 1:10
            StochasticDiffEq.perform_step!(integrator, cache)
            # Manually update t to avoid going past tspan
            integrator.t = mod(integrator.t, 9.0)
        end

        allocs = @allocated StochasticDiffEq.perform_step!(integrator, cache)
        @test allocs == 0
    end

    @testset "loopheader! allocation" begin
        integrator = init(prob_iip, EM(), dt = 0.01, save_on = false)

        # Warm up
        for _ in 1:10
            StochasticDiffEq.loopheader!(integrator)
        end

        allocs = @allocated StochasticDiffEq.loopheader!(integrator)
        @test allocs == 0
    end

    @testset "loopfooter! allocation" begin
        integrator = init(prob_iip, EM(), dt = 0.01, save_on = false)

        # Warm up
        for _ in 1:10
            StochasticDiffEq.loopfooter!(integrator)
        end

        allocs = @allocated StochasticDiffEq.loopfooter!(integrator)
        @test allocs == 0
    end
end

using StochasticDiffEq, LinearAlgebra, SparseArrays, Random, LinearSolve, Test
using OrdinaryDiffEqDifferentiation: OrdinaryDiffEqDifferentiation, calc_W!, calc_W
using SciMLOperators: MatrixOperator, WOperator
using OrdinaryDiffEq

#horid nasty hack to deal with temporary calc_W refactor
# if there is a method that takes a W_transform argument, define the version that doesn't to set W_transform to true
if hasmethod(calc_W, (Any, Any, Any, Any, Any))
    function OrdinaryDiffEqDifferentiation.calc_W(integ, nlsolver, dgamma, repeat_step::Bool)
        return OrdinaryDiffEqDifferentiation.calc_W(integ, nlsolver, dgamma, repeat_step, true)
    end
    function OrdinaryDiffEqDifferentiation.calc_W!(
            integ, nlsolver, cache, dgamma, repeat_step::Bool
        )
        return OrdinaryDiffEqDifferentiation.calc_W(
            integ, nlsolver, dgamma, cacherepeat_step, true
        )
    end
end
@testset "Derivative Utilities" begin
    @testset "calc_W!" begin
        A = [-1.0 0.0; 0.0 -0.5]
        σ = [0.9 0.0; 0.0 0.8]
        mm = [2.0 0.0; 0.0 1.0]
        u0 = [1.0, 1.0]
        tmp = zeros(2)
        tspan = (0.0, 1.0)
        dt = 0.01
        dtgamma = 0.5dt
        concrete_W = -mm / dtgamma + A

        # Out-of-place
        _f = (u, p, t) -> A * u
        _g = (u, p, t) -> σ * u
        fun = SDEFunction(
            _f, _g;
            mass_matrix = mm,
            jac = (u, p, t) -> A
        )
        prob = SDEProblem(fun, u0, tspan)
        integrator = init(prob, ImplicitEM(theta = 1); adaptive = false, dt = dt)
        W = calc_W(integrator, integrator.cache.nlsolver, dtgamma, #=repeat_step=# false)
        @test convert(AbstractMatrix, W) ≈ concrete_W
        @test W \ u0 ≈ concrete_W \ u0

        # In-place
        _f = (du, u, p, t) -> mul!(du, A, u)
        _g = (du, u, p, t) -> mul!(du, σ, u)
        fun = SDEFunction(
            _f, _g;
            mass_matrix = mm,
            jac_prototype = MatrixOperator(A)
        )
        prob = SDEProblem(fun, u0, tspan)
        integrator = init(prob, ImplicitEM(theta = 1); adaptive = false, dt = dt)
        W = integrator.cache.nlsolver.cache.W
        calc_W!(
            W, integrator, integrator.cache.nlsolver,
            integrator.cache, dtgamma,
            #=repeat_step=#
            false
        )

        # Did not update because it's an array operator
        # We don't want to build Jacobians when we have operators!
        @test convert(AbstractMatrix, integrator.cache.nlsolver.cache.W) != concrete_W
        ldiv!(tmp, lu!(integrator.cache.nlsolver.cache.W), u0)
        @test tmp != concrete_W \ u0

        # But jacobian2W! will update the cache
        OrdinaryDiffEqDifferentiation.jacobian2W!(
            integrator.cache.nlsolver.cache.W._concrete_form,
            mm, dtgamma, integrator.cache.nlsolver.cache.W.J.A
        )
        @test convert(AbstractMatrix, integrator.cache.nlsolver.cache.W) == concrete_W
        ldiv!(tmp, lu!(integrator.cache.nlsolver.cache.W), u0)
        @test tmp == concrete_W \ u0
    end

    @testset "Implicit solver with lazy W" begin
        A = sparse([-1.0 0.0; 0.0 -0.5])
        σ = sparse([0.9 0.0; 0.0 0.8])
        mm = sparse([2.0 0.0; 0.0 1.0])
        u0 = [1.0, 1.0]
        tspan = (0.0, 1.0)

        _f = (u, p, t) -> t * (A * u)
        _f_ip = (du, u, p, t) -> lmul!(t, mul!(du, A, u))
        _g = (u, p, t) -> σ * u
        _g_ip = (du, u, p, t) -> mul!(du, σ, u)
        prob1 = SDEProblem(SDEFunction(_f, _g; mass_matrix = mm), u0, tspan)
        prob2 = SDEProblem(SDEFunction(_f, _g; mass_matrix = mm, jac = (u, p, t) -> t * A), u0, tspan)
        prob1_ip = SDEProblem(SDEFunction(_f_ip, _g_ip; mass_matrix = mm), u0, tspan)
        jac_prototype = MatrixOperator(
            similar(A); update_func! = (
                J, u, p, t,
            ) -> (J .= t .* A; J)
        )
        prob2_ip = SDEProblem(
            SDEFunction(_f_ip, _g_ip; mass_matrix = mm, jac_prototype = jac_prototype), u0, tspan
        )

        for Alg in [ImplicitEM, ISSEM]
            println(Alg)
            Random.seed!(0)
            sol1 = solve(prob1, Alg(theta = 1); adaptive = false, dt = 0.01)
            Random.seed!(0)
            sol2 = solve(prob2, Alg(theta = 1); adaptive = false, dt = 0.01)
            @test sol1(1.0) ≈ sol2(1.0) rtol = 1.0e-2
            Random.seed!(0)
            sol1_ip = solve(prob1_ip, Alg(theta = 1); adaptive = false, dt = 0.01)
            Random.seed!(0)
            sol2_ip = solve(prob2_ip, Alg(theta = 1); adaptive = false, dt = 0.01)
            @test sol1_ip(1.0) ≈ sol2_ip(1.0) rtol = 1.0e-4
        end

        σ = 1.0
        _g = (u, p, t) -> σ
        _g_ip = (du, u, p, t) -> (du .= σ)
        prob1 = SDEProblem(SDEFunction(_f, _g), u0, tspan)
        prob2 = SDEProblem(SDEFunction(_f, _g; jac = (u, p, t) -> t * A), u0, tspan)
        prob1_ip = SDEProblem(SDEFunction(_f_ip, _g_ip), u0, tspan)
        prob2_ip = SDEProblem(SDEFunction(_f_ip, _g_ip; jac_prototype = jac_prototype), u0, tspan)

        println(SKenCarp)
        Random.seed!(0)
        sol1 = solve(prob1, SKenCarp(); adaptive = false, dt = 0.01)
        Random.seed!(0)
        sol2 = solve(prob2, SKenCarp(); adaptive = false, dt = 0.01)
        @test sol1(1.0) ≈ sol2(1.0) rtol = 1.0e-2
        Random.seed!(0)
        sol1_ip = solve(prob1_ip, SKenCarp(); adaptive = false, dt = 0.01)
        Random.seed!(0)
        sol2_ip = solve(prob2_ip, SKenCarp(); adaptive = false, dt = 0.01)
        @test sol1_ip(1.0) ≈ sol2_ip(1.0) rtol = 1.0e-3
    end
end

using StochasticDiffEq, Test, Random
using SDEProblemLibrary: prob_sde_2Dlinear
Random.seed!(100)
prob = prob_sde_2Dlinear

## Solve and plot
sol1 = solve(prob, RKMil(), abstol = 1, reltol = 0, adaptive = true)
err1 = sol1.errors[:final]

sol1 = solve(prob, RKMil(), abstol = 1.0e-3, reltol = 1.0e-3, adaptive = true)
err12 = sol1.errors[:final]
@test err12 < err1

sol1 = solve(prob, RKMilGeneral(), abstol = 1, reltol = 0, adaptive = true)
err11 = sol1.errors[:final]

sol1 = solve(prob, RKMilGeneral(), adaptive = true)
err112 = sol1.errors[:final]
@test err112 < err11

sol2 = solve(prob, SRI(), dt = 1 / 2^(4), abstol = 1, reltol = 0)
err2 = sol2.errors[:final]

println("1e-1")
sol3 = solve(prob, SRI(), dt = 1 / 2^(4), abstol = 1.0e-1, reltol = 0)
err3 = sol3.errors[:final]

println("1e-2")
sol4 = solve(prob, SRI(), dt = 1 / 2^(4), abstol = 1.0e-2, reltol = 0)
err4 = sol4.errors[:final]
@test err4 < err2
println("1e-3")
sol5 = solve(prob, SRI(), dt = 1 / 2^(4), abstol = 1.0e-3, reltol = 0)
err5 = sol5.errors[:final]
@test err5 < err3
println(
    """
    Final error for the solutions were:
              $err1
              $err11
              $err2
              $err3
              $err4
              $err5
              """
)

sol6 = solve(prob, SRI())

using StochasticDiffEq, DiffEqNoiseProcess, SparseArrays, LinearAlgebra,
    AllocCheck
using DiffEqBase: @..

@testset "EulerHeun sparse noise: no per-step alloc" begin

    # Simple linear drift
    f!(du, u, p, t) = (@.. du = 0.999 * u)

    # 2×2 identical-column block structure; g! only writes nzval of an existing sparsity pattern
    function sparse_proto(N)
        I = Vector{Int}(undef, 4N)
        J = similar(I)
        V = ones(Float64, 4N)
        @inbounds for i in 1:N
            I[4i - 3] = 2i - 1
            J[4i - 3] = 2i - 1

            I[4i - 2] = 2i
            J[4i - 2] = 2i - 1

            I[4i - 1] = 2i - 1
            J[4i - 1] = 2i

            I[4i] = 2i
            J[4i] = 2i
        end
        sparse(I, J, V, 2N, 2N)
    end

    @inline function ensure_pattern!(G::SparseMatrixCSC{T, Int}, N) where {T}
        s = one(T)
        @inbounds for i in 1:N
            G[2i - 1, 2i - 1] = s
            G[2i, 2i - 1] = s
            G[2i - 1, 2i] = s
            G[2i, 2i] = s
        end
        return nothing
    end

    # Dense g!
    function g!(G::StridedMatrix{T}, u, p, t) where {T}
        c012 = T(0.12)
        c18 = T(1.8)
        @inbounds for i in 1:(p.N)
            off = 2i - 1
            G[off, off] = c012 * u[2i - 1]
            G[off + 1, off] = c18 * u[2i]

            G[off, off + 1] = c012 * u[2i - 1]
            G[off + 1, off + 1] = c18 * u[2i]
        end
        return nothing
    end

    # Sparse g!
    function g!(G::SparseMatrixCSC{T}, u, p, t) where {T}
        c012 = T(0.12)
        c18 = T(1.8)
        @inbounds for i in 1:(p.N)
            off = G.colptr[2i - 1]
            G.nzval[off] = c012 * u[2i - 1]
            G.nzval[off + 1] = c18 * u[2i]

            off = G.colptr[2i]
            G.nzval[off] = c012 * u[2i - 1]
            G.nzval[off + 1] = c18 * u[2i]
        end
        return nothing
    end

    function make_integrator_sparse(N)
        A = sparse_proto(N)
        p = (; N)
        W = SimpleWienerProcess!(0.0, zeros(2N); save_everystep = false)
        prob = SDEProblem(
            f!, g!, ones(2N), (0.0, 1.0), p; noise_rate_prototype = A, noise = W
        )
        integ = init(prob, EulerHeun(); dt = 0.01, adaptive = false, save_on = false)

        cache = integ.cache
        allocs = AllocCheck.check_allocs(
            StochasticDiffEq.perform_step!, (typeof(integ), typeof(cache))
        )
        @test isempty(allocs)
    end

    function make_integrator_dense(N)
        A = zeros(2N, 2N)
        p = (; N)
        W = SimpleWienerProcess!(0.0, zeros(2N); save_everystep = false)
        prob = SDEProblem(
            f!, g!, ones(2N), (0.0, 1.0), p; noise_rate_prototype = A, noise = W
        )
        integ = init(prob, EulerHeun(); dt = 0.01, adaptive = false, save_on = false)

        cache = integ.cache

        # Dense+BLAS: assert with `@allocated == 0` (not `check_allocs`).
        # `check_allocs` flags throw-only branches in LinearAlgebra’s generic gemv!/mul!,
        # while the BLAS hot path is allocation-free at runtime. We keep `check_allocs`
        # for the sparse/non-diagonal tests.
        StochasticDiffEq.perform_step!(integ, cache) # warm-up
        @test @allocated(StochasticDiffEq.perform_step!(integ, cache)) == 0
    end

    make_integrator_dense(16)
    make_integrator_sparse(16)
end

using StochasticDiffEq, DiffEqNoiseProcess, Test, DiffEqDevTools, Random
Random.seed!(1)

f1_harmonic(v, u, p, t) = -u
f2_harmonic(v, u, p, t) = v
g(u, p, t) = 1.0
γ = 1.0

@testset "Scalar u" begin
    u0 = 0.0
    v0 = 1.0

    ff_harmonic = DynamicalSDEFunction(f1_harmonic, f2_harmonic, g)
    prob1 = DynamicalSDEProblem(ff_harmonic, v0, u0, (0.0, 5.0))

    dts = (1 / 2) .^ (8:-1:4)

    # Can't use NoiseGrid as noise is not generated with the correct size in convergence.jl. We require noise with shape of v.
    sim1 = analyticless_test_convergence(
        dts, prob1, BAOAB(gamma = γ), (1 / 2)^10;
        trajectories = Int(2.0e2), use_noise_grid = false
    )
    display(sim1.𝒪est)
    @test abs(sim1.𝒪est[:weak_final] - 1) < 0.3
end

@testset "Vector u" begin
    u0 = zeros(2)
    v0 = ones(2)

    f1_harmonic_iip(dv, v, u, p, t) = dv .= f1_harmonic(v, u, p, t)
    f2_harmonic_iip(du, v, u, p, t) = du .= f2_harmonic(v, u, p, t)
    g_iip(du, u, p, t) = du .= g(u, p, t)

    ff_harmonic = DynamicalSDEFunction(f1_harmonic, f2_harmonic, g)
    prob1 = DynamicalSDEProblem(ff_harmonic, v0, u0, (0.0, 5.0))
    sol1 = solve(prob1, BAOAB(gamma = γ); dt = 1 / 10, save_noise = true)

    prob2 = DynamicalSDEProblem(
        f1_harmonic_iip, f2_harmonic_iip, g_iip, v0,
        u0, (0.0, 5.0); noise = NoiseWrapper(sol1.W)
    )
    sol2 = solve(prob2, BAOAB(gamma = γ); dt = 1 / 10)

    @test sol1[:] ≈ sol2[:]

    dts = (1 / 2) .^ (8:-1:4)

    # Can't use NoiseGrid as noise is not generated with the correct size in convergence.jl. We require noise with shape of v.
    sim1 = analyticless_test_convergence(
        dts, prob1, BAOAB(gamma = γ), (1 / 2)^10;
        trajectories = Int(1.0e3), use_noise_grid = false
    )
    @test abs(sim1.𝒪est[:weak_final] - 1) < 0.3
end

@testset "Scalar u, scale_noise=false" begin
    u0 = 0.0
    v0 = 1.0

    ff_harmonic = DynamicalSDEFunction(f1_harmonic, f2_harmonic, g)
    prob1 = DynamicalSDEProblem(ff_harmonic, v0, u0, (0.0, 5.0))

    dts = (1 / 2) .^ (8:-1:4)

    # Can't use NoiseGrid as noise is not generated with the correct size in convergence.jl. We require noise with shape of v.
    sim1 = analyticless_test_convergence(
        dts, prob1, BAOAB(gamma = γ, scale_noise = false),
        (1 / 2)^10; trajectories = Int(2.0e2), use_noise_grid = false
    )
    display(sim1.𝒪est)
    @test abs(sim1.𝒪est[:weak_final] - 1) < 0.3
end

@testset "Vector u, scale_noise=false" begin
    u0 = zeros(2)
    v0 = ones(2)

    f1_harmonic_iip(dv, v, u, p, t) = dv .= f1_harmonic(v, u, p, t)
    f2_harmonic_iip(du, v, u, p, t) = du .= f2_harmonic(v, u, p, t)
    g_iip(du, u, p, t) = du .= g(u, p, t)

    ff_harmonic = DynamicalSDEFunction(f1_harmonic, f2_harmonic, g)
    prob1 = DynamicalSDEProblem(ff_harmonic, v0, u0, (0.0, 5.0))
    sol1 = solve(prob1, BAOAB(gamma = γ, scale_noise = false); dt = 1 / 10, save_noise = true)

    prob2 = DynamicalSDEProblem(
        f1_harmonic_iip, f2_harmonic_iip, g_iip, v0,
        u0, (0.0, 5.0); noise = NoiseWrapper(sol1.W)
    )
    sol2 = solve(prob2, BAOAB(gamma = γ, scale_noise = false); dt = 1 / 10)

    @test sol1[:] ≈ sol2[:]

    dts = (1 / 2) .^ (8:-1:4)

    # Can't use NoiseGrid as noise is not generated with the correct size in convergence.jl. We require noise with shape of v.
    sim1 = analyticless_test_convergence(
        dts, prob1, BAOAB(gamma = γ, scale_noise = false),
        (1 / 2)^10; trajectories = Int(1.0e3), use_noise_grid = false
    )
    @test abs(sim1.𝒪est[:weak_final] - 1) < 0.3
end

"""
    JET.jl Static Analysis Tests for StochasticDiffEq.jl

These tests use JET.jl to verify type stability and detect potential
runtime errors in the core SDE solving functionality. The tests focus on
StochasticDiffEq-specific code paths, excluding issues in upstream packages.

For more information on JET.jl, see: https://aviatesk.github.io/JET.jl/stable/
"""

using Test
using StochasticDiffEq
using JET

# Helper to filter JET reports to only show StochasticDiffEq issues
function filter_stochastic_reports(reports)
    return filter(reports) do r
        str_rep = string(r)
        occursin("StochasticDiffEq", str_rep) &&
            !occursin("DiffEqBase", str_rep) &&
            !occursin("SciMLBase", str_rep) &&
            !occursin("OrdinaryDiffEq", str_rep)
    end
end

@testset "JET Static Analysis" begin
    # Define test problems
    function f_iip!(du, u, p, t)
        du[1] = 0.1 * u[1]
        du[2] = 0.2 * u[2]
        du[3] = 0.3 * u[3]
    end
    function g_iip!(du, u, p, t)
        du[1] = 0.2 * u[1]
        du[2] = 0.3 * u[2]
        du[3] = 0.4 * u[3]
    end

    f_scalar(u, p, t) = 0.1u
    g_scalar(u, p, t) = 0.2u

    u0_vec = [1.0, 1.0, 1.0]
    tspan = (0.0, 1.0)

    prob_iip = SDEProblem(f_iip!, g_iip!, u0_vec, tspan)
    prob_scalar = SDEProblem{false}(f_scalar, g_scalar, 1.0, tspan)

    @testset "EM algorithm - in-place" begin
        integrator = init(prob_iip, EM(), dt = 0.01)
        cache = integrator.cache

        # Test perform_step!
        rep = JET.report_call(StochasticDiffEq.perform_step!, (typeof(integrator), typeof(cache)))
        stochastic_issues = filter_stochastic_reports(JET.get_reports(rep))
        @test isempty(stochastic_issues)

        # Test loopheader!
        rep = JET.report_call(StochasticDiffEq.loopheader!, (typeof(integrator),))
        stochastic_issues = filter_stochastic_reports(JET.get_reports(rep))
        @test isempty(stochastic_issues)

        # Test loopfooter!
        rep = JET.report_call(StochasticDiffEq.loopfooter!, (typeof(integrator),))
        stochastic_issues = filter_stochastic_reports(JET.get_reports(rep))
        @test isempty(stochastic_issues)
    end

    @testset "EulerHeun algorithm - in-place" begin
        integrator = init(prob_iip, EulerHeun(), dt = 0.01)
        cache = integrator.cache

        rep = JET.report_call(StochasticDiffEq.perform_step!, (typeof(integrator), typeof(cache)))
        stochastic_issues = filter_stochastic_reports(JET.get_reports(rep))
        @test isempty(stochastic_issues)
    end

    @testset "RKMil algorithm - in-place" begin
        integrator = init(prob_iip, RKMil(), dt = 0.01)
        cache = integrator.cache

        rep = JET.report_call(StochasticDiffEq.perform_step!, (typeof(integrator), typeof(cache)))
        stochastic_issues = filter_stochastic_reports(JET.get_reports(rep))
        @test isempty(stochastic_issues)
    end

    @testset "SOSRI algorithm - in-place (adaptive)" begin
        integrator = init(prob_iip, SOSRI())
        cache = integrator.cache

        rep = JET.report_call(StochasticDiffEq.perform_step!, (typeof(integrator), typeof(cache)))
        stochastic_issues = filter_stochastic_reports(JET.get_reports(rep))
        @test isempty(stochastic_issues)
    end

    @testset "SOSRA algorithm - in-place (adaptive)" begin
        integrator = init(prob_iip, SOSRA())
        cache = integrator.cache

        rep = JET.report_call(StochasticDiffEq.perform_step!, (typeof(integrator), typeof(cache)))
        stochastic_issues = filter_stochastic_reports(JET.get_reports(rep))
        @test isempty(stochastic_issues)
    end

    @testset "SRA1 algorithm - in-place (adaptive)" begin
        integrator = init(prob_iip, SRA1())
        cache = integrator.cache

        rep = JET.report_call(StochasticDiffEq.perform_step!, (typeof(integrator), typeof(cache)))
        stochastic_issues = filter_stochastic_reports(JET.get_reports(rep))
        @test isempty(stochastic_issues)
    end

    @testset "Scalar SDE - out-of-place" begin
        integrator = init(prob_scalar, EM(), dt = 0.01)
        cache = integrator.cache

        rep = JET.report_call(StochasticDiffEq.perform_step!, (typeof(integrator), typeof(cache)))
        stochastic_issues = filter_stochastic_reports(JET.get_reports(rep))
        @test isempty(stochastic_issues)
    end

    @testset "step! function" begin
        integrator = init(prob_iip, EM(), dt = 0.01, save_on = false)

        rep = JET.report_call(step!, (typeof(integrator),))
        stochastic_issues = filter_stochastic_reports(JET.get_reports(rep))
        @test isempty(stochastic_issues)
    end
end

using StochasticDiffEq, Test, Random
using SDEProblemLibrary: prob_sde_linear

# Callable tstops support (e.g. SymbolicTstops from ModelingToolkit)
# The callable has signature (p, tspan) -> collection_of_tstop_times

@testset "Callable tstops" begin

    @testset "Basic callable tstops with EM (fixed step)" begin
        prob = prob_sde_linear
        my_tstops = (p, tspan) -> [0.33, 0.66]
        sol = solve(prob, EM(); dt = 1 // 2^4, tstops = my_tstops)
        @test 0.33 ∈ sol.t
        @test 0.66 ∈ sol.t
        @test sol.t[end] == prob.tspan[end]
    end

    @testset "Callable tstops with adaptive solver (SRIW1)" begin
        prob = prob_sde_linear
        my_tstops = (p, tspan) -> [0.33, 0.77]
        sol = solve(prob, SRIW1(); tstops = my_tstops)
        @test 0.33 ∈ sol.t
        @test 0.77 ∈ sol.t
        @test sol.t[end] == prob.tspan[end]
    end

    @testset "Callable tstops with ImplicitEM" begin
        f(u, p, t) = -p[1] * u
        g(u, p, t) = 0.1 * u
        prob = SDEProblem(f, g, 1.0, (0.0, 10.0), [0.5])
        my_tstops = (p, tspan) -> [3.0, 6.0]
        sol = solve(prob, ImplicitEM(); dt = 0.01, tstops = my_tstops)
        @test 3.0 ∈ sol.t
        @test 6.0 ∈ sol.t
        @test sol.t[end] == 10.0
    end

    @testset "Callable tstops depending on parameters" begin
        f(u, p, t) = -p[1] * u
        g(u, p, t) = p[2] * u
        prob = SDEProblem(f, g, 1.0, (0.0, 5.0), [0.5, 0.1])

        # tstops that depend on parameter values
        my_tstops = (p, tspan) -> [p[1] * 2.0, p[1] * 4.0]
        sol = solve(prob, EM(); dt = 0.01, tstops = my_tstops)
        @test 1.0 ∈ sol.t  # 0.5 * 2.0
        @test 2.0 ∈ sol.t  # 0.5 * 4.0
        @test sol.t[end] == 5.0
    end

    @testset "Callable tstops depending on tspan" begin
        prob = prob_sde_linear
        # tstops at midpoint of tspan
        my_tstops = (p, tspan) -> [(tspan[1] + tspan[2]) / 2]
        sol = solve(prob, EM(); dt = 1 // 2^4, tstops = my_tstops)
        @test 0.5 ∈ sol.t
    end

    @testset "Callable tstops returning empty collection" begin
        prob = prob_sde_linear
        my_tstops = (p, tspan) -> Float64[]
        sol = solve(prob, EM(); dt = 1 // 2^4, tstops = my_tstops)
        @test sol.t[end] == prob.tspan[end]
    end

    @testset "Callable tstops with only tstops (no dt, fixed step)" begin
        # Fixed-step EM with callable tstops still requires dt
        prob = prob_sde_linear
        my_tstops = (p, tspan) -> [0.33, 0.66, 1.0]
        sol = solve(prob, EM(); dt = 1 // 2^4, tstops = my_tstops)
        @test 0.33 ∈ sol.t
        @test 0.66 ∈ sol.t
        @test 1.0 ∈ sol.t
    end

    @testset "Callable tstops with adaptive solver (no dt)" begin
        prob = prob_sde_linear
        my_tstops = (p, tspan) -> [0.33, 0.77]
        sol = solve(prob, SRIW1(); tstops = my_tstops)
        @test 0.33 ∈ sol.t
        @test 0.77 ∈ sol.t
    end

    @testset "Callable tstops with init/solve! workflow" begin
        prob = prob_sde_linear
        my_tstops = (p, tspan) -> [0.33, 0.77]
        integrator = init(prob, EM(); dt = 1 // 2^4, tstops = my_tstops)
        solve!(integrator)
        @test 0.33 ∈ integrator.sol.t
        @test 0.77 ∈ integrator.sol.t
    end

    @testset "Callable tstops are stored in tstops_cache" begin
        prob = prob_sde_linear
        my_tstops = (p, tspan) -> [0.33]
        integrator = init(prob, EM(); dt = 1 // 2^4, tstops = my_tstops)
        # The callable should be stored in tstops_cache for reinit!
        @test integrator.opts.tstops_cache === my_tstops
    end

    @testset "Callable tstops with reinit!" begin
        f(u, p, t) = -p[1] * u
        g(u, p, t) = 0.1 * u
        prob = SDEProblem(f, g, 1.0, (0.0, 5.0), [0.5])

        # Parameter-dependent callable tstops
        my_tstops = (p, tspan) -> [p[1] * 4.0]
        integrator = init(prob, EM(); dt = 0.01, tstops = my_tstops)
        solve!(integrator)
        @test 2.0 ∈ integrator.sol.t  # 0.5 * 4.0

        # Reinit reuses the callable from tstops_cache
        reinit!(integrator)
        solve!(integrator)
        @test 2.0 ∈ integrator.sol.t  # 0.5 * 4.0 again
    end

    @testset "Callable tstops with reinit! picks up changed parameters" begin
        f(u, p, t) = -p[1] * u
        g(u, p, t) = 0.1 * u
        prob = SDEProblem(f, g, 1.0, (0.0, 5.0), [0.5])

        # tstop at p[1] * 4.0
        my_tstops = (p, tspan) -> [p[1] * 4.0]
        integrator = init(prob, EM(); dt = 0.01, tstops = my_tstops)
        solve!(integrator)
        @test 2.0 ∈ integrator.sol.t   # 0.5 * 4.0
        @test 3.0 ∉ integrator.sol.t

        # Change parameter before reinit!
        integrator.p[1] = 0.75
        reinit!(integrator)
        solve!(integrator)
        @test 3.0 ∈ integrator.sol.t   # 0.75 * 4.0
        @test 2.0 ∉ integrator.sol.t
    end

    @testset "allows_late_binding_tstops trait" begin
        @test SciMLBase.allows_late_binding_tstops(EM()) == true
        @test SciMLBase.allows_late_binding_tstops(SRIW1()) == true
        @test SciMLBase.allows_late_binding_tstops(ImplicitEM()) == true
        @test SciMLBase.allows_late_binding_tstops(LambaEM()) == true
        @test SciMLBase.allows_late_binding_tstops(EulerHeun()) == true
    end

    @testset "Callable tstops with in-place SDE" begin
        function f!(du, u, p, t)
            du[1] = -p[1] * u[1]
        end
        function g!(du, u, p, t)
            du[1] = 0.1 * u[1]
        end
        prob = SDEProblem(f!, g!, [1.0], (0.0, 5.0), [0.5])
        my_tstops = (p, tspan) -> [1.5, 3.0]
        sol = solve(prob, EM(); dt = 0.01, tstops = my_tstops)
        @test 1.5 ∈ sol.t
        @test 3.0 ∈ sol.t
    end

    @testset "Callable tstops with RODE solver" begin
        f(u, p, t, W) = 1.01u + 0.87u * W
        prob = RODEProblem(f, 1.0, (0.0, 5.0))
        my_tstops = (p, tspan) -> [2.0, 4.0]
        sol = solve(prob, RandomEM(); dt = 0.01, tstops = my_tstops)
        @test 2.0 ∈ sol.t
        @test 4.0 ∈ sol.t
    end

    @testset "Callable tstops with callbacks" begin
        # Zero drift and noise so u stays at its initial/reset value
        f(u, p, t) = 0.0
        g(u, p, t) = 0.0
        prob = SDEProblem(f, g, 1.0, (0.0, 5.0))

        # Discrete callback at t=2.0 that sets u to exactly 42.0
        condition(u, t, integrator) = t == 2.0
        affect!(integrator) = (integrator.u = 42.0)
        cb = DiscreteCallback(condition, affect!)

        my_tstops = (p, tspan) -> [2.0, 4.0]
        sol = solve(prob, EM(); dt = 0.01, tstops = my_tstops, callback = cb)
        @test 2.0 ∈ sol.t
        @test 4.0 ∈ sol.t
        # Verify callback fired: u should be 1.0 before t=2.0 and 42.0 after
        idx_before = findfirst(==(2.0), sol.t) - 1
        idx_after = findfirst(==(2.0), sol.t) + 1
        @test sol.u[idx_before] == 1.0
        @test sol.u[idx_after] == 42.0
        @test sol.u[end] == 42.0
    end

    @testset "Callable tstops with multiple solvers" begin
        f(u, p, t) = -0.5 * u
        g(u, p, t) = 0.1 * u
        prob = SDEProblem(f, g, 1.0, (0.0, 5.0))
        my_tstops = (p, tspan) -> [1.0, 3.0]
        for alg in (EM(), LambaEM(), EulerHeun())
            sol = solve(prob, alg; dt = 0.01, tstops = my_tstops)
            @test 1.0 ∈ sol.t
            @test 3.0 ∈ sol.t
        end
    end
end

using StochasticDiffEq, Random
using SDEProblemLibrary: prob_sde_lorenz
Random.seed!(100)
prob = prob_sde_lorenz

## Solve and plot
println("Plot 1")
sol1 = solve(prob, SRI(); dt = 1 / 2^(4), abstol = 10, reltol = 0)
#=
p1 = plot(sol1[:,1],sol1[:,2],sol1[:,3],title="Absolute Tolerance = 10",leg=false,
          top_margin=50px,right_margin=50px,xguide="X",yguide="Y",zguide="Z",bottom_margin=50px,
          guidefont=font(16),titlefont=font(18),tickfont=font(16))
=#

println("Plot 2")
sol2 = solve(prob, SRI(); dt = 1 / 2^(4), abstol = 1, reltol = 0)
#=
p2 = plot(sol2[:,1],sol2[:,2],sol2[:,3],title="Absolute Tolerance = 10",leg=false,
          top_margin=50px,right_margin=50px,xguide="X",yguide="Y",zguide="Z",bottom_margin=50px,
          guidefont=font(16),titlefont=font(18),tickfont=font(16))
=#

println("Plot 3")
sol3 = solve(prob, SRI(); dt = 1 / 2^(4), abstol = 1 / 10, reltol = 0)
#=
p3 = plot(sol3[:,1],sol3[:,2],sol3[:,3],title="Absolute Tolerance = 10",leg=false,
          top_margin=50px,right_margin=50px,xguide="X",yguide="Y",zguide="Z",bottom_margin=50px,
          guidefont=font(16),titlefont=font(18),tickfont=font(16))
=#

println("Plot 4")
sol4 = solve(prob, SRI(); dt = 1 / 2^(4), abstol = 1 / 100, reltol = 0)
#=
p4 = plot(sol4[:,1],sol4[:,2],sol4[:,3],title="Absolute Tolerance = 10",leg=false,
          top_margin=50px,right_margin=50px,xguide="X",yguide="Y",zguide="Z",bottom_margin=50px,
          guidefont=font(16),titlefont=font(18),tickfont=font(16))
=#

#plot(p1,p2,p3,p4,size=(1200,800),plot_title="Lorenz Attractors")
#gui()

using StochasticDiffEq, Test

@testset "ImplicitEM Newton solver time coefficient" begin
    # This test verifies that implicit SDE solvers evaluate the drift function
    # at the correct time during Newton iterations. The nlsolver.c coefficient
    # should be the Butcher tableau coefficient (in [0,1]), not coefficient*dt.
    #
    # Bug: nlsolver.c was set to theta*dt instead of theta, causing the Newton
    # method to evaluate f at t + theta*dt*dt instead of t + theta*dt.
    # This caused extrapolation errors when using time-dependent parameters
    # with interpolations that end exactly at tspan[2].
    #
    # Reference: https://github.com/SciML/ModelingToolkit.jl/issues/4143

    @testset "Verify Newton evaluates at correct time" begin
        # Test: use a function that records the time it's called at
        # and verify all times are within the expected range [0, tend]

        tend = 1.0
        recorded_times = Float64[]

        function f_recording!(du, u, p, t)
            push!(recorded_times, t)
            du[1] = -u[1]
        end

        function g!(du, u, p, t)
            du[1] = 0.1 * u[1]
        end

        u0 = [1.0]
        tspan = (0.0, tend)
        prob = SDEProblem(f_recording!, g!, u0, tspan)

        # Test ImplicitEM
        empty!(recorded_times)
        solve(prob, ImplicitEM(); dt = 0.1, adaptive = false)

        # All recorded times should be within [0, tend]
        # With the bug (c = theta*dt), times would be at t + theta*dt*dt
        # which is wrong but usually smaller than expected
        # With the fix (c = theta), times should be at t + theta*dt
        @test all(0.0 .<= recorded_times .<= tend + 10 * eps(tend))
        @test maximum(recorded_times) <= tend + 10 * eps(tend)

        # The maximum recorded time should be close to tend
        # With the bug, the Newton method would evaluate at t + dt*dt instead of t + dt
        # So for a step from t=0.9 to t=1.0, the bug gives 0.9 + 0.01 = 0.91,
        # while correct gives 0.9 + 0.1 = 1.0
        @test maximum(recorded_times) >= tend - 0.15  # Should reach close to tend

        # Test ImplicitEulerHeun
        empty!(recorded_times)
        solve(prob, ImplicitEulerHeun(); dt = 0.1, adaptive = false)
        @test all(0.0 .<= recorded_times .<= tend + 10 * eps(tend))

        # Test ImplicitRKMil
        empty!(recorded_times)
        solve(prob, ImplicitRKMil(); dt = 0.1, adaptive = false)
        @test all(0.0 .<= recorded_times .<= tend + 10 * eps(tend))
    end

    @testset "Test with adaptive stepping" begin
        # Test that adaptive stepping also works correctly
        recorded_times = Float64[]

        function f_recording!(du, u, p, t)
            push!(recorded_times, t)
            du[1] = -u[1]
        end

        function g!(du, u, p, t)
            du[1] = 0.1 * u[1]
        end

        u0 = [1.0]
        tspan = (0.0, 1.0)
        prob = SDEProblem(f_recording!, g!, u0, tspan)

        empty!(recorded_times)
        solve(prob, ImplicitEM())

        # All recorded times should be within [0, tend]
        @test all(0.0 .<= recorded_times .<= 1.0 + 10 * eps(1.0))
    end

    @testset "Test ISSEM methods" begin
        # Test split-step methods as well
        recorded_times = Float64[]

        function f_recording!(du, u, p, t)
            push!(recorded_times, t)
            du[1] = -u[1]
        end

        function g!(du, u, p, t)
            du[1] = 0.1 * u[1]
        end

        u0 = [1.0]
        tspan = (0.0, 1.0)
        prob = SDEProblem(f_recording!, g!, u0, tspan)

        # Test ISSEM
        empty!(recorded_times)
        solve(prob, ISSEM(); dt = 0.1, adaptive = false)
        @test all(0.0 .<= recorded_times .<= 1.0 + 10 * eps(1.0))

        # Test ISSEulerHeun
        empty!(recorded_times)
        solve(prob, ISSEulerHeun(); dt = 0.1, adaptive = false)
        @test all(0.0 .<= recorded_times .<= 1.0 + 10 * eps(1.0))
    end

    @testset "Out-of-place methods" begin
        # Test out-of-place versions
        recorded_times = Float64[]

        function f_recording(u, p, t)
            push!(recorded_times, t)
            return -u
        end

        function g(u, p, t)
            return 0.1 * u
        end

        u0 = [1.0]
        tspan = (0.0, 1.0)
        prob = SDEProblem(f_recording, g, u0, tspan)

        # Test ImplicitEM out-of-place
        empty!(recorded_times)
        solve(prob, ImplicitEM(); dt = 0.1, adaptive = false)
        @test all(0.0 .<= recorded_times .<= 1.0 + 10 * eps(1.0))
    end
end

using StochasticDiffEq, DiffEqDevTools, Test, LinearAlgebra, Random

Random.seed!(100)
const σ_const = 0.87
const μ = 1.01

u0 = rand(2)
A = [-2.0 1.0; 1.0 -2.0]
B = Diagonal([σ_const for i in 1:2])

function f_nondiag(u, p, t)
    return A * u + 1.01 * u
end

function f_nondiag_iip(du, u, p, t)
    mul!(du, A, u)
    return du .+= 1.01u
end

function f_analytic_nondiag(u0, p, t, W)
    tmp = (A + 1.01I - (B^2)) * t + B * sum(W)
    return exp(tmp) * u0
end

function g_nondiag(u, p, t)
    du = zeros(2, 2)
    du[1, 1] = σ_const * u[1]
    du[1, 2] = σ_const * u[1]
    du[2, 1] = σ_const * u[2]
    du[2, 2] = σ_const * u[2]
    return du
end

function g_nondiag_iip(du, u, p, t)
    du[1, 1] = σ_const * u[1]
    du[1, 2] = σ_const * u[1]
    du[2, 1] = σ_const * u[2]
    return du[2, 2] = σ_const * u[2]
end

coeff = 2 * σ_const^2 #To not compute the same coefficient in the sde.
function ggprime(u, p, t)
    return coeff * u
end

function ggprime(du, u, p, t)
    return du .= coeff * u
end

prob = SDEProblem(
    SDEFunction(f_nondiag, g_nondiag, analytic = f_analytic_nondiag),
    u0, (0.0, 1.0), noise_rate_prototype = zeros(2, 2)
)
probiip = SDEProblem(
    SDEFunction(f_nondiag_iip, g_nondiag_iip, analytic = f_analytic_nondiag),
    u0, (0.0, 1.0), noise_rate_prototype = zeros(2, 2)
)

## Just solve to test compatibility
IEM = solve(probiip, ImplicitEM())
IEM = solve(probiip, ImplicitEulerHeun())
IEM = solve(probiip, ISSEM())
IEM = solve(probiip, ISSEulerHeun())

## use BenchmarkTools to benchmark speed here if desired.
dt = 0.002
seed = 1
# solEMiip = solve(probiip, EM(), dt=dt, seed=seed)
# solRKMil = solve(probiip, RKMilCommute(), dt=dt, seed=seed)
solPCEuler = solve(prob, PCEuler(ggprime), dt = dt, seed = seed)
solPCEuleriip = solve(probiip, PCEuler(ggprime), dt = dt, seed = seed)

@test solPCEuler.u ≈ solPCEuleriip.u atol = 1.0e-10

## plot to see performance of PCEuler
# first_elem(x) = x[1]
# using PyPlot
# figure()
# plot(solEMiip.t, first_elem.(solEMiip.u_analytic), label="True", "--")
# plot(solEMiip.t, first_elem.(solEMiip.u), label="EM")
# plot(solRKMil.t, first_elem.(solRKMil.u), label="RKMil")
# plot(solPCEuleriip.t, first_elem.(solPCEuleriip.u), label="PC")
# legend()

##
dts = (1 / 2) .^ (10:-1:5) #14->7 good plot
trajectories = 50
simEM = test_convergence(dts, probiip, EM(), trajectories = trajectories)
simPCEuler = test_convergence(dts, probiip, PCEuler(ggprime), trajectories = trajectories)
#simRKMil = test_convergence(dts,probiip,RKMilCommute(),trajectories=trajectories)
@test all(simPCEuler.errors[:l2] .< simEM.errors[:l2])

## Plotting script to see the order 1 scaling of PCEuler
# figure()
# loglog(dts, simEM.errors[:l2], label="EM")
# loglog(dts, simRKMil.errors[:l2], label="RKMil")
# loglog(dts, simPCEuler.errors[:l2], label="PC")
# ylabel("l2 error")
# xlabel("dt")
# legend()

f_morenoise = (du, u, p, t) -> du .= 1.01u
g_morenoise = function (du, u, p, t)
    du[1, 1] = 0.3u[1]
    du[1, 2] = 0.6u[1]
    du[1, 3] = 0.9u[1]
    du[1, 4] = 0.12u[2]
    du[2, 1] = 1.2u[1]
    du[2, 2] = 0.2u[2]
    du[2, 3] = 0.3u[2]
    return du[2, 4] = 1.8u[2]
end
prob = SDEProblem(
    f_morenoise, g_morenoise, ones(2), (0.0, 1.0),
    noise_rate_prototype = zeros(2, 4)
)

sol = solve(prob, dt = 1 / 2^(3), EM())
sol = solve(prob, dt = 1 / 2^(3), SRA())
sol = solve(prob, dt = 1 / 2^(3), ISSEM())
sol = solve(prob, dt = 1 / 2^(3), ImplicitEM())
sol = solve(prob, dt = 1 / 2^(3), EulerHeun())
sol = solve(prob, dt = 1 / 2^(3), ImplicitEulerHeun())
sol = solve(prob, dt = 1 / 2^(3), ISSEulerHeun())

f(du, u, p, t) = du .= u
function g(du, u, p, t)
    return du .= [-0.8 -0.3; -0.8 0.3]
end

u0 = ones(2)
dt = 1 // 2^(4)
tspan = (0.0, 1.0)

prototype = zeros(2, 2)

iip_prob = SDEProblem{true}(f, g, u0, tspan, noise_rate_prototype = prototype)
@test !(solve(iip_prob, EM(), dt = 0.1).u[end] ≈ ones(2))
@test !(solve(iip_prob, SOSRA()).u[end] ≈ ones(2))
@test !(solve(iip_prob, SRA3()).u[end] ≈ ones(2))

# Out of place regression tests

f(u, p, t) = u
function g(u, p, t)
    return [-0.8 -0.3; -0.8 0.3]
end

u0 = ones(2)
dt = 1 // 2^(4)
tspan = (0.0, 1.0)

prototype = zeros(2, 2)

oop_prob = SDEProblem{false}(f, g, u0, tspan, noise_rate_prototype = prototype)
oop_sol = solve(oop_prob, EM(), dt = dt)
oop_sol = solve(oop_prob, SOSRA())
sol = solve(oop_prob, dt = 1 / 2^(3), EM())
sol = solve(oop_prob, dt = 1 / 2^(3), ISSEM())
@test_broken sol = solve(oop_prob, dt = 1 / 2^(3), ImplicitEM())
sol = solve(oop_prob, dt = 1 / 2^(3), EulerHeun())
@test_broken sol = solve(oop_prob, dt = 1 / 2^(3), ImplicitEulerHeun())
sol = solve(oop_prob, dt = 1 / 2^(3), ISSEulerHeun())

module StochasticDiffEq

using Reexport
@reexport using DiffEqBase

using Reexport: @reexport

@reexport using StochasticDiffEqCore
@reexport using StochasticDiffEqLowOrder
@reexport using StochasticDiffEqRODE
@reexport using StochasticDiffEqHighOrder
@reexport using StochasticDiffEqMilstein
@reexport using StochasticDiffEqROCK
@reexport using StochasticDiffEqImplicit
@reexport using StochasticDiffEqWeak
@reexport using StochasticDiffEqIIF
@reexport using StochasticDiffEqLeaping
@reexport using DiffEqNoiseProcess
using OrdinaryDiffEqNonlinearSolve: NLNewton, NLAnderson, NLFunctional, NonlinearSolveAlg

import SciMLBase
import OrdinaryDiffEqCore: perform_step!, loopheader!, loopfooter!

# AutoSOSRI2/AutoSOSRA2 reference concrete types from multiple solver subpackages
# (SOSRI2 from HighOrder, implicit algs from Implicit), so they live here in the umbrella.
AutoSOSRI2(alg; kwargs...) = AutoAlgSwitch(SOSRI2(), alg; kwargs...)
AutoSOSRA2(alg; kwargs...) = AutoAlgSwitch(SOSRA2(), alg; kwargs...)

include("default_sde_alg.jl")

export AutoSOSRI2, AutoSOSRA2
export NLNewton, NLAnderson, NLFunctional, NonlinearSolveAlg

# Re-export general functions
export solve, init, solve!, step!

# Misc Tools (tableau constructors from HighOrder)
export checkSRIOrder, checkSRAOrder, checkRIOrder, checkRSOrder,
    checkNONOrder,
    constructSRIW1, constructSRA1,
    constructDRI1, constructRI1, constructRI3, constructRI5, constructRI6,
    constructRDI1WM, constructRDI2WM, constructRDI3WM, constructRDI4WM,
    constructRS1, constructRS2,
    constructNON, constructNON2

end # module

using StochasticDiffEq, Test, Random
using SDEProblemLibrary: prob_sde_linear
Random.seed!(100)
prob = prob_sde_linear

integrator = init(prob, EM(), dt = 1 // 2^(4), tstops = [0.33])

for (u, t) in tuples(integrator)
    @show u, t
end

sol = solve(prob, EM(), dt = 1 // 2^(4), tstops = [0.33])

@test 0.33 ∈ sol.t

sol = solve(prob, EM(), tstops = [0.33, 0.8, 1.0])

@test sol.t == [0.0, 0.33, 0.8, 1.0]

sol = solve(prob, SRIW1(), tstops = [0.33])

@test 0.33 ∈ sol.t

# check reverse time and negative start times
for (i, tdir) in enumerate([-1.0; 1.0])
    @info i
    prob2 = remake(prob_sde_linear, tspan = (tdir * 1.0, 0.0))
    integrator = init(prob2, SRIW1())
    tstops = tdir .* [0, 0.33, 0.8, 1]
    for tstop in tstops
        add_tstop!(integrator, tstop)
    end
    solve!(integrator)
    for tstop in tstops
        @test tstop ∈ integrator.sol.t
    end
end

using StochasticDiffEq, Test, Random
import SDEProblemLibrary: prob_sde_linear, prob_sde_2Dlinear
Random.seed!(100)

vecarrzero(m::Integer, n) = map(t -> zeros(n), 1:m)

tt = 0:0.05:1
ntt = length(tt)
out_VF = zeros(ntt)                                     # Vector{Float64}
out_VVF_1 = vecarrzero(ntt, 1)                           # Vector{Vector{Float64}}
out_VVF_2 = vecarrzero(ntt, 2)                           # Vector{Vector{Float64}}
out_VMF = vecarrzero(ntt, size(prob_sde_2Dlinear.u0))   # Vector{Matrix{Float64}}

@testset verbose = true "SDESolution interpolation" begin
    sol_SDE = solve(prob_sde_linear, SRIW1(); dt = 1 // 2^4)
    sol_SDE_2D = solve(prob_sde_2Dlinear, SRIW1(); dt = 1 // 2^4)

    sol_SDE_interp = sol_SDE(tt)
    sol_SDE_2D_interp = sol_SDE_2D(tt)

    @testset "1D" begin
        @test_throws MethodError sol_SDE(out_VF, tt; idxs = 1:1)
        @test sol_SDE(out_VF, tt) isa Vector{Float64}
        @test sol_SDE(out_VVF_1, tt) isa Vector{Vector{Float64}}
        @test sol_SDE_interp.u ≈ out_VF
    end

    @testset "2D" begin
        @test_throws MethodError sol_SDE_2D(out_VF, tt; idxs = 3:3)
        @test sol_SDE_2D(out_VF, tt; idxs = 3) isa Vector{Float64}
        @test sol_SDE_2D(out_VVF_1, tt; idxs = 3) isa Vector{Vector{Float64}}
        @test sol_SDE_2D(out_VVF_1, tt; idxs = 3:3) isa Vector{Vector{Float64}}
        @test sol_SDE_2D(out_VVF_2, tt; idxs = 2:3) isa Vector{Vector{Float64}}
        @test sol_SDE_2D(out_VMF, tt) isa Vector{Matrix{Float64}}
        @test sol_SDE_2D_interp.u ≈ out_VMF
    end
end

using StochasticDiffEq, DiffEqDevTools, Test
using Random

f_linear_iip(du, u, p, t) = @.(du = 1.01 * u)
σ_linear_iip(du, u, p, t) = @.(du = 0.87 * u)

linear_analytic(u0, p, t, W) = @.(u0 * exp(0.63155t + 0.87W))

prob_sde_linear_iip = SDEProblem(
    SDEFunction(
        f_linear_iip, σ_linear_iip,
        analytic = linear_analytic
    ), [1 / 2], (0.0, 1.0)
)

Random.seed!(100)
dts = 1 .// 2 .^ (7:-1:3) #14->7 good plot

prob = prob_sde_linear_iip
println("EM")
sim = test_convergence(
    dts, prob, EM(), save_everystep = false, trajectories = Int(1.0e4),
    weak_timeseries_errors = false
)
@test abs(sim.𝒪est[:weak_final] - 1) < 0.45
#@test abs(sim.𝒪est[:weak_l2]-1) < 0.3
#@test abs(sim.𝒪est[:weak_l∞]-1) < 0.3
println("SimplifiedEM")
sim = test_convergence(
    dts, prob, SimplifiedEM(), save_everystep = false, trajectories = Int(5.0e5),
    weak_timeseries_errors = false
)
@test abs(sim.𝒪est[:weak_final] - 1) < 0.45
#@test abs(sim.𝒪est[:weak_l2]-1) < 0.3
#@test abs(sim.𝒪est[:weak_l∞]-1) < 0.35
println("RKMil")
sim = test_convergence(
    dts, prob, RKMil(), save_everystep = false, trajectories = Int(1.0e4),
    weak_timeseries_errors = false
)
@test abs(sim.𝒪est[:weak_final] - 1) < 0.45
#@test abs(sim.𝒪est[:weak_l2]-1) < 0.3
#@test abs(sim.𝒪est[:weak_l∞]-1) < 0.3
println("RKMilCommute")
sim = test_convergence(
    dts, prob, RKMilCommute(), save_everystep = false, trajectories = Int(1.0e4),
    weak_timeseries_errors = false
)
@test abs(sim.𝒪est[:weak_final] - 1) < 0.45
#@test abs(sim.𝒪est[:weak_l2]-1) < 0.3
#@test abs(sim.𝒪est[:weak_l∞]-1) < 0.3
println("RKMilGeneral")
sim = test_convergence(
    dts, prob, RKMilGeneral(), save_everystep = false, trajectories = Int(1.0e4),
    weak_timeseries_errors = false
)
@test abs(sim.𝒪est[:weak_final] - 1) < 0.45
#@test abs(sim.𝒪est[:weak_l2]-1) < 0.3
#@test abs(sim.𝒪est[:weak_l∞]-1) < 0.3
println("SROCK1")
sim = test_convergence(
    dts, prob, SROCK1(), save_everystep = false, trajectories = Int(4.0e4),
    weak_timeseries_errors = false
)
@test abs(sim.𝒪est[:weak_final] - 1) < 0.45
#@test abs(sim.𝒪est[:weak_l2]-1) < 0.3
#@test abs(sim.𝒪est[:weak_l∞]-1) < 0.3
println("SROCK2")
dts = 1 .// 2 .^ (8:-1:1) #14->7 good plot
sim = test_convergence(
    dts, prob, SROCK2(), save_everystep = false, trajectories = Int(5.0e5),
    weak_timeseries_errors = false
)
@show sim.𝒪est[:weak_final]
@test abs(sim.𝒪est[:weak_final] - 2) < 0.5
#@test abs(sim.𝒪est[:weak_l2]-2) < 0.3
#@test abs(sim.𝒪est[:weak_l∞]-2) < 0.3
dts = 1 .// 2 .^ (7:-1:2) #14->7 good plot
println("SROCKEM")
sim = test_convergence(
    dts, prob, SROCKEM(strong_order_1 = false),
    save_everystep = false, trajectories = Int(1.0e4),
    weak_timeseries_errors = false
)
@test abs(sim.𝒪est[:weak_final] - 1) < 0.45
#@test abs(sim.𝒪est[:weak_l2]-1) < 0.3
#@test abs(sim.𝒪est[:weak_l∞]-1) < 0.3
println("SROCKEM")
sim = test_convergence(
    dts, prob, SROCKEM(), save_everystep = false, trajectories = Int(1.0e4),
    weak_timeseries_errors = false
)
@test abs(sim.𝒪est[:weak_final] - 1) < 0.45
#@test abs(sim.𝒪est[:weak_l2]-1) < 0.3
#@test abs(sim.𝒪est[:weak_l∞]-1) < 0.3
println("SKSROCK")
sim = test_convergence(
    dts, prob, SKSROCK(), save_everystep = false, trajectories = Int(5.0e4),
    weak_timeseries_errors = false
)
@test abs(sim.𝒪est[:weak_final] - 1) < 0.45
#@test abs(sim.𝒪est[:weak_l2]-1) < 0.3
#@test abs(sim.𝒪est[:weak_l∞]-1) < 0.3

#omitting tests for incomplete methods
# sim = test_convergence(dts,prob,TangXiaoSROCK2(version_num=1),save_everystep=false,trajectories=Int(4e4),
#                           weak_timeseries_errors=false)
# @test abs(sim.𝒪est[:weak_final]-2) < 0.3
# #@test abs(sim.𝒪est[:weak_l2]-2) < 0.3
# #@test abs(sim.𝒪est[:weak_l∞]-2) < 0.3
# sim = test_convergence(dts,prob,TangXiaoSROCK2(version_num=2),save_everystep=false,trajectories=Int(4e4),
#                           weak_timeseries_errors=false)
# @test abs(sim.𝒪est[:weak_final]-2) < 0.3
# #@test abs(sim.𝒪est[:weak_l2]-2) < 0.3
# #@test abs(sim.𝒪est[:weak_l∞]-2) < 0.3
# sim = test_convergence(dts,prob,TangXiaoSROCK2(version_num=3),save_everystep=false,trajectories=Int(4e4),
#                           weak_timeseries_errors=false)
# @test abs(sim.𝒪est[:weak_final]-2) < 0.3
# #@test abs(sim.𝒪est[:weak_l2]-2) < 0.3
# #@test abs(sim.𝒪est[:weak_l∞]-2) < 0.3
# sim = test_convergence(dts,prob,TangXiaoSROCK2(version_num=4),save_everystep=false,trajectories=Int(4e4),
#                           weak_timeseries_errors=false)
# @test abs(sim.𝒪est[:weak_final]-2) < 0.3
# #@test abs(sim.𝒪est[:weak_l2]-2) < 0.3
# #@test abs(sim.𝒪est[:weak_l∞]-2) < 0.3
# sim = test_convergence(dts,prob,TangXiaoSROCK2(version_num=5),save_everystep=false,trajectories=Int(4e4),
#                           weak_timeseries_errors=false)
# @test abs(sim.𝒪est[:weak_final]-2) < 0.3
# #@test abs(sim.𝒪est[:weak_l2]-2) < 0.3
# #@test abs(sim.𝒪est[:weak_l∞]-2) < 0.3

println("WangLi3SMil_A")
sim = test_convergence(
    dts, prob, WangLi3SMil_A(), save_everystep = false, trajectories = Int(1.0e4),
    weak_timeseries_errors = false
)
@test abs(sim.𝒪est[:weak_final] - 1) < 0.45
#@test abs(sim.𝒪est[:weak_l2]-1) < 0.3
#@test abs(sim.𝒪est[:weak_l∞]-1) < 0.3
println("WangLi3SMil_B")
sim = test_convergence(
    dts, prob, WangLi3SMil_B(), save_everystep = false, trajectories = Int(1.0e4),
    weak_timeseries_errors = false
)
@test abs(sim.𝒪est[:weak_final] - 1) < 0.45
#@test abs(sim.𝒪est[:weak_l2]-1) < 0.3
#@test abs(sim.𝒪est[:weak_l∞]-1) < 0.3
println("WangLi3SMil_C")
sim = test_convergence(
    dts, prob, WangLi3SMil_C(), save_everystep = false, trajectories = Int(1.0e4),
    weak_timeseries_errors = false
)
@test abs(sim.𝒪est[:weak_final] - 1) < 0.45
#@test abs(sim.𝒪est[:weak_l2]-1) < 0.3
#@test abs(sim.𝒪est[:weak_l∞]-1) < 0.3
println("WangLi3SMil_D")
sim = test_convergence(
    dts, prob, WangLi3SMil_D(), save_everystep = false, trajectories = Int(1.0e4),
    weak_timeseries_errors = false
)
@test abs(sim.𝒪est[:weak_final] - 1) < 0.45
#@test abs(sim.𝒪est[:weak_l2]-1) < 0.3
#@test abs(sim.𝒪est[:weak_l∞]-1) < 0.3
println("WangLi3SMil_E")
sim = test_convergence(
    dts, prob, WangLi3SMil_E(), save_everystep = false, trajectories = Int(1.0e4),
    weak_timeseries_errors = false
)
@test abs(sim.𝒪est[:weak_final] - 1) < 0.45
#@test abs(sim.𝒪est[:weak_l2]-1) < 0.3
#@test abs(sim.𝒪est[:weak_l∞]-1) < 0.3
println("WangLi3SMil_F")
sim = test_convergence(
    dts, prob, WangLi3SMil_F(), save_everystep = false, trajectories = Int(1.0e4),
    weak_timeseries_errors = false
)
@test abs(sim.𝒪est[:weak_final] - 1) < 0.45
#@test abs(sim.𝒪est[:weak_l2]-1) < 0.3
#@test abs(sim.𝒪est[:weak_l∞]-1) < 0.3
println("SRI")
dts = 1 .// 2 .^ (8:-1:2)
sim = test_convergence(
    dts, prob, SRI(), save_everystep = false, trajectories = Int(2.0e4),
    weak_timeseries_errors = false
)
@test abs(sim.𝒪est[:weak_final] - 2) < 0.5
#@test abs(sim.𝒪est[:weak_l2]-2) < 0.3
#@test abs(sim.𝒪est[:weak_l∞]-2) < 0.3
println("SRIW1")
sim = test_convergence(
    dts, prob, SRIW1(), save_everystep = false, trajectories = Int(1.0e5),
    weak_timeseries_errors = false
)
@test abs(sim.𝒪est[:weak_final] - 2) < 0.45
#@test abs(sim.𝒪est[:weak_l2]-2) < 0.3
#@test abs(sim.𝒪est[:weak_l∞]-2) < 0.3

using Test
using StochasticDiffEq
using SparseArrays
using LinearAlgebra

function f(dx, x, p, t)
    for i in 2:(length(x) - 1)
        dx[i] = x[i - 1] - 2x[i] + x[i + 1]
    end
    dx[1] = -2x[1] + x[2]
    dx[end] = x[end - 1] - 2x[end]
    return nothing
end

function g(dx, x, p, t)
    dx .= 0
    return nothing
end

function second_derivative_stencil(N)
    A = zeros(N, N)
    for i in 1:N, j in 1:N

        (j - i == -1 || j - i == 1) && (A[i, j] = 1)
        j - i == 0 && (A[i, j] = -2)
    end
    return A
end

function generate_sparsity_pattern(N::Integer)
    dl = repeat([1.0], N - 1)
    du = repeat([1.0], N - 1)
    d = repeat([-2.0], N)
    return Tridiagonal(dl, d, du)
end

jac_sp = sparse(generate_sparsity_pattern(10))
#jac = second_derivative_stencil(10)
colorvec = repeat(1:3, 10)[1:10]
u0 = [1.0, 2.0, 3, 4, 5, 5, 4, 3, 2, 1]
tspan = (0.0, 10.0)
sdefun_sp = SDEFunction(f, g, colorvec = colorvec, jac_prototype = jac_sp)
prob_sp = SDEProblem(sdefun_sp, u0, tspan)
prob_std = SDEProblem(f, g, u0, tspan)

sol_sp = solve(prob_sp, SKenCarp(autodiff = false))
@test sol_sp.retcode == ReturnCode.Success #test sparse finitediff
sol = solve(prob_std, SKenCarp(autodiff = false))
@test sol_sp.u[end] ≈ sol.u[end] atol = 1.0e-4
@test length(sol_sp.t) == length(sol.t)

sol_sp = solve(prob_sp, SKenCarp())
sol = solve(prob_std, SKenCarp())
@test sol_sp.u[end] ≈ sol.u[end] atol = 1.0e-4
@test length(sol_sp.t) == length(sol.t)

#sol_sp=solve(prob_sp,SKenCarp(autodiff=false),abstol=1e-10,reltol=1e-10)
#sol=solve(prob_std,SKenCarp(autodiff=false),abstol=1e-10,reltol=1e-10)
#@test sol_sp.u[end]≈sol.u[end]
#@test length(sol_sp.t)==length(sol.t)

using StochasticDiffEq, DiffEqNoiseProcess, Test, Random
using SDEProblemLibrary
# automatically construct SDE transformation for Ito reversal
using ModelingToolkit
import SciMLBase

# tested solvers
additive_noise_solver = [
    SRA(),
    SRA1(),
    SRA2(),
    SRA3(),
    SOSRA(),
    SOSRA2(),
    SKenCarp(),
]

Stratonovich_solver = [
    # non-stiff methods
    EulerHeun(),
    LambaEulerHeun(),
    RKMil(interpretation = SciMLBase.AlgorithmInterpretation.Stratonovich),
    RKMilCommute(interpretation = SciMLBase.AlgorithmInterpretation.Stratonovich),
    RKMilGeneral(interpretation = SciMLBase.AlgorithmInterpretation.Stratonovich),
    # S-Rock methods
    SROCK1(interpretation = SciMLBase.AlgorithmInterpretation.Stratonovich),
    # stiff methods
    ImplicitEulerHeun(),
    ImplicitRKMil(interpretation = SciMLBase.AlgorithmInterpretation.Stratonovich),
    ISSEulerHeun(),
]

Ito_solver = [
    # non-stiff methods
    EM(),
    LambaEM(),
    WangLi3SMil_A(),
    WangLi3SMil_B(),
    WangLi3SMil_C(),
    WangLi3SMil_D(),
    WangLi3SMil_E(),
    WangLi3SMil_F(),
    RKMil(),
    SRI(),
    SRIW1(),
    SRIW2(),
    SOSRI(),
    SOSRI2(),
    # S-Rock methods
    SROCK1(),
    SROCKEM(),
    SROCK2(),
    SKSROCK(),
    TangXiaoSROCK2(),
    # stiff methods
    ImplicitEM(),
    ImplicitRKMil(),
    ISSEM(),
]

seed = 62356236796
Random.seed!(seed)

dt = 1.0e-6
n = round(Int, 1 / dt) # number of steps, probs have time span (0,1)
W = [0.0; cumsum(sqrt(dt) * randn(n + 1))] # n + 1 to avoid past step in noise grid
Z = [0.0; cumsum(sqrt(dt) * randn(n + 1))]
ts = collect(0:dt:(1 + dt))

W_forward = NoiseGrid(ts, W, Z)
W_reverse = reverse(W_forward)

@testset "Additive Noise Solver Reversal Tests ($(["out-of-place", "in-place"][i]))" for i in
    1:2

    prob = (
        SDEProblemLibrary.prob_sde_additive,
        SDEProblemLibrary.prob_sde_additivesystem,
    )[i]

    prob_forward = remake(prob, noise = W_forward)

    for solver in additive_noise_solver
        println("solver: ", solver)
        sol_forward = solve(prob_forward, solver, dt = dt, adaptive = false)

        prob_reverse = remake(
            prob_forward, noise = W_reverse, tspan = reverse(prob.tspan), u0 = sol_forward.u[end]
        )
        sol_reverse = solve(prob_reverse, solver, dt = dt, adaptive = false)

        @test sol_forward(ts).u ≈ sol_reverse(ts).u rtol = 1.0e-3
        @test length(sol_forward.t) == length(sol_reverse.t)
        GC.gc()
    end
end

@testset "Stratonovich Solver Reversal Tests ($(["out-of-place", "in-place"][i]))" for i in
    1:2

    prob = (
        SDEProblemLibrary.prob_sde_linear_stratonovich,
        SDEProblemLibrary.prob_sde_2Dlinear_stratonovich,
    )[i]

    prob_forward = remake(prob, noise = W_forward)

    for solver in Stratonovich_solver
        println("solver: ", solver)
        sol_forward = solve(prob_forward, solver, dt = dt, adaptive = false)

        prob_reverse = remake(
            prob_forward, noise = W_reverse, tspan = reverse(prob.tspan), u0 = sol_forward.u[end]
        )
        sol_reverse = solve(prob_reverse, solver, dt = dt, adaptive = false)

        @test sol_forward(ts).u ≈ sol_reverse(ts).u rtol = 1.0e-2
        @test length(sol_forward.t) == length(sol_reverse.t)
        GC.gc()
    end
end

@testset "Ito Solver Reversal Tests ($(["out-of-place", "in-place"][i]))" for i in 1:2
    prob = (
        SDEProblemLibrary.prob_sde_linear,
        SDEProblemLibrary.prob_sde_2Dlinear,
    )[i]
    if i == 1
        prob_forward = remake(prob, noise = W_forward)
    else
        prob_forward = remake(prob, noise = W_forward, u0 = vec(prob.u0))
    end
    sys = complete(modelingtoolkitize(prob_forward))
    mtkps = MTKParameters(sys, [])
    sys2 = stochastic_integral_transform(sys, -1 // 1)
    fdrift = generate_rhs(sys2; expression = Val{false})[i]
    fdif = generate_diffusion_function(sys2; expression = Val{false})[i]

    for solver in Ito_solver
        println("solver: ", solver)
        sol_forward = solve(prob_forward, solver, dt = dt, adaptive = false)
        if i == 1
            _u0 = [sol_forward.u[end]]
        else
            _u0 = sol_forward.u[end]
        end
        prob_reverse = remake(
            prob_forward, f = SDEFunction(fdrift, fdif), noise = W_reverse,
            tspan = reverse(prob.tspan), u0 = _u0, p = mtkps
        )
        sol_reverse = solve(prob_reverse, solver, dt = dt, adaptive = false)

        if i == 1
            @test sol_forward(ts).u ≈ vcat(sol_reverse(ts).u...) rtol = 1.0e-2
        else
            @test sol_forward(ts).u ≈ sol_reverse(ts).u rtol = 1.0e-2
        end
        @test length(sol_forward.t) == length(sol_reverse.t)
        GC.gc()
    end
end
